/* arc.c generated by valac 0.17.2, the Vala compiler
 * generated from arc.vala, do not modify */

/*  Mutiara motif designer.
Copyright (C) 2011  Nor Jaidi Tuah

This file is part of Mutiara.

Mutiara is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <cairo.h>


#define TYPE_SEED (seed_get_type ())
#define SEED(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SEED, Seed))
#define SEED_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SEED, SeedClass))
#define IS_SEED(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SEED))
#define IS_SEED_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SEED))
#define SEED_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SEED, SeedClass))

typedef struct _Seed Seed;
typedef struct _SeedClass SeedClass;
typedef struct _SeedPrivate SeedPrivate;

#define TYPE_POINT (point_get_type ())
typedef struct _Point Point;

#define TYPE_ROLE (role_get_type ())

#define TYPE_FLIP (flip_get_type ())

#define TYPE_TWEAK (tweak_get_type ())
typedef struct _Tweak Tweak;

#define TYPE_RGBA (rgba_get_type ())
typedef struct _RGBA RGBA;

#define TYPE_RENDER_STYLE (render_style_get_type ())

#define TYPE_PROJECTION (projection_get_type ())
#define PROJECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PROJECTION, Projection))
#define PROJECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PROJECTION, ProjectionClass))
#define IS_PROJECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PROJECTION))
#define IS_PROJECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PROJECTION))
#define PROJECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PROJECTION, ProjectionClass))

typedef struct _Projection Projection;
typedef struct _ProjectionClass ProjectionClass;

#define TYPE_ARC (arc_get_type ())
#define ARC(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ARC, Arc))
#define ARC_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ARC, ArcClass))
#define IS_ARC(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ARC))
#define IS_ARC_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ARC))
#define ARC_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ARC, ArcClass))

typedef struct _Arc Arc;
typedef struct _ArcClass ArcClass;
typedef struct _ArcPrivate ArcPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Point {
	gdouble x;
	gdouble y;
};

typedef enum  {
	ROLE_DUAL = 0,
	ROLE_MOTIF = 1,
	ROLE_BASE = 2
} Role;

typedef enum  {
	FLIP_NONE = 0,
	FLIP_Y = 1,
	FLIP_X = 2,
	FLIP_XY = 3
} Flip;

struct _Tweak {
	gdouble scale_x;
	gdouble scale_y;
	gdouble rotate;
	gdouble move_x;
	gdouble move_y;
};

struct _RGBA {
	gdouble r;
	gdouble g;
	gdouble b;
	gdouble a;
};

typedef enum  {
	RENDER_STYLE_THIN = 0,
	RENDER_STYLE_THICK = 1,
	RENDER_STYLE_HOLLOW = 2,
	RENDER_STYLE_FILLED = 3,
	RENDER_STYLE_CLOSED = 4,
	RENDER_STYLE_NONE = 5
} RenderStyle;

struct _Seed {
	GObject parent_instance;
	SeedPrivate * priv;
	gboolean debug;
	Role role;
	gdouble base_offset;
	Flip flip_even;
	Flip flip_odd;
	Tweak tweak;
	gdouble width0;
	gdouble width1;
	gint num_segment;
	gint level_of_detail;
	RGBA color;
	gdouble color_mix;
	RenderStyle render_style;
	gdouble* distance_to_param;
	gint distance_to_param_length1;
	Projection** projection;
	gint projection_length1;
	gint selected_control;
	Point pressed_point;
};

struct _SeedClass {
	GObjectClass parent_class;
	void (*init_default_sub) (Seed* self, Point* p);
	void (*init_full_sub) (Seed* self, gdouble* args, int args_length1);
	gchar* (*serialize_sub) (Seed* self);
	void (*point_raw) (Seed* self, gdouble t, Point* result);
	void (*init_distance_to_parametric) (Seed* self);
	gdouble (*perpendicular_angle) (Seed* self, gdouble t);
	void (*draw_direct) (Seed* self, cairo_t* cr, gdouble scale);
	void (*draw_controls) (Seed* self, cairo_t* cr, gdouble scale);
	gint (*pressed_control) (Seed* self, Point* p, gdouble scale);
	void (*save_drag_context) (Seed* self);
	void (*move_shape) (Seed* self, gdouble delta_x, gdouble delta_y);
	void (*drag_control) (Seed* self, Point* p, gdouble scale, gboolean snap_on, gdouble grid_size, gdouble snap_angle);
	Point* (*points_to_snap) (Seed* self, int* result_length1);
	void (*draw_icon) (Seed* self, cairo_t* cr, gdouble width, gdouble height);
};

struct _Arc {
	Seed parent_instance;
	ArcPrivate * priv;
};

struct _ArcClass {
	SeedClass parent_class;
};

struct _ArcPrivate {
	Point centre;
	gdouble angle0;
	gdouble angle1;
	gdouble radius_x;
	gdouble radius_y;
	gdouble rotation;
	Point centre_save;
	Point topleft_save;
};


static gpointer arc_parent_class = NULL;

GType seed_get_type (void) G_GNUC_CONST;
GType point_get_type (void) G_GNUC_CONST;
Point* point_dup (const Point* self);
void point_free (Point* self);
GType role_get_type (void) G_GNUC_CONST;
GType flip_get_type (void) G_GNUC_CONST;
GType tweak_get_type (void) G_GNUC_CONST;
Tweak* tweak_dup (const Tweak* self);
void tweak_free (Tweak* self);
GType rgba_get_type (void) G_GNUC_CONST;
RGBA* rgba_dup (const RGBA* self);
void rgba_free (RGBA* self);
GType render_style_get_type (void) G_GNUC_CONST;
gpointer projection_ref (gpointer instance);
void projection_unref (gpointer instance);
GParamSpec* param_spec_projection (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_projection (GValue* value, gpointer v_object);
void value_take_projection (GValue* value, gpointer v_object);
gpointer value_get_projection (const GValue* value);
GType projection_get_type (void) G_GNUC_CONST;
GType arc_get_type (void) G_GNUC_CONST;
#define ARC_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_ARC, ArcPrivate))
enum  {
	ARC_DUMMY_PROPERTY
};
static void arc_real_init_default_sub (Seed* base, Point* p);
static void arc_real_init_full_sub (Seed* base, gdouble* args, int args_length1);
static gchar* arc_real_serialize_sub (Seed* base);
gchar* util_format (gdouble n, gint decimal_places);
static void arc_real_init_distance_to_parametric (Seed* base);
void seed_init_distance_to_parametric (Seed* self);
static void arc_real_point_raw (Seed* base, gdouble t, Point* result);
void point_rotate (Point *self, gdouble angle, Point* result);
void point_move (Point *self, Point* new_origin, Point* result);
static gdouble arc_real_perpendicular_angle (Seed* base, gdouble t);
static void arc_real_draw_direct (Seed* base, cairo_t* cr, gdouble scale);
static void arc_draw_small_arc (Arc* self, cairo_t* cr, gdouble scale, gdouble a0, gdouble sweep);
void point_scale (Point *self, gdouble sx, gdouble sy, Point* result);
static void arc_real_draw_controls (Seed* base, cairo_t* cr, gdouble scale);
void seed_draw_line_control (Seed* self, cairo_t* cr, Point* p0, Point* p1);
void seed_draw_square_control (Seed* self, cairo_t* cr, Point* p);
void seed_draw_circle_control (Seed* self, cairo_t* cr, Point* p);
void seed_point (Seed* self, gdouble distance, Point* result);
static gint arc_real_pressed_control (Seed* base, Point* p, gdouble scale);
gboolean seed_within_touch_range (Seed* self, Point* p0, Point* p1, gdouble scale);
static void arc_real_save_drag_context (Seed* base);
static void arc_real_drag_control (Seed* base, Point* p, gdouble scale, gboolean snap_on, gdouble grid_size, gdouble snap_angle);
gboolean seed_snap (Seed* self, Point* p, gdouble scale, gdouble grid_size);
gboolean seed_within_snap_range (Seed* self, Point* p0, Point* p1, gdouble scale);
static void arc_normalize_angles (Arc* self);
static void arc_real_move_shape (Seed* base, gdouble delta_x, gdouble delta_y);
void point_move_xy (Point *self, gdouble x, gdouble y, Point* result);
static Point* arc_real_points_to_snap (Seed* base, int* result_length1);
static void arc_real_draw_icon (Seed* base, cairo_t* cr, gdouble width, gdouble height);
void seed_init_full (Seed* self, gdouble* args, int args_length1);
void seed_draw_direct (Seed* self, cairo_t* cr, gdouble scale);
Arc* arc_new (void);
Arc* arc_construct (GType object_type);
Seed* seed_construct (GType object_type);
static void arc_finalize (GObject* obj);


static void arc_real_init_default_sub (Seed* base, Point* p) {
	Arc * self;
	Point _tmp0_;
#line 30 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	self = (Arc*) base;
#line 30 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	g_return_if_fail (p != NULL);
#line 31 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp0_ = *p;
#line 31 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	self->priv->centre = _tmp0_;
#line 32 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	self->priv->radius_x = (gdouble) 0;
#line 33 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	self->priv->radius_y = (gdouble) 0;
#line 34 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	self->priv->angle0 = (gdouble) 0;
#line 35 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	self->priv->angle1 = G_PI * 2;
#line 36 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	self->priv->rotation = (gdouble) 0;
#line 272 "arc.c"
}


static void arc_real_init_full_sub (Seed* base, gdouble* args, int args_length1) {
	Arc * self;
	gdouble* _tmp0_;
	gint _tmp0__length1;
	gdouble* _tmp1_;
	gint _tmp1__length1;
	gdouble _tmp2_;
	gdouble* _tmp3_;
	gint _tmp3__length1;
	gdouble _tmp4_;
	Point _tmp5_ = {0};
	Point _tmp6_;
	gdouble* _tmp7_;
	gint _tmp7__length1;
	gdouble _tmp8_;
	gdouble* _tmp9_;
	gint _tmp9__length1;
	gdouble _tmp10_;
	gdouble* _tmp11_;
	gint _tmp11__length1;
	gdouble _tmp12_;
	gdouble* _tmp13_;
	gint _tmp13__length1;
	gdouble _tmp14_;
	gdouble* _tmp15_;
	gint _tmp15__length1;
	gdouble _tmp16_;
#line 39 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	self = (Arc*) base;
#line 40 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp0_ = args;
#line 40 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp0__length1 = args_length1;
#line 40 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_vala_assert (_tmp0__length1 >= 7, "args.length >= 7");
#line 41 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp1_ = args;
#line 41 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp1__length1 = args_length1;
#line 41 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp2_ = _tmp1_[0];
#line 41 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp3_ = args;
#line 41 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp3__length1 = args_length1;
#line 41 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp4_ = _tmp3_[1];
#line 41 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	memset (&_tmp5_, 0, sizeof (Point));
#line 41 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp5_.x = _tmp2_;
#line 41 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp5_.y = _tmp4_;
#line 41 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	self->priv->centre = _tmp5_;
#line 41 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp6_ = self->priv->centre;
#line 42 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp7_ = args;
#line 42 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp7__length1 = args_length1;
#line 42 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp8_ = _tmp7_[2];
#line 42 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	self->priv->radius_x = _tmp8_;
#line 43 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp9_ = args;
#line 43 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp9__length1 = args_length1;
#line 43 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp10_ = _tmp9_[3];
#line 43 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	self->priv->radius_y = _tmp10_;
#line 44 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp11_ = args;
#line 44 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp11__length1 = args_length1;
#line 44 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp12_ = _tmp11_[4];
#line 44 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	self->priv->angle0 = _tmp12_;
#line 45 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp13_ = args;
#line 45 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp13__length1 = args_length1;
#line 45 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp14_ = _tmp13_[5];
#line 45 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	self->priv->angle1 = _tmp14_;
#line 46 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp15_ = args;
#line 46 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp15__length1 = args_length1;
#line 46 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp16_ = _tmp15_[6];
#line 46 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	self->priv->rotation = _tmp16_;
#line 373 "arc.c"
}


static gchar* arc_real_serialize_sub (Seed* base) {
	Arc * self;
	gchar* result = NULL;
	Point _tmp0_;
	gdouble _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	Point _tmp4_;
	gdouble _tmp5_;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_;
	gdouble _tmp8_;
	gchar* _tmp9_ = NULL;
	gchar* _tmp10_;
	gdouble _tmp11_;
	gchar* _tmp12_ = NULL;
	gchar* _tmp13_;
	gdouble _tmp14_;
	gchar* _tmp15_ = NULL;
	gchar* _tmp16_;
	gdouble _tmp17_;
	gchar* _tmp18_ = NULL;
	gchar* _tmp19_;
	gdouble _tmp20_;
	gchar* _tmp21_ = NULL;
	gchar* _tmp22_;
	gchar* _tmp23_ = NULL;
	gchar* _tmp24_;
#line 49 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	self = (Arc*) base;
#line 50 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp0_ = self->priv->centre;
#line 50 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp1_ = _tmp0_.x;
#line 50 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp2_ = util_format (_tmp1_, 4);
#line 50 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp3_ = _tmp2_;
#line 50 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp4_ = self->priv->centre;
#line 50 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp5_ = _tmp4_.y;
#line 50 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp6_ = util_format (_tmp5_, 4);
#line 50 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp7_ = _tmp6_;
#line 50 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp8_ = self->priv->radius_x;
#line 50 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp9_ = util_format (_tmp8_, 4);
#line 50 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp10_ = _tmp9_;
#line 50 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp11_ = self->priv->radius_y;
#line 50 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp12_ = util_format (_tmp11_, 4);
#line 50 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp13_ = _tmp12_;
#line 50 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp14_ = self->priv->angle0;
#line 50 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp15_ = util_format (_tmp14_, 4);
#line 50 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp16_ = _tmp15_;
#line 50 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp17_ = self->priv->angle1;
#line 50 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp18_ = util_format (_tmp17_, 4);
#line 50 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp19_ = _tmp18_;
#line 50 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp20_ = self->priv->rotation;
#line 50 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp21_ = util_format (_tmp20_, 4);
#line 50 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp22_ = _tmp21_;
#line 50 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp23_ = g_strdup_printf ("Arc (%s, %s) (%s, %s) (%s, %s) %s", _tmp3_, _tmp7_, _tmp10_, _tmp13_, _tmp16_, _tmp19_, _tmp22_);
#line 50 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp24_ = _tmp23_;
#line 50 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_g_free0 (_tmp22_);
#line 50 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_g_free0 (_tmp19_);
#line 50 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_g_free0 (_tmp16_);
#line 50 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_g_free0 (_tmp13_);
#line 50 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_g_free0 (_tmp10_);
#line 50 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_g_free0 (_tmp7_);
#line 50 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_g_free0 (_tmp3_);
#line 50 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	result = _tmp24_;
#line 50 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	return result;
#line 475 "arc.c"
}


/**
 * For an approximately circular arc, don't use distance_to_param. Use raw t directly.
 */
static void arc_real_init_distance_to_parametric (Seed* base) {
	Arc * self;
	gboolean _tmp0_ = FALSE;
	gdouble _tmp1_;
	gboolean _tmp3_;
#line 60 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	self = (Arc*) base;
#line 61 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	((Seed*) self)->distance_to_param = (g_free (((Seed*) self)->distance_to_param), NULL);
#line 61 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	((Seed*) self)->distance_to_param = NULL;
#line 61 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	((Seed*) self)->distance_to_param_length1 = 0;
#line 62 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp1_ = self->priv->radius_x;
#line 62 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	if (_tmp1_ == ((gdouble) 0)) {
#line 499 "arc.c"
		gdouble _tmp2_;
#line 62 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		_tmp2_ = self->priv->radius_y;
#line 62 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		_tmp0_ = _tmp2_ == ((gdouble) 0);
#line 505 "arc.c"
	} else {
#line 62 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		_tmp0_ = FALSE;
#line 509 "arc.c"
	}
#line 62 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp3_ = _tmp0_;
#line 62 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	if (_tmp3_) {
#line 62 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		return;
#line 517 "arc.c"
	}
#line 65 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	SEED_CLASS (arc_parent_class)->init_distance_to_parametric (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SEED, Seed));
#line 521 "arc.c"
}


static void arc_real_point_raw (Seed* base, gdouble t, Point* result) {
	Arc * self;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_ = 0.0;
	Point _tmp10_ = {0};
	gdouble _tmp11_;
	Point _tmp12_ = {0};
	Point _tmp13_;
	Point _tmp14_ = {0};
#line 68 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	self = (Arc*) base;
#line 69 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp0_ = t;
#line 69 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp1_ = self->priv->angle0;
#line 69 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp2_ = t;
#line 69 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp3_ = self->priv->angle1;
#line 69 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	t = ((1.0 - _tmp0_) * _tmp1_) + (_tmp2_ * _tmp3_);
#line 70 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp4_ = self->priv->radius_x;
#line 70 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp5_ = t;
#line 70 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp6_ = cos (_tmp5_);
#line 70 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp7_ = self->priv->radius_y;
#line 70 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp8_ = t;
#line 70 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp9_ = sin (_tmp8_);
#line 70 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	memset (&_tmp10_, 0, sizeof (Point));
#line 70 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp10_.x = _tmp4_ * _tmp6_;
#line 70 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp10_.y = _tmp7_ * _tmp9_;
#line 70 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp11_ = self->priv->rotation;
#line 70 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_rotate (&_tmp10_, _tmp11_, &_tmp12_);
#line 70 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp13_ = self->priv->centre;
#line 70 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_move (&_tmp12_, &_tmp13_, &_tmp14_);
#line 70 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	*result = _tmp14_;
#line 70 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	return;
#line 584 "arc.c"
}


/**
 * Use parametric angle rather than the actual perpendicular
 */
static gdouble arc_real_perpendicular_angle (Seed* base, gdouble t) {
	Arc * self;
	gdouble result = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble angle;
	gdouble _tmp4_;
#line 78 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	self = (Arc*) base;
#line 79 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp0_ = t;
#line 79 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp1_ = self->priv->angle0;
#line 79 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp2_ = t;
#line 79 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp3_ = self->priv->angle1;
#line 79 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	angle = ((1.0 - _tmp0_) * _tmp1_) + (_tmp2_ * _tmp3_);
#line 80 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp4_ = self->priv->rotation;
#line 80 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	result = angle + _tmp4_;
#line 80 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	return result;
#line 618 "arc.c"
}


static void arc_real_draw_direct (Seed* base, cairo_t* cr, gdouble scale) {
	Arc * self;
	gdouble _tmp0_;
	gdouble a0;
#line 83 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	self = (Arc*) base;
#line 83 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	g_return_if_fail (cr != NULL);
#line 84 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp0_ = self->priv->angle0;
#line 84 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	a0 = _tmp0_;
#line 634 "arc.c"
	{
		gboolean _tmp1_;
#line 85 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		_tmp1_ = TRUE;
#line 85 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		while (TRUE) {
#line 641 "arc.c"
			gboolean _tmp2_;
			gdouble _tmp5_;
			gdouble _tmp6_;
			gdouble _tmp7_ = 0.0;
			gdouble a1;
			cairo_t* _tmp8_;
			gdouble _tmp9_;
			gdouble _tmp10_;
			gdouble _tmp11_;
			gdouble _tmp12_;
#line 85 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
			_tmp2_ = _tmp1_;
#line 85 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
			if (!_tmp2_) {
#line 656 "arc.c"
				gdouble _tmp3_;
				gdouble _tmp4_;
#line 89 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
				_tmp3_ = a0;
#line 89 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
				_tmp4_ = self->priv->angle1;
#line 89 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
				if (!(_tmp3_ < _tmp4_)) {
#line 89 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
					break;
#line 667 "arc.c"
				}
			}
#line 85 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
			_tmp1_ = FALSE;
#line 86 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
			_tmp5_ = self->priv->angle1;
#line 86 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
			_tmp6_ = a0;
#line 86 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
			_tmp7_ = MIN (G_PI / 2, _tmp5_ - _tmp6_);
#line 86 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
			a1 = _tmp7_;
#line 87 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
			_tmp8_ = cr;
#line 87 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
			_tmp9_ = scale;
#line 87 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
			_tmp10_ = a0;
#line 87 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
			_tmp11_ = a1;
#line 87 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
			arc_draw_small_arc (self, _tmp8_, _tmp9_, _tmp10_, _tmp11_);
#line 88 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
			_tmp12_ = a0;
#line 88 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
			a0 = _tmp12_ + (G_PI / 2);
#line 694 "arc.c"
		}
	}
}


/**
 * Draw arc subtending an angle of less than 90 degrees.
 *
 * Reference: Richard DeVeneza's "How to determine the control points of a Bezier
 * curve that approximates a small circular arc", Nov 2004
 */
static void arc_draw_small_arc (Arc* self, cairo_t* cr, gdouble scale, gdouble a0, gdouble sweep) {
	gdouble _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_;
	gdouble _tmp3_ = 0.0;
	Point _tmp4_ = {0};
	Point p0;
	Point _tmp5_;
	gdouble _tmp6_;
	Point _tmp7_;
	gdouble _tmp8_;
	Point _tmp9_;
	gdouble _tmp10_;
	Point _tmp11_;
	gdouble _tmp12_;
	Point _tmp13_ = {0};
	Point p1;
	Point _tmp14_ = {0};
	Point p2;
	Point _tmp15_ = {0};
	Point p3;
	gdouble _tmp16_;
	gdouble _tmp17_;
	gdouble rot;
	Point _tmp18_ = {0};
	gdouble _tmp19_;
	gdouble _tmp20_;
	Point _tmp21_ = {0};
	gdouble _tmp22_;
	Point _tmp23_ = {0};
	Point _tmp24_;
	Point _tmp25_ = {0};
	gdouble _tmp26_;
	gdouble _tmp27_;
	Point _tmp28_ = {0};
	Point _tmp29_ = {0};
	gdouble _tmp30_;
	gdouble _tmp31_;
	Point _tmp32_ = {0};
	gdouble _tmp33_;
	Point _tmp34_ = {0};
	Point _tmp35_;
	Point _tmp36_ = {0};
	gdouble _tmp37_;
	gdouble _tmp38_;
	Point _tmp39_ = {0};
	Point _tmp40_ = {0};
	gdouble _tmp41_;
	gdouble _tmp42_;
	Point _tmp43_ = {0};
	gdouble _tmp44_;
	Point _tmp45_ = {0};
	Point _tmp46_;
	Point _tmp47_ = {0};
	gdouble _tmp48_;
	gdouble _tmp49_;
	Point _tmp50_ = {0};
	Point _tmp51_ = {0};
	gdouble _tmp52_;
	gdouble _tmp53_;
	Point _tmp54_ = {0};
	gdouble _tmp55_;
	Point _tmp56_ = {0};
	Point _tmp57_;
	Point _tmp58_ = {0};
	gdouble _tmp59_;
	gdouble _tmp60_;
	Point _tmp61_ = {0};
	cairo_t* _tmp62_;
	Point _tmp63_;
	gdouble _tmp64_;
	Point _tmp65_;
	gdouble _tmp66_;
	cairo_t* _tmp67_;
	Point _tmp68_;
	gdouble _tmp69_;
	Point _tmp70_;
	gdouble _tmp71_;
	Point _tmp72_;
	gdouble _tmp73_;
	Point _tmp74_;
	gdouble _tmp75_;
	Point _tmp76_;
	gdouble _tmp77_;
	Point _tmp78_;
	gdouble _tmp79_;
	cairo_t* _tmp80_;
#line 98 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	g_return_if_fail (self != NULL);
#line 98 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	g_return_if_fail (cr != NULL);
#line 100 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp0_ = sweep;
#line 100 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp1_ = cos (_tmp0_ / 2);
#line 100 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp2_ = sweep;
#line 100 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp3_ = sin (_tmp2_ / 2);
#line 100 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	memset (&_tmp4_, 0, sizeof (Point));
#line 100 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp4_.x = _tmp1_;
#line 100 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp4_.y = _tmp3_;
#line 100 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	p0 = _tmp4_;
#line 101 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp5_ = p0;
#line 101 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp6_ = _tmp5_.x;
#line 101 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp7_ = p0;
#line 101 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp8_ = _tmp7_.x;
#line 101 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp9_ = p0;
#line 101 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp10_ = _tmp9_.x;
#line 101 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp11_ = p0;
#line 101 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp12_ = _tmp11_.y;
#line 101 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	memset (&_tmp13_, 0, sizeof (Point));
#line 101 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp13_.x = (4 - _tmp6_) / 3;
#line 101 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp13_.y = ((1 - _tmp8_) * (3 - _tmp10_)) / (3 * _tmp12_);
#line 101 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	p1 = _tmp13_;
#line 102 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_scale (&p1, (gdouble) 1, (gdouble) (-1), &_tmp14_);
#line 102 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	p2 = _tmp14_;
#line 103 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_scale (&p0, (gdouble) 1, (gdouble) (-1), &_tmp15_);
#line 103 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	p3 = _tmp15_;
#line 109 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp16_ = a0;
#line 109 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp17_ = sweep;
#line 109 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	rot = _tmp16_ + (_tmp17_ / 2);
#line 110 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_rotate (&p0, rot, &_tmp18_);
#line 110 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp19_ = self->priv->radius_x;
#line 110 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp20_ = self->priv->radius_y;
#line 110 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_scale (&_tmp18_, _tmp19_, _tmp20_, &_tmp21_);
#line 110 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp22_ = self->priv->rotation;
#line 110 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_rotate (&_tmp21_, _tmp22_, &_tmp23_);
#line 110 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp24_ = self->priv->centre;
#line 110 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_move (&_tmp23_, &_tmp24_, &_tmp25_);
#line 110 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp26_ = scale;
#line 110 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp27_ = scale;
#line 110 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_scale (&_tmp25_, _tmp26_, _tmp27_, &_tmp28_);
#line 110 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	p0 = _tmp28_;
#line 111 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_rotate (&p1, rot, &_tmp29_);
#line 111 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp30_ = self->priv->radius_x;
#line 111 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp31_ = self->priv->radius_y;
#line 111 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_scale (&_tmp29_, _tmp30_, _tmp31_, &_tmp32_);
#line 111 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp33_ = self->priv->rotation;
#line 111 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_rotate (&_tmp32_, _tmp33_, &_tmp34_);
#line 111 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp35_ = self->priv->centre;
#line 111 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_move (&_tmp34_, &_tmp35_, &_tmp36_);
#line 111 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp37_ = scale;
#line 111 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp38_ = scale;
#line 111 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_scale (&_tmp36_, _tmp37_, _tmp38_, &_tmp39_);
#line 111 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	p1 = _tmp39_;
#line 112 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_rotate (&p2, rot, &_tmp40_);
#line 112 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp41_ = self->priv->radius_x;
#line 112 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp42_ = self->priv->radius_y;
#line 112 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_scale (&_tmp40_, _tmp41_, _tmp42_, &_tmp43_);
#line 112 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp44_ = self->priv->rotation;
#line 112 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_rotate (&_tmp43_, _tmp44_, &_tmp45_);
#line 112 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp46_ = self->priv->centre;
#line 112 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_move (&_tmp45_, &_tmp46_, &_tmp47_);
#line 112 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp48_ = scale;
#line 112 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp49_ = scale;
#line 112 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_scale (&_tmp47_, _tmp48_, _tmp49_, &_tmp50_);
#line 112 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	p2 = _tmp50_;
#line 113 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_rotate (&p3, rot, &_tmp51_);
#line 113 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp52_ = self->priv->radius_x;
#line 113 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp53_ = self->priv->radius_y;
#line 113 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_scale (&_tmp51_, _tmp52_, _tmp53_, &_tmp54_);
#line 113 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp55_ = self->priv->rotation;
#line 113 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_rotate (&_tmp54_, _tmp55_, &_tmp56_);
#line 113 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp57_ = self->priv->centre;
#line 113 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_move (&_tmp56_, &_tmp57_, &_tmp58_);
#line 113 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp59_ = scale;
#line 113 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp60_ = scale;
#line 113 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_scale (&_tmp58_, _tmp59_, _tmp60_, &_tmp61_);
#line 113 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	p3 = _tmp61_;
#line 115 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp62_ = cr;
#line 115 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp63_ = p0;
#line 115 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp64_ = _tmp63_.x;
#line 115 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp65_ = p0;
#line 115 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp66_ = _tmp65_.y;
#line 115 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	cairo_move_to (_tmp62_, _tmp64_, _tmp66_);
#line 116 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp67_ = cr;
#line 116 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp68_ = p1;
#line 116 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp69_ = _tmp68_.x;
#line 116 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp70_ = p1;
#line 116 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp71_ = _tmp70_.y;
#line 116 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp72_ = p2;
#line 116 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp73_ = _tmp72_.x;
#line 116 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp74_ = p2;
#line 116 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp75_ = _tmp74_.y;
#line 116 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp76_ = p3;
#line 116 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp77_ = _tmp76_.x;
#line 116 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp78_ = p3;
#line 116 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp79_ = _tmp78_.y;
#line 116 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	cairo_curve_to (_tmp67_, _tmp69_, _tmp71_, _tmp73_, _tmp75_, _tmp77_, _tmp79_);
#line 117 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp80_ = cr;
#line 117 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	cairo_stroke (_tmp80_);
#line 991 "arc.c"
}


static void arc_real_draw_controls (Seed* base, cairo_t* cr, gdouble scale) {
	Arc * self;
	gdouble _tmp0_;
	gdouble _tmp1_;
	Point _tmp2_ = {0};
	gdouble _tmp3_;
	Point _tmp4_ = {0};
	Point _tmp5_;
	Point _tmp6_ = {0};
	gdouble _tmp7_;
	gdouble _tmp8_;
	Point _tmp9_ = {0};
	Point corner0;
	gdouble _tmp10_;
	gdouble _tmp11_;
	Point _tmp12_ = {0};
	gdouble _tmp13_;
	Point _tmp14_ = {0};
	Point _tmp15_;
	Point _tmp16_ = {0};
	gdouble _tmp17_;
	gdouble _tmp18_;
	Point _tmp19_ = {0};
	Point corner1;
	gdouble _tmp20_;
	gdouble _tmp21_;
	Point _tmp22_ = {0};
	gdouble _tmp23_;
	Point _tmp24_ = {0};
	Point _tmp25_;
	Point _tmp26_ = {0};
	gdouble _tmp27_;
	gdouble _tmp28_;
	Point _tmp29_ = {0};
	Point corner2;
	gdouble _tmp30_;
	gdouble _tmp31_;
	Point _tmp32_ = {0};
	gdouble _tmp33_;
	Point _tmp34_ = {0};
	Point _tmp35_;
	Point _tmp36_ = {0};
	gdouble _tmp37_;
	gdouble _tmp38_;
	Point _tmp39_ = {0};
	Point corner3;
	cairo_t* _tmp40_;
	Point _tmp41_;
	Point _tmp42_;
	cairo_t* _tmp43_;
	Point _tmp44_;
	Point _tmp45_;
	cairo_t* _tmp46_;
	Point _tmp47_;
	Point _tmp48_;
	cairo_t* _tmp49_;
	Point _tmp50_;
	Point _tmp51_;
	cairo_t* _tmp52_;
	Point _tmp53_;
	cairo_t* _tmp54_;
	Point _tmp55_;
	cairo_t* _tmp56_;
	Point _tmp57_ = {0};
	gdouble _tmp58_;
	gdouble _tmp59_;
	Point _tmp60_ = {0};
	cairo_t* _tmp61_;
	Point _tmp62_ = {0};
	gdouble _tmp63_;
	gdouble _tmp64_;
	Point _tmp65_ = {0};
#line 120 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	self = (Arc*) base;
#line 120 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	g_return_if_fail (cr != NULL);
#line 121 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp0_ = self->priv->radius_x;
#line 121 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp1_ = self->priv->radius_y;
#line 121 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	memset (&_tmp2_, 0, sizeof (Point));
#line 121 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp2_.x = -_tmp0_;
#line 121 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp2_.y = -_tmp1_;
#line 121 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp3_ = self->priv->rotation;
#line 121 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_rotate (&_tmp2_, _tmp3_, &_tmp4_);
#line 121 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp5_ = self->priv->centre;
#line 121 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_move (&_tmp4_, &_tmp5_, &_tmp6_);
#line 121 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp7_ = scale;
#line 121 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp8_ = scale;
#line 121 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_scale (&_tmp6_, _tmp7_, _tmp8_, &_tmp9_);
#line 121 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	corner0 = _tmp9_;
#line 122 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp10_ = self->priv->radius_x;
#line 122 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp11_ = self->priv->radius_y;
#line 122 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	memset (&_tmp12_, 0, sizeof (Point));
#line 122 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp12_.x = +_tmp10_;
#line 122 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp12_.y = -_tmp11_;
#line 122 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp13_ = self->priv->rotation;
#line 122 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_rotate (&_tmp12_, _tmp13_, &_tmp14_);
#line 122 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp15_ = self->priv->centre;
#line 122 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_move (&_tmp14_, &_tmp15_, &_tmp16_);
#line 122 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp17_ = scale;
#line 122 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp18_ = scale;
#line 122 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_scale (&_tmp16_, _tmp17_, _tmp18_, &_tmp19_);
#line 122 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	corner1 = _tmp19_;
#line 123 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp20_ = self->priv->radius_x;
#line 123 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp21_ = self->priv->radius_y;
#line 123 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	memset (&_tmp22_, 0, sizeof (Point));
#line 123 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp22_.x = +_tmp20_;
#line 123 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp22_.y = +_tmp21_;
#line 123 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp23_ = self->priv->rotation;
#line 123 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_rotate (&_tmp22_, _tmp23_, &_tmp24_);
#line 123 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp25_ = self->priv->centre;
#line 123 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_move (&_tmp24_, &_tmp25_, &_tmp26_);
#line 123 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp27_ = scale;
#line 123 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp28_ = scale;
#line 123 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_scale (&_tmp26_, _tmp27_, _tmp28_, &_tmp29_);
#line 123 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	corner2 = _tmp29_;
#line 124 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp30_ = self->priv->radius_x;
#line 124 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp31_ = self->priv->radius_y;
#line 124 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	memset (&_tmp32_, 0, sizeof (Point));
#line 124 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp32_.x = -_tmp30_;
#line 124 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp32_.y = +_tmp31_;
#line 124 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp33_ = self->priv->rotation;
#line 124 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_rotate (&_tmp32_, _tmp33_, &_tmp34_);
#line 124 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp35_ = self->priv->centre;
#line 124 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_move (&_tmp34_, &_tmp35_, &_tmp36_);
#line 124 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp37_ = scale;
#line 124 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp38_ = scale;
#line 124 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_scale (&_tmp36_, _tmp37_, _tmp38_, &_tmp39_);
#line 124 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	corner3 = _tmp39_;
#line 125 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp40_ = cr;
#line 125 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp41_ = corner0;
#line 125 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp42_ = corner1;
#line 125 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	seed_draw_line_control ((Seed*) self, _tmp40_, &_tmp41_, &_tmp42_);
#line 126 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp43_ = cr;
#line 126 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp44_ = corner1;
#line 126 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp45_ = corner2;
#line 126 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	seed_draw_line_control ((Seed*) self, _tmp43_, &_tmp44_, &_tmp45_);
#line 127 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp46_ = cr;
#line 127 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp47_ = corner2;
#line 127 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp48_ = corner3;
#line 127 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	seed_draw_line_control ((Seed*) self, _tmp46_, &_tmp47_, &_tmp48_);
#line 128 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp49_ = cr;
#line 128 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp50_ = corner3;
#line 128 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp51_ = corner0;
#line 128 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	seed_draw_line_control ((Seed*) self, _tmp49_, &_tmp50_, &_tmp51_);
#line 129 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp52_ = cr;
#line 129 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp53_ = corner2;
#line 129 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	seed_draw_square_control ((Seed*) self, _tmp52_, &_tmp53_);
#line 130 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp54_ = cr;
#line 130 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp55_ = corner1;
#line 130 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	seed_draw_circle_control ((Seed*) self, _tmp54_, &_tmp55_);
#line 131 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp56_ = cr;
#line 131 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	seed_point ((Seed*) self, (gdouble) 0, &_tmp57_);
#line 131 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp58_ = scale;
#line 131 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp59_ = scale;
#line 131 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_scale (&_tmp57_, _tmp58_, _tmp59_, &_tmp60_);
#line 131 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	seed_draw_circle_control ((Seed*) self, _tmp56_, &_tmp60_);
#line 132 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp61_ = cr;
#line 132 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	seed_point ((Seed*) self, (gdouble) 1, &_tmp62_);
#line 132 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp63_ = scale;
#line 132 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp64_ = scale;
#line 132 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_scale (&_tmp62_, _tmp63_, _tmp64_, &_tmp65_);
#line 132 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	seed_draw_circle_control ((Seed*) self, _tmp61_, &_tmp65_);
#line 1243 "arc.c"
}


static gint arc_real_pressed_control (Seed* base, Point* p, gdouble scale) {
	Arc * self;
	gint result = 0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	Point _tmp2_ = {0};
	gdouble _tmp3_;
	Point _tmp4_ = {0};
	Point _tmp5_;
	Point _tmp6_ = {0};
	Point corner1;
	gdouble _tmp7_;
	gdouble _tmp8_;
	Point _tmp9_ = {0};
	gdouble _tmp10_;
	Point _tmp11_ = {0};
	Point _tmp12_;
	Point _tmp13_ = {0};
	Point corner2;
	gint _tmp14_ = 0;
	Point _tmp15_;
	Point _tmp16_;
	gdouble _tmp17_;
	gboolean _tmp18_ = FALSE;
	gint _tmp37_;
#line 145 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	self = (Arc*) base;
#line 145 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	g_return_val_if_fail (p != NULL, 0);
#line 146 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp0_ = self->priv->radius_x;
#line 146 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp1_ = self->priv->radius_y;
#line 146 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	memset (&_tmp2_, 0, sizeof (Point));
#line 146 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp2_.x = +_tmp0_;
#line 146 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp2_.y = -_tmp1_;
#line 146 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp3_ = self->priv->rotation;
#line 146 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_rotate (&_tmp2_, _tmp3_, &_tmp4_);
#line 146 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp5_ = self->priv->centre;
#line 146 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_move (&_tmp4_, &_tmp5_, &_tmp6_);
#line 146 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	corner1 = _tmp6_;
#line 147 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp7_ = self->priv->radius_x;
#line 147 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp8_ = self->priv->radius_y;
#line 147 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	memset (&_tmp9_, 0, sizeof (Point));
#line 147 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp9_.x = +_tmp7_;
#line 147 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp9_.y = +_tmp8_;
#line 147 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp10_ = self->priv->rotation;
#line 147 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_rotate (&_tmp9_, _tmp10_, &_tmp11_);
#line 147 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp12_ = self->priv->centre;
#line 147 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_move (&_tmp11_, &_tmp12_, &_tmp13_);
#line 147 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	corner2 = _tmp13_;
#line 148 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp15_ = *p;
#line 148 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp16_ = corner2;
#line 148 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp17_ = scale;
#line 148 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp18_ = seed_within_touch_range ((Seed*) self, &_tmp15_, &_tmp16_, _tmp17_);
#line 148 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	if (_tmp18_) {
#line 148 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		_tmp14_ = 0;
#line 1328 "arc.c"
	} else {
		gint _tmp19_ = 0;
		Point _tmp20_;
		Point _tmp21_;
		gdouble _tmp22_;
		gboolean _tmp23_ = FALSE;
		gint _tmp36_;
#line 149 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		_tmp20_ = *p;
#line 149 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		_tmp21_ = corner1;
#line 149 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		_tmp22_ = scale;
#line 149 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		_tmp23_ = seed_within_touch_range ((Seed*) self, &_tmp20_, &_tmp21_, _tmp22_);
#line 149 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		if (_tmp23_) {
#line 149 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
			_tmp19_ = 1;
#line 1348 "arc.c"
		} else {
			gint _tmp24_ = 0;
			Point _tmp25_;
			Point _tmp26_ = {0};
			gdouble _tmp27_;
			gboolean _tmp28_ = FALSE;
			gint _tmp35_;
#line 150 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
			_tmp25_ = *p;
#line 150 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
			seed_point ((Seed*) self, (gdouble) 0, &_tmp26_);
#line 150 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
			_tmp27_ = scale;
#line 150 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
			_tmp28_ = seed_within_touch_range ((Seed*) self, &_tmp25_, &_tmp26_, _tmp27_);
#line 150 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
			if (_tmp28_) {
#line 150 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
				_tmp24_ = 2;
#line 1368 "arc.c"
			} else {
				gint _tmp29_ = 0;
				Point _tmp30_;
				Point _tmp31_ = {0};
				gdouble _tmp32_;
				gboolean _tmp33_ = FALSE;
				gint _tmp34_;
#line 151 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
				_tmp30_ = *p;
#line 151 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
				seed_point ((Seed*) self, (gdouble) 1, &_tmp31_);
#line 151 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
				_tmp32_ = scale;
#line 151 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
				_tmp33_ = seed_within_touch_range ((Seed*) self, &_tmp30_, &_tmp31_, _tmp32_);
#line 151 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
				if (_tmp33_) {
#line 151 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
					_tmp29_ = 3;
#line 1388 "arc.c"
				} else {
#line 151 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
					_tmp29_ = -1;
#line 1392 "arc.c"
				}
#line 151 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
				_tmp34_ = _tmp29_;
#line 151 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
				_tmp24_ = _tmp34_;
#line 1398 "arc.c"
			}
#line 150 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
			_tmp35_ = _tmp24_;
#line 150 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
			_tmp19_ = _tmp35_;
#line 1404 "arc.c"
		}
#line 149 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		_tmp36_ = _tmp19_;
#line 149 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		_tmp14_ = _tmp36_;
#line 1410 "arc.c"
	}
#line 148 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp37_ = _tmp14_;
#line 148 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	result = _tmp37_;
#line 148 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	return result;
#line 1418 "arc.c"
}


static void arc_real_save_drag_context (Seed* base) {
	Arc * self;
	Point _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	Point _tmp3_ = {0};
	gdouble _tmp4_;
	Point _tmp5_ = {0};
	Point _tmp6_;
	Point _tmp7_ = {0};
#line 154 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	self = (Arc*) base;
#line 155 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp0_ = self->priv->centre;
#line 155 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	self->priv->centre_save = _tmp0_;
#line 156 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp1_ = self->priv->radius_x;
#line 156 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp2_ = self->priv->radius_y;
#line 156 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	memset (&_tmp3_, 0, sizeof (Point));
#line 156 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp3_.x = -_tmp1_;
#line 156 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp3_.y = -_tmp2_;
#line 156 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp4_ = self->priv->rotation;
#line 156 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_rotate (&_tmp3_, _tmp4_, &_tmp5_);
#line 156 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp6_ = self->priv->centre;
#line 156 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_move (&_tmp5_, &_tmp6_, &_tmp7_);
#line 156 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	self->priv->topleft_save = _tmp7_;
#line 1458 "arc.c"
}


static void arc_real_drag_control (Seed* base, Point* p, gdouble scale, gboolean snap_on, gdouble grid_size, gdouble snap_angle) {
	Arc * self;
	gdouble _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp4_;
	Point _tmp7_;
	gdouble _tmp8_;
	Point _tmp9_;
	gdouble _tmp10_;
	Point _tmp11_;
	gdouble _tmp12_;
	Point _tmp13_;
	gdouble _tmp14_;
	Point _tmp15_ = {0};
	gdouble _tmp16_;
	Point _tmp17_ = {0};
	Point canonical_p;
	Point _tmp18_;
	gdouble _tmp19_;
	gdouble rx;
	Point _tmp20_;
	gdouble _tmp21_;
	gdouble ry;
	gint _tmp22_;
#line 159 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	self = (Arc*) base;
#line 159 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	g_return_if_fail (p != NULL);
#line 161 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp0_ = snap_angle;
#line 161 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	snap_angle = (G_PI * _tmp0_) / 180;
#line 162 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp2_ = snap_on;
#line 162 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	if (_tmp2_) {
#line 1499 "arc.c"
		gint _tmp3_;
#line 162 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		_tmp3_ = ((Seed*) self)->selected_control;
#line 162 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		_tmp1_ = _tmp3_ == 0;
#line 1505 "arc.c"
	} else {
#line 162 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		_tmp1_ = FALSE;
#line 1509 "arc.c"
	}
#line 162 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp4_ = _tmp1_;
#line 162 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	if (_tmp4_) {
#line 1515 "arc.c"
		gdouble _tmp5_;
		gdouble _tmp6_;
#line 162 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		_tmp5_ = scale;
#line 162 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		_tmp6_ = grid_size;
#line 162 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		seed_snap ((Seed*) self, p, _tmp5_, _tmp6_);
#line 1524 "arc.c"
	}
#line 163 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp7_ = *p;
#line 163 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp8_ = _tmp7_.x;
#line 163 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp9_ = self->priv->centre;
#line 163 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp10_ = _tmp9_.x;
#line 163 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp11_ = *p;
#line 163 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp12_ = _tmp11_.y;
#line 163 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp13_ = self->priv->centre;
#line 163 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp14_ = _tmp13_.y;
#line 163 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	memset (&_tmp15_, 0, sizeof (Point));
#line 163 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp15_.x = _tmp8_ - _tmp10_;
#line 163 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp15_.y = _tmp12_ - _tmp14_;
#line 163 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp16_ = self->priv->rotation;
#line 163 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_rotate (&_tmp15_, -_tmp16_, &_tmp17_);
#line 163 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	canonical_p = _tmp17_;
#line 164 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp18_ = canonical_p;
#line 164 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp19_ = _tmp18_.x;
#line 164 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	rx = _tmp19_;
#line 165 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp20_ = canonical_p;
#line 165 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp21_ = _tmp20_.y;
#line 165 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	ry = _tmp21_;
#line 166 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp22_ = ((Seed*) self)->selected_control;
#line 166 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	if (_tmp22_ == 0) {
#line 1570 "arc.c"
		Point _tmp23_;
		gdouble _tmp24_;
		Point _tmp25_;
		gdouble _tmp26_;
		Point _tmp27_;
		gdouble _tmp28_;
		Point _tmp29_;
		gdouble _tmp30_;
		Point _tmp31_ = {0};
		gdouble _tmp32_;
		Point _tmp33_ = {0};
		Point size;
		Point _tmp34_;
		gdouble _tmp35_;
		gdouble _tmp36_ = 0.0;
		Point _tmp37_;
		gdouble _tmp38_;
		gdouble _tmp39_ = 0.0;
		gdouble _tmp40_;
		gdouble _tmp41_;
		Point _tmp42_ = {0};
		gdouble _tmp43_;
		Point _tmp44_ = {0};
		Point _tmp45_;
		Point _tmp46_ = {0};
#line 167 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		_tmp23_ = *p;
#line 167 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		_tmp24_ = _tmp23_.x;
#line 167 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		_tmp25_ = self->priv->topleft_save;
#line 167 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		_tmp26_ = _tmp25_.x;
#line 167 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		_tmp27_ = *p;
#line 167 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		_tmp28_ = _tmp27_.y;
#line 167 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		_tmp29_ = self->priv->topleft_save;
#line 167 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		_tmp30_ = _tmp29_.y;
#line 167 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		memset (&_tmp31_, 0, sizeof (Point));
#line 167 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		_tmp31_.x = _tmp24_ - _tmp26_;
#line 167 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		_tmp31_.y = _tmp28_ - _tmp30_;
#line 167 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		_tmp32_ = self->priv->rotation;
#line 167 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		point_rotate (&_tmp31_, -_tmp32_, &_tmp33_);
#line 167 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		size = _tmp33_;
#line 168 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		_tmp34_ = size;
#line 168 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		_tmp35_ = _tmp34_.x;
#line 168 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		_tmp36_ = MAX ((gdouble) 0, _tmp35_ / 2);
#line 168 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		self->priv->radius_x = _tmp36_;
#line 169 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		_tmp37_ = size;
#line 169 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		_tmp38_ = _tmp37_.y;
#line 169 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		_tmp39_ = MAX ((gdouble) 0, _tmp38_ / 2);
#line 169 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		self->priv->radius_y = _tmp39_;
#line 170 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		_tmp40_ = self->priv->radius_x;
#line 170 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		_tmp41_ = self->priv->radius_y;
#line 170 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		memset (&_tmp42_, 0, sizeof (Point));
#line 170 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		_tmp42_.x = _tmp40_;
#line 170 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		_tmp42_.y = _tmp41_;
#line 170 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		_tmp43_ = self->priv->rotation;
#line 170 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		point_rotate (&_tmp42_, _tmp43_, &_tmp44_);
#line 170 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		_tmp45_ = self->priv->topleft_save;
#line 170 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		point_move (&_tmp44_, &_tmp45_, &_tmp46_);
#line 170 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		self->priv->centre = _tmp46_;
#line 1660 "arc.c"
	} else {
		gint _tmp47_;
#line 172 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		_tmp47_ = ((Seed*) self)->selected_control;
#line 172 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		if (_tmp47_ == 1) {
#line 1667 "arc.c"
			Point _tmp48_;
			gdouble _tmp49_;
			Point _tmp50_;
			gdouble _tmp51_;
			Point _tmp52_;
			gdouble _tmp53_;
			Point _tmp54_;
			gdouble _tmp55_;
			gdouble _tmp56_ = 0.0;
			gdouble _tmp57_;
			gdouble _tmp58_;
			gdouble _tmp59_ = 0.0;
			gboolean _tmp60_;
#line 174 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
			_tmp48_ = *p;
#line 174 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
			_tmp49_ = _tmp48_.y;
#line 174 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
			_tmp50_ = self->priv->centre;
#line 174 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
			_tmp51_ = _tmp50_.y;
#line 174 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
			_tmp52_ = *p;
#line 174 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
			_tmp53_ = _tmp52_.x;
#line 174 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
			_tmp54_ = self->priv->centre;
#line 174 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
			_tmp55_ = _tmp54_.x;
#line 174 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
			_tmp56_ = atan2 (_tmp49_ - _tmp51_, _tmp53_ - _tmp55_);
#line 174 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
			_tmp57_ = self->priv->radius_y;
#line 174 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
			_tmp58_ = self->priv->radius_x;
#line 174 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
			_tmp59_ = atan2 (_tmp57_, _tmp58_);
#line 174 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
			self->priv->rotation = _tmp56_ + _tmp59_;
#line 175 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
			_tmp60_ = snap_on;
#line 175 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
			if (_tmp60_) {
#line 1711 "arc.c"
				gdouble _tmp61_;
				gdouble _tmp62_;
				gdouble _tmp63_ = 0.0;
				gdouble _tmp64_;
#line 175 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
				_tmp61_ = self->priv->rotation;
#line 175 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
				_tmp62_ = snap_angle;
#line 175 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
				_tmp63_ = round (_tmp61_ / _tmp62_);
#line 175 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
				_tmp64_ = snap_angle;
#line 175 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
				self->priv->rotation = _tmp63_ * _tmp64_;
#line 1726 "arc.c"
			}
		} else {
			gint _tmp65_;
#line 177 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
			_tmp65_ = ((Seed*) self)->selected_control;
#line 177 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
			if (_tmp65_ == 2) {
#line 1734 "arc.c"
				gboolean _tmp66_ = FALSE;
				gboolean _tmp67_;
				gboolean _tmp72_;
#line 178 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
				_tmp67_ = snap_on;
#line 178 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
				if (_tmp67_) {
#line 1742 "arc.c"
					Point _tmp68_;
					Point _tmp69_ = {0};
					gdouble _tmp70_;
					gboolean _tmp71_ = FALSE;
#line 178 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
					_tmp68_ = *p;
#line 178 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
					seed_point ((Seed*) self, (gdouble) 1, &_tmp69_);
#line 178 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
					_tmp70_ = scale;
#line 178 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
					_tmp71_ = seed_within_snap_range ((Seed*) self, &_tmp68_, &_tmp69_, _tmp70_);
#line 178 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
					_tmp66_ = _tmp71_;
#line 1757 "arc.c"
				} else {
#line 178 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
					_tmp66_ = FALSE;
#line 1761 "arc.c"
				}
#line 178 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
				_tmp72_ = _tmp66_;
#line 178 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
				if (_tmp72_) {
#line 1767 "arc.c"
					gdouble _tmp73_;
					gdouble _tmp74_;
#line 180 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
					_tmp73_ = self->priv->angle1;
#line 180 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
					self->priv->angle0 = _tmp73_;
#line 181 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
					_tmp74_ = self->priv->angle1;
#line 181 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
					self->priv->angle1 = _tmp74_ + (2 * G_PI);
#line 1778 "arc.c"
				} else {
					gdouble _tmp75_;
					gdouble _tmp76_;
					gdouble _tmp77_;
					gdouble _tmp78_;
					gdouble _tmp79_ = 0.0;
					gboolean _tmp80_;
#line 185 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
					_tmp75_ = self->priv->radius_x;
#line 185 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
					_tmp76_ = ry;
#line 185 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
					_tmp77_ = self->priv->radius_y;
#line 185 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
					_tmp78_ = rx;
#line 185 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
					_tmp79_ = atan2 (_tmp75_ * _tmp76_, _tmp77_ * _tmp78_);
#line 185 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
					self->priv->angle0 = _tmp79_;
#line 186 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
					_tmp80_ = snap_on;
#line 186 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
					if (_tmp80_) {
#line 1802 "arc.c"
						gdouble _tmp81_;
						gdouble _tmp82_;
						gdouble _tmp83_ = 0.0;
						gdouble _tmp84_;
#line 186 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
						_tmp81_ = self->priv->angle0;
#line 186 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
						_tmp82_ = snap_angle;
#line 186 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
						_tmp83_ = round (_tmp81_ / _tmp82_);
#line 186 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
						_tmp84_ = snap_angle;
#line 186 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
						self->priv->angle0 = _tmp83_ * _tmp84_;
#line 1817 "arc.c"
					}
#line 187 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
					arc_normalize_angles (self);
#line 1821 "arc.c"
				}
			} else {
				gint _tmp85_;
#line 190 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
				_tmp85_ = ((Seed*) self)->selected_control;
#line 190 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
				if (_tmp85_ == 3) {
#line 1829 "arc.c"
					gboolean _tmp86_ = FALSE;
					gboolean _tmp87_;
					gboolean _tmp92_;
#line 191 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
					_tmp87_ = snap_on;
#line 191 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
					if (_tmp87_) {
#line 1837 "arc.c"
						Point _tmp88_;
						Point _tmp89_ = {0};
						gdouble _tmp90_;
						gboolean _tmp91_ = FALSE;
#line 191 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
						_tmp88_ = *p;
#line 191 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
						seed_point ((Seed*) self, (gdouble) 0, &_tmp89_);
#line 191 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
						_tmp90_ = scale;
#line 191 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
						_tmp91_ = seed_within_snap_range ((Seed*) self, &_tmp88_, &_tmp89_, _tmp90_);
#line 191 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
						_tmp86_ = _tmp91_;
#line 1852 "arc.c"
					} else {
#line 191 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
						_tmp86_ = FALSE;
#line 1856 "arc.c"
					}
#line 191 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
					_tmp92_ = _tmp86_;
#line 191 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
					if (_tmp92_) {
#line 1862 "arc.c"
						gdouble _tmp93_;
#line 193 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
						_tmp93_ = self->priv->angle0;
#line 193 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
						self->priv->angle1 = _tmp93_ + (2 * G_PI);
#line 1868 "arc.c"
					} else {
						gdouble _tmp94_;
						gdouble _tmp95_;
						gdouble _tmp96_;
						gdouble _tmp97_;
						gdouble _tmp98_ = 0.0;
						gboolean _tmp99_;
#line 197 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
						_tmp94_ = self->priv->radius_x;
#line 197 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
						_tmp95_ = ry;
#line 197 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
						_tmp96_ = self->priv->radius_y;
#line 197 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
						_tmp97_ = rx;
#line 197 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
						_tmp98_ = atan2 (_tmp94_ * _tmp95_, _tmp96_ * _tmp97_);
#line 197 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
						self->priv->angle1 = _tmp98_;
#line 198 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
						_tmp99_ = snap_on;
#line 198 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
						if (_tmp99_) {
#line 1892 "arc.c"
							gdouble _tmp100_;
							gdouble _tmp101_;
							gdouble _tmp102_ = 0.0;
							gdouble _tmp103_;
#line 198 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
							_tmp100_ = self->priv->angle1;
#line 198 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
							_tmp101_ = snap_angle;
#line 198 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
							_tmp102_ = round (_tmp100_ / _tmp101_);
#line 198 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
							_tmp103_ = snap_angle;
#line 198 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
							self->priv->angle1 = _tmp102_ * _tmp103_;
#line 1907 "arc.c"
						}
#line 199 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
						arc_normalize_angles (self);
#line 1911 "arc.c"
					}
				} else {
#line 202 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
					g_assert_not_reached ();
#line 1916 "arc.c"
				}
			}
		}
	}
}


static void arc_real_move_shape (Seed* base, gdouble delta_x, gdouble delta_y) {
	Arc * self;
	gdouble _tmp0_;
	gdouble _tmp1_;
	Point _tmp2_ = {0};
#line 205 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	self = (Arc*) base;
#line 206 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp0_ = delta_x;
#line 206 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp1_ = delta_y;
#line 206 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_move_xy (&self->priv->centre_save, _tmp0_, _tmp1_, &_tmp2_);
#line 206 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	self->priv->centre = _tmp2_;
#line 1939 "arc.c"
}


static Point* arc_real_points_to_snap (Seed* base, int* result_length1) {
	Arc * self;
	Point* result = NULL;
	Point _tmp0_;
	gdouble _tmp1_;
	Point _tmp2_ = {0};
	gdouble _tmp3_;
	Point _tmp4_ = {0};
	Point _tmp5_;
	Point _tmp6_ = {0};
	gdouble _tmp7_;
	Point _tmp8_ = {0};
	gdouble _tmp9_;
	Point _tmp10_ = {0};
	Point _tmp11_;
	Point _tmp12_ = {0};
	gdouble _tmp13_;
	Point _tmp14_ = {0};
	gdouble _tmp15_;
	Point _tmp16_ = {0};
	Point _tmp17_;
	Point _tmp18_ = {0};
	gdouble _tmp19_;
	Point _tmp20_ = {0};
	gdouble _tmp21_;
	Point _tmp22_ = {0};
	Point _tmp23_;
	Point _tmp24_ = {0};
	Point* _tmp25_ = NULL;
	Point* _tmp26_;
	gint _tmp26__length1;
#line 209 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	self = (Arc*) base;
#line 210 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp0_ = self->priv->centre;
#line 210 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp1_ = self->priv->radius_x;
#line 210 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	memset (&_tmp2_, 0, sizeof (Point));
#line 210 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp2_.x = -_tmp1_;
#line 210 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp2_.y = (gdouble) 0;
#line 210 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp3_ = self->priv->rotation;
#line 210 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_rotate (&_tmp2_, _tmp3_, &_tmp4_);
#line 210 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp5_ = self->priv->centre;
#line 210 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_move (&_tmp4_, &_tmp5_, &_tmp6_);
#line 210 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp7_ = self->priv->radius_x;
#line 210 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	memset (&_tmp8_, 0, sizeof (Point));
#line 210 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp8_.x = _tmp7_;
#line 210 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp8_.y = (gdouble) 0;
#line 210 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp9_ = self->priv->rotation;
#line 210 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_rotate (&_tmp8_, _tmp9_, &_tmp10_);
#line 210 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp11_ = self->priv->centre;
#line 210 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_move (&_tmp10_, &_tmp11_, &_tmp12_);
#line 210 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp13_ = self->priv->radius_y;
#line 210 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	memset (&_tmp14_, 0, sizeof (Point));
#line 210 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp14_.x = (gdouble) 0;
#line 210 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp14_.y = -_tmp13_;
#line 210 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp15_ = self->priv->rotation;
#line 210 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_rotate (&_tmp14_, _tmp15_, &_tmp16_);
#line 210 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp17_ = self->priv->centre;
#line 210 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_move (&_tmp16_, &_tmp17_, &_tmp18_);
#line 210 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp19_ = self->priv->radius_y;
#line 210 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	memset (&_tmp20_, 0, sizeof (Point));
#line 210 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp20_.x = (gdouble) 0;
#line 210 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp20_.y = _tmp19_;
#line 210 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp21_ = self->priv->rotation;
#line 210 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_rotate (&_tmp20_, _tmp21_, &_tmp22_);
#line 210 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp23_ = self->priv->centre;
#line 210 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	point_move (&_tmp22_, &_tmp23_, &_tmp24_);
#line 210 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp25_ = g_new0 (Point, 5);
#line 210 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp25_[0] = _tmp0_;
#line 210 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp25_[1] = _tmp6_;
#line 210 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp25_[2] = _tmp12_;
#line 210 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp25_[3] = _tmp18_;
#line 210 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp25_[4] = _tmp24_;
#line 210 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp26_ = _tmp25_;
#line 210 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp26__length1 = 5;
#line 210 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	if (result_length1) {
#line 210 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		*result_length1 = _tmp26__length1;
#line 2062 "arc.c"
	}
#line 210 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	result = _tmp26_;
#line 210 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	return result;
#line 2068 "arc.c"
}


static void arc_normalize_angles (Arc* self) {
	gdouble _tmp8_;
	gdouble _tmp9_;
#line 218 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	g_return_if_fail (self != NULL);
#line 219 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	while (TRUE) {
#line 2079 "arc.c"
		gdouble _tmp0_;
		gdouble _tmp1_;
#line 219 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		_tmp0_ = self->priv->angle0;
#line 219 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		if (!(_tmp0_ < ((gdouble) 0))) {
#line 219 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
			break;
#line 2088 "arc.c"
		}
#line 219 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		_tmp1_ = self->priv->angle0;
#line 219 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		self->priv->angle0 = _tmp1_ + (2 * G_PI);
#line 2094 "arc.c"
	}
#line 220 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	while (TRUE) {
#line 2098 "arc.c"
		gdouble _tmp2_;
		gdouble _tmp3_;
#line 220 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		_tmp2_ = self->priv->angle0;
#line 220 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		if (!(_tmp2_ > (2 * G_PI))) {
#line 220 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
			break;
#line 2107 "arc.c"
		}
#line 220 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		_tmp3_ = self->priv->angle0;
#line 220 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		self->priv->angle0 = _tmp3_ - (2 * G_PI);
#line 2113 "arc.c"
	}
#line 221 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	while (TRUE) {
#line 2117 "arc.c"
		gdouble _tmp4_;
		gdouble _tmp5_;
#line 221 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		_tmp4_ = self->priv->angle1;
#line 221 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		if (!(_tmp4_ < ((gdouble) 0))) {
#line 221 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
			break;
#line 2126 "arc.c"
		}
#line 221 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		_tmp5_ = self->priv->angle1;
#line 221 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		self->priv->angle1 = _tmp5_ + (2 * G_PI);
#line 2132 "arc.c"
	}
#line 222 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	while (TRUE) {
#line 2136 "arc.c"
		gdouble _tmp6_;
		gdouble _tmp7_;
#line 222 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		_tmp6_ = self->priv->angle1;
#line 222 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		if (!(_tmp6_ > (2 * G_PI))) {
#line 222 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
			break;
#line 2145 "arc.c"
		}
#line 222 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		_tmp7_ = self->priv->angle1;
#line 222 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		self->priv->angle1 = _tmp7_ - (2 * G_PI);
#line 2151 "arc.c"
	}
#line 224 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp8_ = self->priv->angle0;
#line 224 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp9_ = self->priv->angle1;
#line 224 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	if (_tmp8_ > _tmp9_) {
#line 2159 "arc.c"
		gdouble _tmp10_;
#line 224 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		_tmp10_ = self->priv->angle1;
#line 224 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
		self->priv->angle1 = _tmp10_ + (2 * G_PI);
#line 2165 "arc.c"
	}
}


static void arc_real_draw_icon (Seed* base, cairo_t* cr, gdouble width, gdouble height) {
	Arc * self;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble* _tmp4_ = NULL;
	gdouble* args;
	gint args_length1;
	gint _args_size_;
	cairo_t* _tmp5_;
#line 227 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	self = (Arc*) base;
#line 227 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	g_return_if_fail (cr != NULL);
#line 228 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp0_ = width;
#line 228 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp1_ = height;
#line 228 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp2_ = width;
#line 228 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp3_ = height;
#line 228 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp4_ = g_new0 (gdouble, 7);
#line 228 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp4_[0] = _tmp0_ / 2;
#line 228 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp4_[1] = _tmp1_ / 2;
#line 228 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp4_[2] = _tmp2_ / 2.3;
#line 228 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp4_[3] = _tmp3_ / 2.3;
#line 228 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp4_[4] = (gdouble) 0;
#line 228 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp4_[5] = 1.4 * G_PI;
#line 228 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp4_[6] = (gdouble) 0;
#line 228 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	args = _tmp4_;
#line 228 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	args_length1 = 7;
#line 228 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_args_size_ = args_length1;
#line 229 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	seed_init_full ((Seed*) self, args, args_length1);
#line 230 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	_tmp5_ = cr;
#line 230 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	seed_draw_direct ((Seed*) self, _tmp5_, (gdouble) 1);
#line 227 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	args = (g_free (args), NULL);
#line 2223 "arc.c"
}


Arc* arc_construct (GType object_type) {
	Arc * self = NULL;
#line 19 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	self = (Arc*) seed_construct (object_type);
#line 19 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	return self;
#line 2233 "arc.c"
}


Arc* arc_new (void) {
#line 19 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	return arc_construct (TYPE_ARC);
#line 2240 "arc.c"
}


static void arc_class_init (ArcClass * klass) {
#line 19 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	arc_parent_class = g_type_class_peek_parent (klass);
#line 19 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	g_type_class_add_private (klass, sizeof (ArcPrivate));
#line 19 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	SEED_CLASS (klass)->init_default_sub = arc_real_init_default_sub;
#line 19 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	SEED_CLASS (klass)->init_full_sub = arc_real_init_full_sub;
#line 19 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	SEED_CLASS (klass)->serialize_sub = arc_real_serialize_sub;
#line 19 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	SEED_CLASS (klass)->init_distance_to_parametric = arc_real_init_distance_to_parametric;
#line 19 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	SEED_CLASS (klass)->point_raw = arc_real_point_raw;
#line 19 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	SEED_CLASS (klass)->perpendicular_angle = arc_real_perpendicular_angle;
#line 19 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	SEED_CLASS (klass)->draw_direct = arc_real_draw_direct;
#line 19 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	SEED_CLASS (klass)->draw_controls = arc_real_draw_controls;
#line 19 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	SEED_CLASS (klass)->pressed_control = arc_real_pressed_control;
#line 19 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	SEED_CLASS (klass)->save_drag_context = arc_real_save_drag_context;
#line 19 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	SEED_CLASS (klass)->drag_control = arc_real_drag_control;
#line 19 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	SEED_CLASS (klass)->move_shape = arc_real_move_shape;
#line 19 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	SEED_CLASS (klass)->points_to_snap = arc_real_points_to_snap;
#line 19 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	SEED_CLASS (klass)->draw_icon = arc_real_draw_icon;
#line 19 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	G_OBJECT_CLASS (klass)->finalize = arc_finalize;
#line 2279 "arc.c"
}


static void arc_instance_init (Arc * self) {
#line 19 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	self->priv = ARC_GET_PRIVATE (self);
#line 2286 "arc.c"
}


static void arc_finalize (GObject* obj) {
	Arc * self;
#line 19 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ARC, Arc);
#line 19 "/home/jaidi/project/mutiara/tiara/src/arc.vala"
	G_OBJECT_CLASS (arc_parent_class)->finalize (obj);
#line 2296 "arc.c"
}


GType arc_get_type (void) {
	static volatile gsize arc_type_id__volatile = 0;
	if (g_once_init_enter (&arc_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ArcClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) arc_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Arc), 0, (GInstanceInitFunc) arc_instance_init, NULL };
		GType arc_type_id;
		arc_type_id = g_type_register_static (TYPE_SEED, "Arc", &g_define_type_info, 0);
		g_once_init_leave (&arc_type_id__volatile, arc_type_id);
	}
	return arc_type_id__volatile;
}



