/* point.c generated by valac 0.17.2, the Vala compiler
 * generated from point.vala, do not modify */

/*  Mutiara motif designer.
Copyright (C) 2011  Nor Jaidi Tuah

This file is part of Mutiara.

Mutiara is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>
#include <cairo.h>
#include <gobject/gvaluecollector.h>


#define TYPE_POINT (point_get_type ())
typedef struct _Point Point;

#define TYPE_ROLE (role_get_type ())

#define TYPE_RENDER_STYLE (render_style_get_type ())

#define TYPE_PROJECTION (projection_get_type ())
#define PROJECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PROJECTION, Projection))
#define PROJECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PROJECTION, ProjectionClass))
#define IS_PROJECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PROJECTION))
#define IS_PROJECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PROJECTION))
#define PROJECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PROJECTION, ProjectionClass))

typedef struct _Projection Projection;
typedef struct _ProjectionClass ProjectionClass;
typedef struct _ProjectionPrivate ProjectionPrivate;

#define TYPE_SEED (seed_get_type ())
#define SEED(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SEED, Seed))
#define SEED_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SEED, SeedClass))
#define IS_SEED(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SEED))
#define IS_SEED_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SEED))
#define SEED_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SEED, SeedClass))

typedef struct _Seed Seed;
typedef struct _SeedClass SeedClass;
#define _projection_unref0(var) ((var == NULL) ? NULL : (var = (projection_unref (var), NULL)))

#define TYPE_FLIP (flip_get_type ())
typedef struct _SeedPrivate SeedPrivate;

#define TYPE_TWEAK (tweak_get_type ())
typedef struct _Tweak Tweak;

#define TYPE_RGBA (rgba_get_type ())
typedef struct _RGBA RGBA;
typedef struct _ParamSpecProjection ParamSpecProjection;

struct _Point {
	gdouble x;
	gdouble y;
};

typedef enum  {
	ROLE_DUAL = 0,
	ROLE_MOTIF = 1,
	ROLE_BASE = 2
} Role;

typedef enum  {
	RENDER_STYLE_THIN = 0,
	RENDER_STYLE_THICK = 1,
	RENDER_STYLE_HOLLOW = 2,
	RENDER_STYLE_FILLED = 3,
	RENDER_STYLE_CLOSED = 4,
	RENDER_STYLE_NONE = 5
} RenderStyle;

struct _Projection {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ProjectionPrivate * priv;
};

struct _ProjectionClass {
	GTypeClass parent_class;
	void (*finalize) (Projection *self);
};

struct _ProjectionPrivate {
	Seed* seed;
	Projection* parent;
	gdouble a;
	gdouble b;
	gdouble c;
	gdouble d;
	gdouble e;
	gdouble f;
};

typedef enum  {
	FLIP_NONE = 0,
	FLIP_Y = 1,
	FLIP_X = 2,
	FLIP_XY = 3
} Flip;

struct _Tweak {
	gdouble scale_x;
	gdouble scale_y;
	gdouble rotate;
	gdouble move_x;
	gdouble move_y;
};

struct _RGBA {
	gdouble r;
	gdouble g;
	gdouble b;
	gdouble a;
};

struct _Seed {
	GObject parent_instance;
	SeedPrivate * priv;
	gboolean debug;
	Role role;
	gdouble base_offset;
	Flip flip_even;
	Flip flip_odd;
	Tweak tweak;
	gdouble width0;
	gdouble width1;
	gint num_segment;
	gint level_of_detail;
	RGBA color;
	gdouble color_mix;
	RenderStyle render_style;
	gdouble* distance_to_param;
	gint distance_to_param_length1;
	Projection** projection;
	gint projection_length1;
	gint selected_control;
	Point pressed_point;
};

struct _SeedClass {
	GObjectClass parent_class;
	void (*init_default_sub) (Seed* self, Point* p);
	void (*init_full_sub) (Seed* self, gdouble* args, int args_length1);
	gchar* (*serialize_sub) (Seed* self);
	void (*point_raw) (Seed* self, gdouble t, Point* result);
	void (*init_distance_to_parametric) (Seed* self);
	gdouble (*perpendicular_angle) (Seed* self, gdouble t);
	void (*draw_direct) (Seed* self, cairo_t* cr, gdouble scale);
	void (*draw_controls) (Seed* self, cairo_t* cr, gdouble scale);
	gint (*pressed_control) (Seed* self, Point* p, gdouble scale);
	void (*save_drag_context) (Seed* self);
	void (*move_shape) (Seed* self, gdouble delta_x, gdouble delta_y);
	void (*drag_control) (Seed* self, Point* p, gdouble scale, gboolean snap_on, gdouble grid_size, gdouble snap_angle);
	Point* (*points_to_snap) (Seed* self, int* result_length1);
	void (*draw_icon) (Seed* self, cairo_t* cr, gdouble width, gdouble height);
};

struct _ParamSpecProjection {
	GParamSpec parent_instance;
};


static gpointer projection_parent_class = NULL;

GType point_get_type (void) G_GNUC_CONST;
Point* point_dup (const Point* self);
void point_free (Point* self);
gdouble point_hypot (Point* p0, Point* p1);
void point_rotate (Point *self, gdouble angle, Point* result);
void point_scale (Point *self, gdouble sx, gdouble sy, Point* result);
void point_move (Point *self, Point* new_origin, Point* result);
void point_move_xy (Point *self, gdouble x, gdouble y, Point* result);
GType role_get_type (void) G_GNUC_CONST;
GType render_style_get_type (void) G_GNUC_CONST;
gpointer projection_ref (gpointer instance);
void projection_unref (gpointer instance);
GParamSpec* param_spec_projection (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_projection (GValue* value, gpointer v_object);
void value_take_projection (GValue* value, gpointer v_object);
gpointer value_get_projection (const GValue* value);
GType projection_get_type (void) G_GNUC_CONST;
GType seed_get_type (void) G_GNUC_CONST;
#define PROJECTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PROJECTION, ProjectionPrivate))
enum  {
	PROJECTION_DUMMY_PROPERTY
};
GType flip_get_type (void) G_GNUC_CONST;
Projection* projection_new (Projection* parent, Seed* seed, gdouble t0, gdouble t1, Flip flip);
Projection* projection_construct (GType object_type, Projection* parent, Seed* seed, gdouble t0, gdouble t1, Flip flip);
static void projection_add (Projection* self, gdouble p, gdouble q, gdouble r, gdouble s);
GType tweak_get_type (void) G_GNUC_CONST;
Tweak* tweak_dup (const Tweak* self);
void tweak_free (Tweak* self);
GType rgba_get_type (void) G_GNUC_CONST;
RGBA* rgba_dup (const RGBA* self);
void rgba_free (RGBA* self);
gboolean flip_x (Flip self);
gboolean flip_y (Flip self);
Projection* projection_new_copy (Projection* parent, Projection* source);
Projection* projection_construct_copy (GType object_type, Projection* parent, Projection* source);
void projection_map (Projection* pr, Point* p, Point* result);
void seed_distant_point (Seed* self, gdouble t, gdouble distance, Point* result);
static void projection_finalize (Projection* obj);
void rgba_init (RGBA *self, gdouble r, gdouble g, gdouble b, gdouble a);


gdouble point_hypot (Point* p0, Point* p1) {
	gdouble result = 0.0;
	Point _tmp0_;
	gdouble _tmp1_;
	Point _tmp2_;
	gdouble _tmp3_;
	Point _tmp4_;
	gdouble _tmp5_;
	Point _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_ = 0.0;
#line 23 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	g_return_val_if_fail (p0 != NULL, 0.0);
#line 23 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	g_return_val_if_fail (p1 != NULL, 0.0);
#line 24 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp0_ = *p1;
#line 24 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp1_ = _tmp0_.y;
#line 24 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp2_ = *p0;
#line 24 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp3_ = _tmp2_.y;
#line 24 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp4_ = *p1;
#line 24 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp5_ = _tmp4_.x;
#line 24 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp6_ = *p0;
#line 24 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp7_ = _tmp6_.x;
#line 24 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp8_ = hypot (_tmp1_ - _tmp3_, _tmp5_ - _tmp7_);
#line 24 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	result = _tmp8_;
#line 24 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	return result;
#line 265 "point.c"
}


void point_rotate (Point *self, gdouble angle, Point* result) {
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_ = 0.0;
	Point _tmp12_ = {0};
#line 28 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp0_ = (*self).x;
#line 28 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp1_ = angle;
#line 28 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp2_ = cos (_tmp1_);
#line 28 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp3_ = (*self).y;
#line 28 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp4_ = angle;
#line 28 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp5_ = sin (_tmp4_);
#line 28 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp6_ = (*self).x;
#line 28 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp7_ = angle;
#line 28 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp8_ = sin (_tmp7_);
#line 28 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp9_ = (*self).y;
#line 28 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp10_ = angle;
#line 28 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp11_ = cos (_tmp10_);
#line 28 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	memset (&_tmp12_, 0, sizeof (Point));
#line 28 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp12_.x = (_tmp0_ * _tmp2_) - (_tmp3_ * _tmp5_);
#line 28 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp12_.y = (_tmp6_ * _tmp8_) + (_tmp9_ * _tmp11_);
#line 28 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	*result = _tmp12_;
#line 28 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	return;
#line 317 "point.c"
}


void point_scale (Point *self, gdouble sx, gdouble sy, Point* result) {
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	Point _tmp4_ = {0};
#line 34 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp0_ = (*self).x;
#line 34 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp1_ = sx;
#line 34 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp2_ = (*self).y;
#line 34 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp3_ = sy;
#line 34 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	memset (&_tmp4_, 0, sizeof (Point));
#line 34 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp4_.x = _tmp0_ * _tmp1_;
#line 34 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp4_.y = _tmp2_ * _tmp3_;
#line 34 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	*result = _tmp4_;
#line 34 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	return;
#line 345 "point.c"
}


void point_move (Point *self, Point* new_origin, Point* result) {
	gdouble _tmp0_;
	Point _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	Point _tmp4_;
	gdouble _tmp5_;
	Point _tmp6_ = {0};
#line 37 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	g_return_if_fail (new_origin != NULL);
#line 38 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp0_ = (*self).x;
#line 38 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp1_ = *new_origin;
#line 38 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp2_ = _tmp1_.x;
#line 38 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp3_ = (*self).y;
#line 38 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp4_ = *new_origin;
#line 38 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp5_ = _tmp4_.y;
#line 38 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	memset (&_tmp6_, 0, sizeof (Point));
#line 38 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp6_.x = _tmp0_ + _tmp2_;
#line 38 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp6_.y = _tmp3_ + _tmp5_;
#line 38 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	*result = _tmp6_;
#line 38 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	return;
#line 381 "point.c"
}


void point_move_xy (Point *self, gdouble x, gdouble y, Point* result) {
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	Point _tmp4_ = {0};
#line 42 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp0_ = (*self).x;
#line 42 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp1_ = x;
#line 42 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp2_ = (*self).y;
#line 42 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp3_ = y;
#line 42 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	memset (&_tmp4_, 0, sizeof (Point));
#line 42 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp4_.x = _tmp0_ + _tmp1_;
#line 42 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp4_.y = _tmp2_ + _tmp3_;
#line 42 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	*result = _tmp4_;
#line 42 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	return;
#line 409 "point.c"
}


Point* point_dup (const Point* self) {
	Point* dup;
#line 19 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	dup = g_new0 (Point, 1);
#line 19 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	memcpy (dup, self, sizeof (Point));
#line 19 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	return dup;
#line 421 "point.c"
}


void point_free (Point* self) {
#line 19 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	g_free (self);
#line 428 "point.c"
}


GType point_get_type (void) {
	static volatile gsize point_type_id__volatile = 0;
	if (g_once_init_enter (&point_type_id__volatile)) {
		GType point_type_id;
		point_type_id = g_boxed_type_register_static ("Point", (GBoxedCopyFunc) point_dup, (GBoxedFreeFunc) point_free);
		g_once_init_leave (&point_type_id__volatile, point_type_id);
	}
	return point_type_id__volatile;
}


GType role_get_type (void) {
	static volatile gsize role_type_id__volatile = 0;
	if (g_once_init_enter (&role_type_id__volatile)) {
		static const GEnumValue values[] = {{ROLE_DUAL, "ROLE_DUAL", "dual"}, {ROLE_MOTIF, "ROLE_MOTIF", "motif"}, {ROLE_BASE, "ROLE_BASE", "base"}, {0, NULL, NULL}};
		GType role_type_id;
		role_type_id = g_enum_register_static ("Role", values);
		g_once_init_leave (&role_type_id__volatile, role_type_id);
	}
	return role_type_id__volatile;
}


GType render_style_get_type (void) {
	static volatile gsize render_style_type_id__volatile = 0;
	if (g_once_init_enter (&render_style_type_id__volatile)) {
		static const GEnumValue values[] = {{RENDER_STYLE_THIN, "RENDER_STYLE_THIN", "thin"}, {RENDER_STYLE_THICK, "RENDER_STYLE_THICK", "thick"}, {RENDER_STYLE_HOLLOW, "RENDER_STYLE_HOLLOW", "hollow"}, {RENDER_STYLE_FILLED, "RENDER_STYLE_FILLED", "filled"}, {RENDER_STYLE_CLOSED, "RENDER_STYLE_CLOSED", "closed"}, {RENDER_STYLE_NONE, "RENDER_STYLE_NONE", "none"}, {0, NULL, NULL}};
		GType render_style_type_id;
		render_style_type_id = g_enum_register_static ("RenderStyle", values);
		g_once_init_leave (&render_style_type_id__volatile, render_style_type_id);
	}
	return render_style_type_id__volatile;
}


/**
 * Project using the following reference points:
 *   (0,base_offset) -> point on projection.seed at t0
 *   (1,base_offset) -> point on projection.seed at t1
 * For other points:
 *   (x,base_offset) -> point on projection.seed at t = t0 + x/(t1-t0)
 *   (x,y)   -> point at a distance of base_offset-y from (x,base_offset)
 */
static gpointer _projection_ref0 (gpointer self) {
#line 94 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	return self ? projection_ref (self) : NULL;
#line 478 "point.c"
}


Projection* projection_construct (GType object_type, Projection* parent, Seed* seed, gdouble t0, gdouble t1, Flip flip) {
	Projection* self = NULL;
	Projection* _tmp0_;
	Projection* _tmp1_;
	Seed* _tmp2_;
	Seed* _tmp3_;
	Tweak _tmp4_;
	gdouble _tmp5_;
	Seed* _tmp6_;
	Tweak _tmp7_;
	gdouble _tmp8_;
	Seed* _tmp9_;
	Tweak _tmp10_;
	gdouble _tmp11_;
	gdouble angle;
	gdouble sin = 0.0;
	gdouble cos = 0.0;
	gdouble _tmp12_;
	gdouble _tmp13_ = 0.0;
	gdouble _tmp14_ = 0.0;
	gdouble _tmp15_;
	gdouble _tmp16_;
	gdouble _tmp17_;
	gdouble _tmp18_;
	gdouble _tmp19_;
	Seed* _tmp20_;
	Tweak _tmp21_;
	gdouble _tmp22_;
	gdouble _tmp23_;
	Seed* _tmp24_;
	Tweak _tmp25_;
	gdouble _tmp26_;
	Flip _tmp27_;
	gboolean _tmp28_ = FALSE;
	Flip _tmp30_;
	gboolean _tmp31_ = FALSE;
	gdouble _tmp33_;
	gdouble _tmp34_;
	gdouble _tmp35_;
	gdouble _tmp36_;
	gdouble _tmp37_;
	Seed* _tmp38_;
	gdouble _tmp39_;
#line 93 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	g_return_val_if_fail (seed != NULL, NULL);
#line 93 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	self = (Projection*) g_type_create_instance (object_type);
#line 94 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp0_ = parent;
#line 94 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp1_ = _projection_ref0 (_tmp0_);
#line 94 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_projection_unref0 (self->priv->parent);
#line 94 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	self->priv->parent = _tmp1_;
#line 95 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp2_ = seed;
#line 95 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	self->priv->seed = _tmp2_;
#line 97 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	self->priv->a = (gdouble) 1;
#line 97 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	self->priv->d = (gdouble) 1;
#line 100 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	self->priv->e = -0.5;
#line 100 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	self->priv->f = -0.5;
#line 102 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp3_ = seed;
#line 102 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp4_ = _tmp3_->tweak;
#line 102 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp5_ = _tmp4_.scale_x;
#line 102 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp6_ = seed;
#line 102 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp7_ = _tmp6_->tweak;
#line 102 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp8_ = _tmp7_.scale_y;
#line 102 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	projection_add (self, _tmp5_, (gdouble) 0, (gdouble) 0, _tmp8_);
#line 104 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp9_ = seed;
#line 104 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp10_ = _tmp9_->tweak;
#line 104 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp11_ = _tmp10_.rotate;
#line 104 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	angle = (_tmp11_ * G_PI) / 180;
#line 106 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp12_ = angle;
#line 106 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	sincos (_tmp12_, &_tmp13_, &_tmp14_);
#line 106 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	sin = _tmp13_;
#line 106 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	cos = _tmp14_;
#line 107 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp15_ = cos;
#line 107 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp16_ = sin;
#line 107 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp17_ = sin;
#line 107 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp18_ = cos;
#line 107 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	projection_add (self, _tmp15_, _tmp16_, -_tmp17_, _tmp18_);
#line 110 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp19_ = self->priv->e;
#line 110 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp20_ = seed;
#line 110 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp21_ = _tmp20_->tweak;
#line 110 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp22_ = _tmp21_.move_x;
#line 110 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	self->priv->e = _tmp19_ + (_tmp22_ + 0.5);
#line 111 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp23_ = self->priv->f;
#line 111 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp24_ = seed;
#line 111 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp25_ = _tmp24_->tweak;
#line 111 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp26_ = _tmp25_.move_y;
#line 111 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	self->priv->f = _tmp23_ + (_tmp26_ + 0.5);
#line 113 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp27_ = flip;
#line 113 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp28_ = flip_x (_tmp27_);
#line 113 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	if (_tmp28_) {
#line 615 "point.c"
		gdouble _tmp29_;
#line 114 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		projection_add (self, (gdouble) (-1), (gdouble) 0, (gdouble) 0, (gdouble) 1);
#line 115 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		_tmp29_ = self->priv->e;
#line 115 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		self->priv->e = _tmp29_ + 1;
#line 623 "point.c"
	}
#line 117 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp30_ = flip;
#line 117 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp31_ = flip_y (_tmp30_);
#line 117 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	if (_tmp31_) {
#line 631 "point.c"
		gdouble _tmp32_;
#line 118 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		projection_add (self, (gdouble) 1, (gdouble) 0, (gdouble) 0, (gdouble) (-1));
#line 119 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		_tmp32_ = self->priv->f;
#line 119 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		self->priv->f = _tmp32_ + 1;
#line 639 "point.c"
	}
#line 124 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp33_ = t1;
#line 124 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp34_ = t0;
#line 124 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	projection_add (self, _tmp33_ - _tmp34_, (gdouble) 0, (gdouble) 0, (gdouble) (-1));
#line 125 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp35_ = self->priv->e;
#line 125 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp36_ = t0;
#line 125 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	self->priv->e = _tmp35_ + _tmp36_;
#line 126 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp37_ = self->priv->f;
#line 126 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp38_ = seed;
#line 126 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp39_ = _tmp38_->base_offset;
#line 126 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	self->priv->f = _tmp37_ + _tmp39_;
#line 93 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	return self;
#line 663 "point.c"
}


Projection* projection_new (Projection* parent, Seed* seed, gdouble t0, gdouble t1, Flip flip) {
#line 93 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	return projection_construct (TYPE_PROJECTION, parent, seed, t0, t1, flip);
#line 670 "point.c"
}


Projection* projection_construct_copy (GType object_type, Projection* parent, Projection* source) {
	Projection* self = NULL;
	Projection* _tmp0_;
	Projection* _tmp1_;
	Projection* _tmp2_;
	Seed* _tmp3_;
	Projection* _tmp4_;
	gdouble _tmp5_;
	Projection* _tmp6_;
	gdouble _tmp7_;
	Projection* _tmp8_;
	gdouble _tmp9_;
	Projection* _tmp10_;
	gdouble _tmp11_;
	Projection* _tmp12_;
	gdouble _tmp13_;
	Projection* _tmp14_;
	gdouble _tmp15_;
#line 129 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	g_return_val_if_fail (source != NULL, NULL);
#line 129 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	self = (Projection*) g_type_create_instance (object_type);
#line 130 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp0_ = parent;
#line 130 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp1_ = _projection_ref0 (_tmp0_);
#line 130 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_projection_unref0 (self->priv->parent);
#line 130 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	self->priv->parent = _tmp1_;
#line 131 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp2_ = source;
#line 131 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp3_ = _tmp2_->priv->seed;
#line 131 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	self->priv->seed = _tmp3_;
#line 132 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp4_ = source;
#line 132 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp5_ = _tmp4_->priv->a;
#line 132 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	self->priv->a = _tmp5_;
#line 133 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp6_ = source;
#line 133 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp7_ = _tmp6_->priv->b;
#line 133 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	self->priv->b = _tmp7_;
#line 134 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp8_ = source;
#line 134 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp9_ = _tmp8_->priv->c;
#line 134 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	self->priv->c = _tmp9_;
#line 135 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp10_ = source;
#line 135 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp11_ = _tmp10_->priv->d;
#line 135 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	self->priv->d = _tmp11_;
#line 136 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp12_ = source;
#line 136 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp13_ = _tmp12_->priv->e;
#line 136 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	self->priv->e = _tmp13_;
#line 137 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp14_ = source;
#line 137 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp15_ = _tmp14_->priv->f;
#line 137 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	self->priv->f = _tmp15_;
#line 129 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	return self;
#line 748 "point.c"
}


Projection* projection_new_copy (Projection* parent, Projection* source) {
#line 129 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	return projection_construct_copy (TYPE_PROJECTION, parent, source);
#line 755 "point.c"
}


/**
 * Return p * abcedf * seed
 */
void projection_map (Projection* pr, Point* p, Point* result) {
	Point _tmp28_;
#line 143 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	g_return_if_fail (p != NULL);
#line 144 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	while (TRUE) {
#line 768 "point.c"
		Projection* _tmp0_;
		Projection* _tmp1_;
		gdouble _tmp2_;
		Point _tmp3_;
		gdouble _tmp4_;
		Projection* _tmp5_;
		gdouble _tmp6_;
		Point _tmp7_;
		gdouble _tmp8_;
		Projection* _tmp9_;
		gdouble _tmp10_;
		gdouble x;
		Projection* _tmp11_;
		gdouble _tmp12_;
		Point _tmp13_;
		gdouble _tmp14_;
		Projection* _tmp15_;
		gdouble _tmp16_;
		Point _tmp17_;
		gdouble _tmp18_;
		Projection* _tmp19_;
		gdouble _tmp20_;
		gdouble y;
		Projection* _tmp21_;
		Seed* _tmp22_;
		gdouble _tmp23_;
		gdouble _tmp24_;
		Point _tmp25_ = {0};
		Projection* _tmp26_;
		Projection* _tmp27_;
#line 144 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		_tmp0_ = pr;
#line 144 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		if (!(_tmp0_ != NULL)) {
#line 144 "/home/jaidi/project/mutiara/tiara/src/point.vala"
			break;
#line 805 "point.c"
		}
#line 146 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		_tmp1_ = pr;
#line 146 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		_tmp2_ = _tmp1_->priv->a;
#line 146 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		_tmp3_ = *p;
#line 146 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		_tmp4_ = _tmp3_.x;
#line 146 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		_tmp5_ = pr;
#line 146 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		_tmp6_ = _tmp5_->priv->c;
#line 146 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		_tmp7_ = *p;
#line 146 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		_tmp8_ = _tmp7_.y;
#line 146 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		_tmp9_ = pr;
#line 146 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		_tmp10_ = _tmp9_->priv->e;
#line 146 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		x = ((_tmp2_ * _tmp4_) + (_tmp6_ * _tmp8_)) + _tmp10_;
#line 147 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		_tmp11_ = pr;
#line 147 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		_tmp12_ = _tmp11_->priv->b;
#line 147 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		_tmp13_ = *p;
#line 147 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		_tmp14_ = _tmp13_.x;
#line 147 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		_tmp15_ = pr;
#line 147 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		_tmp16_ = _tmp15_->priv->d;
#line 147 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		_tmp17_ = *p;
#line 147 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		_tmp18_ = _tmp17_.y;
#line 147 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		_tmp19_ = pr;
#line 147 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		_tmp20_ = _tmp19_->priv->f;
#line 147 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		y = ((_tmp12_ * _tmp14_) + (_tmp16_ * _tmp18_)) + _tmp20_;
#line 149 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		_tmp21_ = pr;
#line 149 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		_tmp22_ = _tmp21_->priv->seed;
#line 149 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		_tmp23_ = x;
#line 149 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		_tmp24_ = y;
#line 149 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		seed_distant_point (_tmp22_, _tmp23_, _tmp24_, &_tmp25_);
#line 149 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		*p = _tmp25_;
#line 150 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		_tmp26_ = pr;
#line 150 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		_tmp27_ = _tmp26_->priv->parent;
#line 150 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		pr = _tmp27_;
#line 869 "point.c"
	}
#line 152 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp28_ = *p;
#line 152 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	*result = _tmp28_;
#line 152 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	return;
#line 877 "point.c"
}


/**
 * abcdef = abcdef * pqrs00
 */
static void projection_add (Projection* self, gdouble p, gdouble q, gdouble r, gdouble s) {
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble ta;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble tb;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	gdouble tc;
	gdouble _tmp12_;
	gdouble _tmp13_;
	gdouble _tmp14_;
	gdouble _tmp15_;
	gdouble td;
	gdouble _tmp16_;
	gdouble _tmp17_;
	gdouble _tmp18_;
	gdouble _tmp19_;
	gdouble te;
	gdouble _tmp20_;
	gdouble _tmp21_;
	gdouble _tmp22_;
	gdouble _tmp23_;
	gdouble tf;
#line 158 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	g_return_if_fail (self != NULL);
#line 159 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp0_ = self->priv->a;
#line 159 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp1_ = p;
#line 159 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp2_ = self->priv->b;
#line 159 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp3_ = r;
#line 159 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	ta = (_tmp0_ * _tmp1_) + (_tmp2_ * _tmp3_);
#line 160 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp4_ = self->priv->a;
#line 160 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp5_ = q;
#line 160 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp6_ = self->priv->b;
#line 160 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp7_ = s;
#line 160 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	tb = (_tmp4_ * _tmp5_) + (_tmp6_ * _tmp7_);
#line 161 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp8_ = self->priv->c;
#line 161 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp9_ = p;
#line 161 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp10_ = self->priv->d;
#line 161 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp11_ = r;
#line 161 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	tc = (_tmp8_ * _tmp9_) + (_tmp10_ * _tmp11_);
#line 162 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp12_ = self->priv->c;
#line 162 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp13_ = q;
#line 162 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp14_ = self->priv->d;
#line 162 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp15_ = s;
#line 162 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	td = (_tmp12_ * _tmp13_) + (_tmp14_ * _tmp15_);
#line 163 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp16_ = self->priv->e;
#line 163 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp17_ = p;
#line 163 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp18_ = self->priv->f;
#line 163 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp19_ = r;
#line 163 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	te = (_tmp16_ * _tmp17_) + (_tmp18_ * _tmp19_);
#line 164 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp20_ = self->priv->e;
#line 164 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp21_ = q;
#line 164 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp22_ = self->priv->f;
#line 164 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp23_ = s;
#line 164 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	tf = (_tmp20_ * _tmp21_) + (_tmp22_ * _tmp23_);
#line 165 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	self->priv->a = ta;
#line 165 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	self->priv->b = tb;
#line 165 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	self->priv->c = tc;
#line 165 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	self->priv->d = td;
#line 165 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	self->priv->e = te;
#line 165 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	self->priv->f = tf;
#line 989 "point.c"
}


static void value_projection_init (GValue* value) {
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	value->data[0].v_pointer = NULL;
#line 996 "point.c"
}


static void value_projection_free_value (GValue* value) {
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	if (value->data[0].v_pointer) {
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		projection_unref (value->data[0].v_pointer);
#line 1005 "point.c"
	}
}


static void value_projection_copy_value (const GValue* src_value, GValue* dest_value) {
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	if (src_value->data[0].v_pointer) {
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		dest_value->data[0].v_pointer = projection_ref (src_value->data[0].v_pointer);
#line 1015 "point.c"
	} else {
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1019 "point.c"
	}
}


static gpointer value_projection_peek_pointer (const GValue* value) {
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	return value->data[0].v_pointer;
#line 1027 "point.c"
}


static gchar* value_projection_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	if (collect_values[0].v_pointer) {
#line 1034 "point.c"
		Projection* object;
		object = collect_values[0].v_pointer;
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		if (object->parent_instance.g_class == NULL) {
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1041 "point.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1045 "point.c"
		}
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		value->data[0].v_pointer = projection_ref (object);
#line 1049 "point.c"
	} else {
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		value->data[0].v_pointer = NULL;
#line 1053 "point.c"
	}
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	return NULL;
#line 1057 "point.c"
}


static gchar* value_projection_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	Projection** object_p;
	object_p = collect_values[0].v_pointer;
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	if (!object_p) {
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1068 "point.c"
	}
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	if (!value->data[0].v_pointer) {
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		*object_p = NULL;
#line 1074 "point.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		*object_p = value->data[0].v_pointer;
#line 1078 "point.c"
	} else {
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		*object_p = projection_ref (value->data[0].v_pointer);
#line 1082 "point.c"
	}
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	return NULL;
#line 1086 "point.c"
}


GParamSpec* param_spec_projection (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecProjection* spec;
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PROJECTION), NULL);
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	return G_PARAM_SPEC (spec);
#line 1100 "point.c"
}


gpointer value_get_projection (const GValue* value) {
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PROJECTION), NULL);
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	return value->data[0].v_pointer;
#line 1109 "point.c"
}


void value_set_projection (GValue* value, gpointer v_object) {
	Projection* old;
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PROJECTION));
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	old = value->data[0].v_pointer;
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	if (v_object) {
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PROJECTION));
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		value->data[0].v_pointer = v_object;
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		projection_ref (value->data[0].v_pointer);
#line 1129 "point.c"
	} else {
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		value->data[0].v_pointer = NULL;
#line 1133 "point.c"
	}
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	if (old) {
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		projection_unref (old);
#line 1139 "point.c"
	}
}


void value_take_projection (GValue* value, gpointer v_object) {
	Projection* old;
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PROJECTION));
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	old = value->data[0].v_pointer;
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	if (v_object) {
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PROJECTION));
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		value->data[0].v_pointer = v_object;
#line 1158 "point.c"
	} else {
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		value->data[0].v_pointer = NULL;
#line 1162 "point.c"
	}
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	if (old) {
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		projection_unref (old);
#line 1168 "point.c"
	}
}


static void projection_class_init (ProjectionClass * klass) {
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	projection_parent_class = g_type_class_peek_parent (klass);
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	PROJECTION_CLASS (klass)->finalize = projection_finalize;
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	g_type_class_add_private (klass, sizeof (ProjectionPrivate));
#line 1180 "point.c"
}


static void projection_instance_init (Projection * self) {
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	self->priv = PROJECTION_GET_PRIVATE (self);
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	self->ref_count = 1;
#line 1189 "point.c"
}


static void projection_finalize (Projection* obj) {
	Projection * self;
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PROJECTION, Projection);
#line 72 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_projection_unref0 (self->priv->parent);
#line 1199 "point.c"
}


GType projection_get_type (void) {
	static volatile gsize projection_type_id__volatile = 0;
	if (g_once_init_enter (&projection_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_projection_init, value_projection_free_value, value_projection_copy_value, value_projection_peek_pointer, "p", value_projection_collect_value, "p", value_projection_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (ProjectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) projection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Projection), 0, (GInstanceInitFunc) projection_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType projection_type_id;
		projection_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Projection", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&projection_type_id__volatile, projection_type_id);
	}
	return projection_type_id__volatile;
}


gpointer projection_ref (gpointer instance) {
	Projection* self;
	self = instance;
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	g_atomic_int_inc (&self->ref_count);
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	return instance;
#line 1224 "point.c"
}


void projection_unref (gpointer instance) {
	Projection* self;
	self = instance;
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		PROJECTION_GET_CLASS (self)->finalize (self);
#line 70 "/home/jaidi/project/mutiara/tiara/src/point.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1237 "point.c"
	}
}


void rgba_init (RGBA *self, gdouble r, gdouble g, gdouble b, gdouble a) {
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
#line 175 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	memset (self, 0, sizeof (RGBA));
#line 176 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp0_ = r;
#line 176 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	(*self).r = _tmp0_;
#line 177 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp1_ = g;
#line 177 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	(*self).g = _tmp1_;
#line 178 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp2_ = b;
#line 178 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	(*self).b = _tmp2_;
#line 179 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	_tmp3_ = a;
#line 179 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	(*self).a = _tmp3_;
#line 1265 "point.c"
}


RGBA* rgba_dup (const RGBA* self) {
	RGBA* dup;
#line 169 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	dup = g_new0 (RGBA, 1);
#line 169 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	memcpy (dup, self, sizeof (RGBA));
#line 169 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	return dup;
#line 1277 "point.c"
}


void rgba_free (RGBA* self) {
#line 169 "/home/jaidi/project/mutiara/tiara/src/point.vala"
	g_free (self);
#line 1284 "point.c"
}


GType rgba_get_type (void) {
	static volatile gsize rgba_type_id__volatile = 0;
	if (g_once_init_enter (&rgba_type_id__volatile)) {
		GType rgba_type_id;
		rgba_type_id = g_boxed_type_register_static ("RGBA", (GBoxedCopyFunc) rgba_dup, (GBoxedFreeFunc) rgba_free);
		g_once_init_leave (&rgba_type_id__volatile, rgba_type_id);
	}
	return rgba_type_id__volatile;
}



