/* util.c generated by valac 0.17.2, the Vala compiler
 * generated from util.vala, do not modify */

/*  Mutiara motif designer.
Copyright (C) 2011  Nor Jaidi Tuah

This file is part of Mutiara.

Mutiara is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

typedef void (*UtilContentsDelegate) (GtkGrid* grid, void* user_data);

extern GtkWindow* main_window;
extern GtkActionGroup* action_group;

gboolean util_debug_on (void);
gchar* util_format (gdouble n, gint decimal_places);
GtkLabel* util_label (const gchar* label_text);
GtkLabel* util_title (const gchar* label_text);
GtkLabel* util_label_centered (const gchar* label_text);
void util_attach (GtkGrid* grid, gint y, const gchar* label_text, GtkWidget* widget);
GtkDialog* util_make_dialog (const gchar* title, const gchar* ok_text, UtilContentsDelegate put_contents, void* put_contents_target);
gchar** util_action_names (int* result_length1);
void util_resolve_accelerator_clashes (GtkWidget* widget);
static gboolean __lambda7_ (GdkEventFocus* e);
static gboolean ___lambda7__gtk_widget_focus_in_event (GtkWidget* _sender, GdkEventFocus* event, gpointer self);
static gboolean __lambda8_ (GdkEventFocus* e);
static gboolean ___lambda8__gtk_widget_focus_out_event (GtkWidget* _sender, GdkEventFocus* event, gpointer self);
GtkSpinButton* util_make_spin_button (gdouble min, gdouble max, gdouble step);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);

static GRegex* _tmp_regex_0 = NULL;

gboolean util_debug_on (void) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
#line 26 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_tmp0_ = g_getenv ("MUTIARA_DEBUG");
#line 26 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	result = _tmp0_ != NULL;
#line 26 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	return result;
#line 70 "util.c"
}


/**
 * Remove trailing zeros and decimal point.
 * e.g., 2.000 => 2
 *       5.240 => 5.24
 */
static inline GRegex* _thread_safe_regex_init (GRegex** re, const gchar * pattern, GRegexMatchFlags match_options) {
#line 38 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	if (g_once_init_enter ((volatile gsize*) re)) {
#line 38 "/home/jaidi/project/mutiara/tiara/src/util.vala"
		GRegex* val = g_regex_new (pattern, match_options, 0, NULL);
#line 38 "/home/jaidi/project/mutiara/tiara/src/util.vala"
		g_once_init_leave ((volatile gsize*) re, (gsize) val);
#line 86 "util.c"
	}
#line 38 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	return *re;
#line 90 "util.c"
}


gchar* util_format (gdouble n, gint decimal_places) {
	gchar* result = NULL;
	gint _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* format_string;
	const gchar* _tmp2_;
	gdouble _tmp3_;
	gchar* _tmp4_ = NULL;
	gchar* number;
	GError * _inner_error_ = NULL;
#line 35 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_tmp0_ = decimal_places;
#line 35 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_tmp1_ = g_strdup_printf ("%%.%df", _tmp0_);
#line 35 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	format_string = _tmp1_;
#line 36 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_tmp2_ = format_string;
#line 36 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_tmp3_ = n;
#line 36 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_tmp4_ = g_strdup_printf (_tmp2_, _tmp3_);
#line 36 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	number = _tmp4_;
#line 118 "util.c"
	{
		const gchar* _tmp5_;
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_;
		const gchar* _tmp8_;
#line 38 "/home/jaidi/project/mutiara/tiara/src/util.vala"
		_tmp5_ = number;
#line 38 "/home/jaidi/project/mutiara/tiara/src/util.vala"
		_tmp6_ = g_regex_replace (_thread_safe_regex_init (&_tmp_regex_0, "\\.?0+$", 0), _tmp5_, (gssize) (-1), 0, "", 0, &_inner_error_);
#line 38 "/home/jaidi/project/mutiara/tiara/src/util.vala"
		_tmp7_ = _tmp6_;
#line 38 "/home/jaidi/project/mutiara/tiara/src/util.vala"
		if (_inner_error_ != NULL) {
#line 38 "/home/jaidi/project/mutiara/tiara/src/util.vala"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 134 "util.c"
				goto __catch22_g_regex_error;
			}
#line 38 "/home/jaidi/project/mutiara/tiara/src/util.vala"
			_g_free0 (number);
#line 38 "/home/jaidi/project/mutiara/tiara/src/util.vala"
			_g_free0 (format_string);
#line 38 "/home/jaidi/project/mutiara/tiara/src/util.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 38 "/home/jaidi/project/mutiara/tiara/src/util.vala"
			g_clear_error (&_inner_error_);
#line 38 "/home/jaidi/project/mutiara/tiara/src/util.vala"
			return NULL;
#line 147 "util.c"
		}
#line 38 "/home/jaidi/project/mutiara/tiara/src/util.vala"
		_g_free0 (number);
#line 38 "/home/jaidi/project/mutiara/tiara/src/util.vala"
		number = _tmp7_;
#line 39 "/home/jaidi/project/mutiara/tiara/src/util.vala"
		_tmp8_ = number;
#line 39 "/home/jaidi/project/mutiara/tiara/src/util.vala"
		if (g_strcmp0 (_tmp8_, "-0") == 0) {
#line 157 "util.c"
			gchar* _tmp9_;
#line 39 "/home/jaidi/project/mutiara/tiara/src/util.vala"
			_tmp9_ = g_strdup ("0");
#line 39 "/home/jaidi/project/mutiara/tiara/src/util.vala"
			result = _tmp9_;
#line 39 "/home/jaidi/project/mutiara/tiara/src/util.vala"
			_g_free0 (number);
#line 39 "/home/jaidi/project/mutiara/tiara/src/util.vala"
			_g_free0 (format_string);
#line 39 "/home/jaidi/project/mutiara/tiara/src/util.vala"
			return result;
#line 169 "util.c"
		} else {
#line 40 "/home/jaidi/project/mutiara/tiara/src/util.vala"
			result = number;
#line 40 "/home/jaidi/project/mutiara/tiara/src/util.vala"
			_g_free0 (format_string);
#line 40 "/home/jaidi/project/mutiara/tiara/src/util.vala"
			return result;
#line 177 "util.c"
		}
	}
	goto __finally22;
	__catch22_g_regex_error:
	{
		GError* e = NULL;
		GError* _tmp10_;
		const gchar* _tmp11_;
#line 37 "/home/jaidi/project/mutiara/tiara/src/util.vala"
		e = _inner_error_;
#line 37 "/home/jaidi/project/mutiara/tiara/src/util.vala"
		_inner_error_ = NULL;
#line 43 "/home/jaidi/project/mutiara/tiara/src/util.vala"
		_tmp10_ = e;
#line 43 "/home/jaidi/project/mutiara/tiara/src/util.vala"
		_tmp11_ = _tmp10_->message;
#line 43 "/home/jaidi/project/mutiara/tiara/src/util.vala"
		g_print ("%s\n", _tmp11_);
#line 44 "/home/jaidi/project/mutiara/tiara/src/util.vala"
		result = number;
#line 44 "/home/jaidi/project/mutiara/tiara/src/util.vala"
		_g_error_free0 (e);
#line 44 "/home/jaidi/project/mutiara/tiara/src/util.vala"
		_g_free0 (format_string);
#line 44 "/home/jaidi/project/mutiara/tiara/src/util.vala"
		return result;
#line 204 "util.c"
	}
	__finally22:
#line 37 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_g_free0 (number);
#line 37 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_g_free0 (format_string);
#line 37 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 37 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	g_clear_error (&_inner_error_);
#line 37 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	return NULL;
#line 217 "util.c"
}


/**
 * Create left-justified, left-positioned label
 */
GtkLabel* util_label (const gchar* label_text) {
	GtkLabel* result = NULL;
	const gchar* _tmp0_;
	GtkLabel* _tmp1_;
	GtkLabel* label;
#line 51 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	g_return_val_if_fail (label_text != NULL, NULL);
#line 52 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_tmp0_ = label_text;
#line 52 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_tmp1_ = (GtkLabel*) gtk_label_new (_tmp0_);
#line 52 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	g_object_ref_sink (_tmp1_);
#line 52 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	label = _tmp1_;
#line 53 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	gtk_widget_set_halign ((GtkWidget*) label, GTK_ALIGN_START);
#line 54 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	gtk_label_set_justify (label, GTK_JUSTIFY_LEFT);
#line 55 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	result = label;
#line 55 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	return result;
#line 247 "util.c"
}


/**
 * Create title label
 */
GtkLabel* util_title (const gchar* label_text) {
	GtkLabel* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GtkLabel* _tmp5_ = NULL;
	GtkLabel* _tmp6_;
	GtkLabel* label;
#line 61 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	g_return_val_if_fail (label_text != NULL, NULL);
#line 62 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_tmp0_ = label_text;
#line 62 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_tmp1_ = g_strconcat ("<b>", _tmp0_, NULL);
#line 62 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_tmp2_ = _tmp1_;
#line 62 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_tmp3_ = g_strconcat (_tmp2_, "</b>", NULL);
#line 62 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_tmp4_ = _tmp3_;
#line 62 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_tmp5_ = util_label_centered (_tmp4_);
#line 62 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_tmp6_ = _tmp5_;
#line 62 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_g_free0 (_tmp4_);
#line 62 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_g_free0 (_tmp2_);
#line 62 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	label = _tmp6_;
#line 63 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	gtk_label_set_use_markup (label, TRUE);
#line 64 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	result = label;
#line 64 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	return result;
#line 292 "util.c"
}


/**
 * Create centered label
 */
GtkLabel* util_label_centered (const gchar* label_text) {
	GtkLabel* result = NULL;
	const gchar* _tmp0_;
	GtkLabel* _tmp1_;
	GtkLabel* label;
#line 70 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	g_return_val_if_fail (label_text != NULL, NULL);
#line 71 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_tmp0_ = label_text;
#line 71 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_tmp1_ = (GtkLabel*) gtk_label_new (_tmp0_);
#line 71 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	g_object_ref_sink (_tmp1_);
#line 71 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	label = _tmp1_;
#line 72 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	gtk_widget_set_halign ((GtkWidget*) label, GTK_ALIGN_CENTER);
#line 73 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	gtk_label_set_justify (label, GTK_JUSTIFY_CENTER);
#line 74 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	gtk_widget_set_margin_top ((GtkWidget*) label, 10);
#line 75 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) label, 10);
#line 76 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	result = label;
#line 76 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	return result;
#line 326 "util.c"
}


/**
 * Attach a widget to a table complete with a left-justified label
 */
void util_attach (GtkGrid* grid, gint y, const gchar* label_text, GtkWidget* widget) {
	const gchar* _tmp0_;
	GtkGrid* _tmp6_;
	GtkWidget* _tmp7_;
	gint _tmp8_;
#line 82 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	g_return_if_fail (grid != NULL);
#line 83 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_tmp0_ = label_text;
#line 83 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	if (_tmp0_ != NULL) {
#line 344 "util.c"
		GtkGrid* _tmp1_;
		const gchar* _tmp2_;
		GtkLabel* _tmp3_ = NULL;
		GtkLabel* _tmp4_;
		gint _tmp5_;
#line 83 "/home/jaidi/project/mutiara/tiara/src/util.vala"
		_tmp1_ = grid;
#line 83 "/home/jaidi/project/mutiara/tiara/src/util.vala"
		_tmp2_ = label_text;
#line 83 "/home/jaidi/project/mutiara/tiara/src/util.vala"
		_tmp3_ = util_label (_tmp2_);
#line 83 "/home/jaidi/project/mutiara/tiara/src/util.vala"
		_tmp4_ = _tmp3_;
#line 83 "/home/jaidi/project/mutiara/tiara/src/util.vala"
		_tmp5_ = y;
#line 83 "/home/jaidi/project/mutiara/tiara/src/util.vala"
		gtk_grid_attach (_tmp1_, (GtkWidget*) _tmp4_, 0, _tmp5_, 1, 1);
#line 83 "/home/jaidi/project/mutiara/tiara/src/util.vala"
		_g_object_unref0 (_tmp4_);
#line 364 "util.c"
	}
#line 84 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_tmp6_ = grid;
#line 84 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_tmp7_ = widget;
#line 84 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_tmp8_ = y;
#line 84 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	gtk_grid_attach (_tmp6_, _tmp7_, 1, _tmp8_, 1, 1);
#line 374 "util.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 96 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	return self ? g_object_ref (self) : NULL;
#line 381 "util.c"
}


GtkDialog* util_make_dialog (const gchar* title, const gchar* ok_text, UtilContentsDelegate put_contents, void* put_contents_target) {
	GtkDialog* result = NULL;
	const gchar* _tmp0_;
	GtkWindow* _tmp1_;
	const gchar* _tmp2_;
	GtkDialog* _tmp3_;
	GtkDialog* dialog;
	GtkBox* _tmp4_ = NULL;
	GtkBox* _tmp5_;
	GtkBox* box;
	GtkGrid* _tmp6_;
	GtkGrid* grid;
	UtilContentsDelegate _tmp7_;
	void* _tmp7__target;
#line 92 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	g_return_val_if_fail (title != NULL, NULL);
#line 92 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	g_return_val_if_fail (ok_text != NULL, NULL);
#line 93 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_tmp0_ = title;
#line 93 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_tmp1_ = main_window;
#line 93 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_tmp2_ = ok_text;
#line 93 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_tmp3_ = (GtkDialog*) gtk_dialog_new_with_buttons (_tmp0_, _tmp1_, GTK_DIALOG_MODAL, GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL, _tmp2_, GTK_RESPONSE_OK, NULL);
#line 93 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	g_object_ref_sink (_tmp3_);
#line 93 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	dialog = _tmp3_;
#line 95 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	gtk_window_set_resizable ((GtkWindow*) dialog, FALSE);
#line 96 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_tmp4_ = gtk_dialog_get_content_area (dialog);
#line 96 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 96 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	box = _tmp5_;
#line 97 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_tmp6_ = (GtkGrid*) gtk_grid_new ();
#line 97 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	g_object_ref_sink (_tmp6_);
#line 97 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	grid = _tmp6_;
#line 98 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	gtk_container_add ((GtkContainer*) box, (GtkWidget*) grid);
#line 100 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	gtk_grid_set_row_spacing (grid, 5);
#line 101 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	gtk_grid_set_column_spacing (grid, 10);
#line 102 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	gtk_widget_set_margin_left ((GtkWidget*) grid, 5);
#line 103 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	gtk_widget_set_margin_right ((GtkWidget*) grid, 5);
#line 104 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) grid, 20);
#line 105 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_tmp7_ = put_contents;
#line 105 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_tmp7__target = put_contents_target;
#line 105 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_tmp7_ (grid, _tmp7__target);
#line 106 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	gtk_widget_show_all ((GtkWidget*) dialog);
#line 107 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	result = dialog;
#line 107 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_g_object_unref0 (grid);
#line 107 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_g_object_unref0 (box);
#line 107 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	return result;
#line 457 "util.c"
}


/**
 * Actions whose accelerators clash with editing keys.
 */
gchar** util_action_names (int* result_length1) {
	gchar** result = NULL;
	gchar* _tmp0_;
	gchar** _tmp1_ = NULL;
	gchar** _tmp2_;
	gint _tmp2__length1;
#line 114 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_tmp0_ = g_strdup ("Delete");
#line 114 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_tmp1_ = g_new0 (gchar*, 1 + 1);
#line 114 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_tmp1_[0] = _tmp0_;
#line 114 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_tmp2_ = _tmp1_;
#line 114 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_tmp2__length1 = 1;
#line 114 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	if (result_length1) {
#line 114 "/home/jaidi/project/mutiara/tiara/src/util.vala"
		*result_length1 = _tmp2__length1;
#line 484 "util.c"
	}
#line 114 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	result = _tmp2_;
#line 114 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	return result;
#line 490 "util.c"
}


/**
 * Call this method with text editing components
 */
static gboolean __lambda7_ (GdkEventFocus* e) {
	gboolean result = FALSE;
	gint _tmp0_ = 0;
	gchar** _tmp1_ = NULL;
#line 121 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 122 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_tmp1_ = util_action_names (&_tmp0_);
#line 505 "util.c"
	{
		gchar** name_collection = NULL;
		gint name_collection_length1 = 0;
		gint _name_collection_size_ = 0;
		gint name_it = 0;
#line 122 "/home/jaidi/project/mutiara/tiara/src/util.vala"
		name_collection = _tmp1_;
#line 122 "/home/jaidi/project/mutiara/tiara/src/util.vala"
		name_collection_length1 = _tmp0_;
#line 122 "/home/jaidi/project/mutiara/tiara/src/util.vala"
		for (name_it = 0; name_it < _tmp0_; name_it = name_it + 1) {
#line 517 "util.c"
			gchar* _tmp2_;
			gchar* name = NULL;
#line 122 "/home/jaidi/project/mutiara/tiara/src/util.vala"
			_tmp2_ = g_strdup (name_collection[name_it]);
#line 122 "/home/jaidi/project/mutiara/tiara/src/util.vala"
			name = _tmp2_;
#line 524 "util.c"
			{
				GtkActionGroup* _tmp3_;
				const gchar* _tmp4_;
				GtkAction* _tmp5_ = NULL;
#line 123 "/home/jaidi/project/mutiara/tiara/src/util.vala"
				_tmp3_ = action_group;
#line 123 "/home/jaidi/project/mutiara/tiara/src/util.vala"
				_tmp4_ = name;
#line 123 "/home/jaidi/project/mutiara/tiara/src/util.vala"
				_tmp5_ = gtk_action_group_get_action (_tmp3_, _tmp4_);
#line 123 "/home/jaidi/project/mutiara/tiara/src/util.vala"
				gtk_action_disconnect_accelerator (_tmp5_);
#line 122 "/home/jaidi/project/mutiara/tiara/src/util.vala"
				_g_free0 (name);
#line 539 "util.c"
			}
		}
#line 122 "/home/jaidi/project/mutiara/tiara/src/util.vala"
		name_collection = (_vala_array_free (name_collection, name_collection_length1, (GDestroyNotify) g_free), NULL);
#line 544 "util.c"
	}
#line 125 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	result = FALSE;
#line 125 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	return result;
#line 550 "util.c"
}


static gboolean ___lambda7__gtk_widget_focus_in_event (GtkWidget* _sender, GdkEventFocus* event, gpointer self) {
	gboolean result;
	result = __lambda7_ (event);
#line 121 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	return result;
#line 559 "util.c"
}


static gboolean __lambda8_ (GdkEventFocus* e) {
	gboolean result = FALSE;
	gint _tmp0_ = 0;
	gchar** _tmp1_ = NULL;
#line 127 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 128 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_tmp1_ = util_action_names (&_tmp0_);
#line 571 "util.c"
	{
		gchar** name_collection = NULL;
		gint name_collection_length1 = 0;
		gint _name_collection_size_ = 0;
		gint name_it = 0;
#line 128 "/home/jaidi/project/mutiara/tiara/src/util.vala"
		name_collection = _tmp1_;
#line 128 "/home/jaidi/project/mutiara/tiara/src/util.vala"
		name_collection_length1 = _tmp0_;
#line 128 "/home/jaidi/project/mutiara/tiara/src/util.vala"
		for (name_it = 0; name_it < _tmp0_; name_it = name_it + 1) {
#line 583 "util.c"
			gchar* _tmp2_;
			gchar* name = NULL;
#line 128 "/home/jaidi/project/mutiara/tiara/src/util.vala"
			_tmp2_ = g_strdup (name_collection[name_it]);
#line 128 "/home/jaidi/project/mutiara/tiara/src/util.vala"
			name = _tmp2_;
#line 590 "util.c"
			{
				GtkActionGroup* _tmp3_;
				const gchar* _tmp4_;
				GtkAction* _tmp5_ = NULL;
#line 129 "/home/jaidi/project/mutiara/tiara/src/util.vala"
				_tmp3_ = action_group;
#line 129 "/home/jaidi/project/mutiara/tiara/src/util.vala"
				_tmp4_ = name;
#line 129 "/home/jaidi/project/mutiara/tiara/src/util.vala"
				_tmp5_ = gtk_action_group_get_action (_tmp3_, _tmp4_);
#line 129 "/home/jaidi/project/mutiara/tiara/src/util.vala"
				gtk_action_connect_accelerator (_tmp5_);
#line 128 "/home/jaidi/project/mutiara/tiara/src/util.vala"
				_g_free0 (name);
#line 605 "util.c"
			}
		}
#line 128 "/home/jaidi/project/mutiara/tiara/src/util.vala"
		name_collection = (_vala_array_free (name_collection, name_collection_length1, (GDestroyNotify) g_free), NULL);
#line 610 "util.c"
	}
#line 131 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	result = FALSE;
#line 131 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	return result;
#line 616 "util.c"
}


static gboolean ___lambda8__gtk_widget_focus_out_event (GtkWidget* _sender, GdkEventFocus* event, gpointer self) {
	gboolean result;
	result = __lambda8_ (event);
#line 127 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	return result;
#line 625 "util.c"
}


void util_resolve_accelerator_clashes (GtkWidget* widget) {
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
#line 120 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	g_return_if_fail (widget != NULL);
#line 121 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_tmp0_ = widget;
#line 121 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	g_signal_connect (_tmp0_, "focus-in-event", (GCallback) ___lambda7__gtk_widget_focus_in_event, NULL);
#line 127 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_tmp1_ = widget;
#line 127 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	g_signal_connect (_tmp1_, "focus-out-event", (GCallback) ___lambda8__gtk_widget_focus_out_event, NULL);
#line 642 "util.c"
}


/**
 * Create a spin button which disable some accelerators upon focus.
 */
GtkSpinButton* util_make_spin_button (gdouble min, gdouble max, gdouble step) {
	GtkSpinButton* result = NULL;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	GtkSpinButton* _tmp3_;
	GtkSpinButton* button;
#line 139 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_tmp0_ = min;
#line 139 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_tmp1_ = max;
#line 139 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_tmp2_ = step;
#line 139 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	_tmp3_ = (GtkSpinButton*) gtk_spin_button_new_with_range (_tmp0_, _tmp1_, _tmp2_);
#line 139 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	g_object_ref_sink (_tmp3_);
#line 139 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	button = _tmp3_;
#line 140 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	util_resolve_accelerator_clashes ((GtkWidget*) button);
#line 141 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	result = button;
#line 141 "/home/jaidi/project/mutiara/tiara/src/util.vala"
	return result;
#line 674 "util.c"
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
#line 101 "/home/jaidi/project/mutiara/tiara/src/pod.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 681 "util.c"
		int i;
#line 101 "/home/jaidi/project/mutiara/tiara/src/pod.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 101 "/home/jaidi/project/mutiara/tiara/src/pod.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 101 "/home/jaidi/project/mutiara/tiara/src/pod.vala"
				destroy_func (((gpointer*) array)[i]);
#line 689 "util.c"
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
#line 101 "/home/jaidi/project/mutiara/tiara/src/pod.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 101 "/home/jaidi/project/mutiara/tiara/src/pod.vala"
	g_free (array);
#line 701 "util.c"
}



