/* seed.c generated by valac 0.17.2, the Vala compiler
 * generated from seed.vala, do not modify */

/*  Mutiara motif designer.
Copyright (C) 2011  Nor Jaidi Tuah

This file is part of Mutiara.

Mutiara is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/**
 * User configurable attributes
 * ^^^^^^^^^^^^^^^^^^^^^^^^^^^^
 */
/**
 * Computed values used to speed up rendering
 * ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
 *
 * These values initialized by a call to start_render.
 */

#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <cairo.h>


#define TYPE_SEED (seed_get_type ())
#define SEED(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SEED, Seed))
#define SEED_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SEED, SeedClass))
#define IS_SEED(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SEED))
#define IS_SEED_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SEED))
#define SEED_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SEED, SeedClass))

typedef struct _Seed Seed;
typedef struct _SeedClass SeedClass;
typedef struct _SeedPrivate SeedPrivate;

#define TYPE_POINT (point_get_type ())
typedef struct _Point Point;

#define TYPE_ROLE (role_get_type ())

#define TYPE_FLIP (flip_get_type ())

#define TYPE_TWEAK (tweak_get_type ())
typedef struct _Tweak Tweak;

#define TYPE_RGBA (rgba_get_type ())
typedef struct _RGBA RGBA;

#define TYPE_RENDER_STYLE (render_style_get_type ())

#define TYPE_PROJECTION (projection_get_type ())
#define PROJECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PROJECTION, Projection))
#define PROJECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PROJECTION, ProjectionClass))
#define IS_PROJECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PROJECTION))
#define IS_PROJECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PROJECTION))
#define PROJECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PROJECTION, ProjectionClass))

typedef struct _Projection Projection;
typedef struct _ProjectionClass ProjectionClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _projection_unref0(var) ((var == NULL) ? NULL : (var = (projection_unref (var), NULL)))

#define TYPE_PROBE (probe_get_type ())
#define PROBE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PROBE, Probe))
#define PROBE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PROBE, ProbeClass))
#define IS_PROBE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PROBE))
#define IS_PROBE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PROBE))
#define PROBE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PROBE, ProbeClass))

typedef struct _Probe Probe;
typedef struct _ProbeClass ProbeClass;
typedef struct _ProbePrivate ProbePrivate;

#define TYPE_DEFERRED_CAIRO (deferred_cairo_get_type ())
#define DEFERRED_CAIRO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DEFERRED_CAIRO, DeferredCairo))
#define DEFERRED_CAIRO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DEFERRED_CAIRO, DeferredCairoClass))
#define IS_DEFERRED_CAIRO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DEFERRED_CAIRO))
#define IS_DEFERRED_CAIRO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DEFERRED_CAIRO))
#define DEFERRED_CAIRO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DEFERRED_CAIRO, DeferredCairoClass))

typedef struct _DeferredCairo DeferredCairo;
typedef struct _DeferredCairoClass DeferredCairoClass;

#define TYPE_LINE (line_get_type ())
#define LINE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LINE, Line))
#define LINE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LINE, LineClass))
#define IS_LINE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LINE))
#define IS_LINE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LINE))
#define LINE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LINE, LineClass))

typedef struct _Line Line;
typedef struct _LineClass LineClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _deferred_cairo_unref0(var) ((var == NULL) ? NULL : (var = (deferred_cairo_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Point {
	gdouble x;
	gdouble y;
};

typedef enum  {
	ROLE_DUAL = 0,
	ROLE_MOTIF = 1,
	ROLE_BASE = 2
} Role;

typedef enum  {
	FLIP_NONE = 0,
	FLIP_Y = 1,
	FLIP_X = 2,
	FLIP_XY = 3
} Flip;

struct _Tweak {
	gdouble scale_x;
	gdouble scale_y;
	gdouble rotate;
	gdouble move_x;
	gdouble move_y;
};

struct _RGBA {
	gdouble r;
	gdouble g;
	gdouble b;
	gdouble a;
};

typedef enum  {
	RENDER_STYLE_THIN = 0,
	RENDER_STYLE_THICK = 1,
	RENDER_STYLE_HOLLOW = 2,
	RENDER_STYLE_FILLED = 3,
	RENDER_STYLE_CLOSED = 4,
	RENDER_STYLE_NONE = 5
} RenderStyle;

struct _Seed {
	GObject parent_instance;
	SeedPrivate * priv;
	gboolean debug;
	Role role;
	gdouble base_offset;
	Flip flip_even;
	Flip flip_odd;
	Tweak tweak;
	gdouble width0;
	gdouble width1;
	gint num_segment;
	gint level_of_detail;
	RGBA color;
	gdouble color_mix;
	RenderStyle render_style;
	gdouble* distance_to_param;
	gint distance_to_param_length1;
	Projection** projection;
	gint projection_length1;
	gint selected_control;
	Point pressed_point;
};

struct _SeedClass {
	GObjectClass parent_class;
	void (*init_default_sub) (Seed* self, Point* p);
	void (*init_full_sub) (Seed* self, gdouble* args, int args_length1);
	gchar* (*serialize_sub) (Seed* self);
	void (*point_raw) (Seed* self, gdouble t, Point* result);
	void (*init_distance_to_parametric) (Seed* self);
	gdouble (*perpendicular_angle) (Seed* self, gdouble t);
	void (*draw_direct) (Seed* self, cairo_t* cr, gdouble scale);
	void (*draw_controls) (Seed* self, cairo_t* cr, gdouble scale);
	gint (*pressed_control) (Seed* self, Point* p, gdouble scale);
	void (*save_drag_context) (Seed* self);
	void (*move_shape) (Seed* self, gdouble delta_x, gdouble delta_y);
	void (*drag_control) (Seed* self, Point* p, gdouble scale, gboolean snap_on, gdouble grid_size, gdouble snap_angle);
	Point* (*points_to_snap) (Seed* self, int* result_length1);
	void (*draw_icon) (Seed* self, cairo_t* cr, gdouble width, gdouble height);
};

struct _SeedPrivate {
	gint div;
	gboolean* self_intersect;
	gint self_intersect_length1;
	gint _self_intersect_size_;
	gboolean twisted;
	gdouble control_radius;
	gdouble control_magnetic_range;
	gdouble grid_magnetic_range;
};

struct _Probe {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ProbePrivate * priv;
	gboolean cancelled;
};

struct _ProbeClass {
	GTypeClass parent_class;
	void (*finalize) (Probe *self);
};


static gpointer seed_parent_class = NULL;
static gdouble seed_epsilon;
static gdouble seed_epsilon = 0.0;

GType seed_get_type (void) G_GNUC_CONST;
GType point_get_type (void) G_GNUC_CONST;
Point* point_dup (const Point* self);
void point_free (Point* self);
GType role_get_type (void) G_GNUC_CONST;
GType flip_get_type (void) G_GNUC_CONST;
GType tweak_get_type (void) G_GNUC_CONST;
Tweak* tweak_dup (const Tweak* self);
void tweak_free (Tweak* self);
GType rgba_get_type (void) G_GNUC_CONST;
RGBA* rgba_dup (const RGBA* self);
void rgba_free (RGBA* self);
GType render_style_get_type (void) G_GNUC_CONST;
gpointer projection_ref (gpointer instance);
void projection_unref (gpointer instance);
GParamSpec* param_spec_projection (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_projection (GValue* value, gpointer v_object);
void value_take_projection (GValue* value, gpointer v_object);
gpointer value_get_projection (const GValue* value);
GType projection_get_type (void) G_GNUC_CONST;
#define SEED_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SEED, SeedPrivate))
enum  {
	SEED_DUMMY_PROPERTY
};
void tweak_init (Tweak *self);
void rgba_init (RGBA *self, gdouble r, gdouble g, gdouble b, gdouble a);
void seed_init_default (Seed* self, Point* p);
void seed_init_default_sub (Seed* self, Point* p);
void seed_init_full (Seed* self, gdouble* args, int args_length1);
void seed_init_full_sub (Seed* self, gdouble* args, int args_length1);
static void seed_real_init_default_sub (Seed* self, Point* p);
static void seed_real_init_full_sub (Seed* self, gdouble* args, int args_length1);
gchar* seed_serialize (Seed* self, gboolean for_border);
gchar* seed_serialize_sub (Seed* self);
gchar* util_format (gdouble n, gint decimal_places);
static gchar* seed_serialize_tweak (Seed* self);
gboolean tweak_equals (Tweak *self, Tweak* t);
gchar* tweak_serialize (Tweak *self);
static gchar* seed_real_serialize_sub (Seed* self);
void seed_copy_parameters (Seed* self, Seed* source);
void seed_point (Seed* self, gdouble distance, Point* result);
void seed_point_raw (Seed* self, gdouble t, Point* result);
gdouble seed_parameter (Seed* self, gdouble distance);
static void seed_real_point_raw (Seed* self, gdouble t, Point* result);
void seed_start_render (Seed* self);
void seed_init_distance_to_parametric (Seed* self);
static void seed_init_self_intersect (Seed* self);
static void seed_init_projection (Seed* self);
void seed_stop_render (Seed* self);
static void seed_real_init_distance_to_parametric (Seed* self);
gdouble point_hypot (Point* p0, Point* p1);
gboolean seed_check_twisted (Seed* self, gint n);
static gboolean seed_check_self_intersect (Seed* self, gint n);
void seed_distant_point (Seed* self, gdouble t, gdouble distance, Point* result);
static gboolean seed_check_intersect (Point* p1, Point* p2, Point* q1, Point* q2);
static gdouble seed_area_sign (Point* p1, Point* p2, Point* p3);
Projection* projection_new (Projection* parent, Seed* seed, gdouble t0, gdouble t1, Flip flip);
Projection* projection_construct (GType object_type, Projection* parent, Seed* seed, gdouble t0, gdouble t1, Flip flip);
gdouble seed_perpendicular_angle (Seed* self, gdouble t);
static gdouble seed_real_perpendicular_angle (Seed* self, gdouble t);
gpointer probe_ref (gpointer instance);
void probe_unref (gpointer instance);
GParamSpec* param_spec_probe (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_probe (GValue* value, gpointer v_object);
void value_take_probe (GValue* value, gpointer v_object);
gpointer value_get_probe (const GValue* value);
GType probe_get_type (void) G_GNUC_CONST;
gboolean seed_too_thin (Seed* self, Projection* pr, Probe* probe, gdouble thickness, gboolean segment_twisted, gdouble* width);
static void seed_compute_area_perimeter (Seed* self, Projection* pr, Probe* probe, gdouble limit, gdouble x0, gdouble y0, gdouble x1, gdouble y1, gdouble* area, gdouble* perimeter);
static void seed_compute_sub_area_perimeter (Seed* self, Projection* pr, Probe* probe, gdouble limit, gdouble x0, gdouble y0, Point* p0, gdouble x1, gdouble y1, Point* p1, gdouble* area, gdouble* perimeter, gint depth);
void projection_map (Projection* pr, Point* p, Point* result);
gpointer deferred_cairo_ref (gpointer instance);
void deferred_cairo_unref (gpointer instance);
GParamSpec* param_spec_deferred_cairo (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_deferred_cairo (GValue* value, gpointer v_object);
void value_take_deferred_cairo (GValue* value, gpointer v_object);
gpointer value_get_deferred_cairo (const GValue* value);
GType deferred_cairo_get_type (void) G_GNUC_CONST;
void seed_draw (Seed* self, DeferredCairo* dc, Projection* pr, Probe* probe, gdouble limit);
void deferred_cairo_move_to (DeferredCairo* self, Point* p);
static void seed_draw_segment (Seed* self, DeferredCairo* dc, Projection* pr, Probe* probe, gdouble x0, gdouble y0, gdouble x1, gdouble y1, gdouble limit);
Line* line_new (void);
Line* line_construct (GType object_type);
GType line_get_type (void) G_GNUC_CONST;
void deferred_cairo_fill (DeferredCairo* self);
void seed_draw_segmentation (Seed* self, cairo_t* cr, Projection* pr);
DeferredCairo* deferred_cairo_new (void);
DeferredCairo* deferred_cairo_construct (GType object_type);
void deferred_cairo_render (DeferredCairo* self, cairo_t* cr);
static void seed_draw_sub_segment (Seed* self, DeferredCairo* dc, Projection* pr, Probe* probe, gdouble x0, gdouble y0, Point* p0, gdouble x1, gdouble y1, Point* p1, gdouble limit, gint depth);
void deferred_cairo_line_to (DeferredCairo* self, Point* p);
void seed_draw_direct (Seed* self, cairo_t* cr, gdouble scale);
static void seed_real_draw_direct (Seed* self, cairo_t* cr, gdouble scale);
void seed_draw_controls (Seed* self, cairo_t* cr, gdouble scale);
static void seed_real_draw_controls (Seed* self, cairo_t* cr, gdouble scale);
void seed_draw_square_control (Seed* self, cairo_t* cr, Point* p);
void seed_draw_line_control (Seed* self, cairo_t* cr, Point* p0, Point* p1);
void seed_draw_circle_control (Seed* self, cairo_t* cr, Point* p);
gboolean seed_within_snap_range (Seed* self, Point* p0, Point* p1, gdouble scale);
gboolean seed_within_touch_range (Seed* self, Point* p0, Point* p1, gdouble scale);
gboolean seed_touching (Seed* self, Point* p, gdouble scale);
gboolean seed_start_drag (Seed* self, Point* p, gdouble scale, gboolean selected, gboolean snap_on, gdouble grid_size);
void seed_save_drag_context (Seed* self);
gboolean seed_snap (Seed* self, Point* p, gdouble scale, gdouble grid_size);
gint seed_pressed_control (Seed* self, Point* p, gdouble scale);
static gint seed_real_pressed_control (Seed* self, Point* p, gdouble scale);
static void seed_real_save_drag_context (Seed* self);
void seed_drag (Seed* self, Point* p, gdouble scale, gboolean snap_on, gdouble grid_size, gdouble snap_angle);
void seed_move_shape (Seed* self, gdouble delta_x, gdouble delta_y);
void seed_distance_to_grid (Seed* self, gdouble scale, gdouble grid_size, gdouble* distance_x, gdouble* distance_y);
void seed_drag_control (Seed* self, Point* p, gdouble scale, gboolean snap_on, gdouble grid_size, gdouble snap_angle);
static void seed_real_move_shape (Seed* self, gdouble delta_x, gdouble delta_y);
static void seed_real_drag_control (Seed* self, Point* p, gdouble scale, gboolean snap_on, gdouble grid_size, gdouble snap_angle);
gboolean seed_snap_x (Seed* self, Point* p, gdouble scale, gdouble grid_size);
gboolean seed_snap_y (Seed* self, Point* p, gdouble scale, gdouble grid_size);
Point* seed_points_to_snap (Seed* self, int* result_length1);
static Point* seed_real_points_to_snap (Seed* self, int* result_length1);
void seed_draw_icon (Seed* self, cairo_t* cr, gdouble width, gdouble height);
static void seed_real_draw_icon (Seed* self, cairo_t* cr, gdouble width, gdouble height);
Seed* seed_construct (GType object_type);
static void seed_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


/**
 * After creating a seed, call one of these to initialize.
 */
void seed_init_default (Seed* self, Point* p) {
	Point _tmp0_;
#line 107 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 107 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_if_fail (p != NULL);
#line 108 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp0_ = *p;
#line 108 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	seed_init_default_sub (self, &_tmp0_);
#line 365 "seed.c"
}


void seed_init_full (Seed* self, gdouble* args, int args_length1) {
	gdouble* _tmp0_;
	gint _tmp0__length1;
#line 111 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 112 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp0_ = args;
#line 112 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp0__length1 = args_length1;
#line 112 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	seed_init_full_sub (self, _tmp0_, _tmp0__length1);
#line 380 "seed.c"
}


static void seed_real_init_default_sub (Seed* self, Point* p) {
#line 115 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_critical ("Type `%s' does not implement abstract method `seed_init_default_sub'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 115 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	return;
#line 389 "seed.c"
}


void seed_init_default_sub (Seed* self, Point* p) {
#line 115 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 115 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	SEED_GET_CLASS (self)->init_default_sub (self, p);
#line 398 "seed.c"
}


static void seed_real_init_full_sub (Seed* self, gdouble* args, int args_length1) {
#line 116 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_critical ("Type `%s' does not implement abstract method `seed_init_full_sub'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 116 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	return;
#line 407 "seed.c"
}


void seed_init_full_sub (Seed* self, gdouble* args, int args_length1) {
#line 116 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 116 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	SEED_GET_CLASS (self)->init_full_sub (self, args, args_length1);
#line 416 "seed.c"
}


/**
 * See Pod.serialize
 */
gchar* seed_serialize (Seed* self, gboolean for_border) {
	gchar* result = NULL;
	gboolean _tmp0_;
#line 121 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 122 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp0_ = for_border;
#line 122 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	if (_tmp0_) {
#line 432 "seed.c"
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_;
		gdouble _tmp3_;
		gint _tmp4_;
		gdouble _tmp5_;
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_;
		gdouble _tmp8_;
		gchar* _tmp9_ = NULL;
		gchar* _tmp10_;
		Role _tmp11_;
		gint _tmp12_;
		Flip _tmp13_;
		Flip _tmp14_;
		gchar* _tmp15_ = NULL;
		gchar* _tmp16_;
		gchar* _tmp17_ = NULL;
		gchar* _tmp18_;
#line 123 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp1_ = seed_serialize_sub (self);
#line 123 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp2_ = _tmp1_;
#line 123 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp3_ = self->base_offset;
#line 123 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp4_ = self->num_segment;
#line 123 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp5_ = self->width0;
#line 123 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp6_ = util_format (_tmp5_, 4);
#line 123 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp7_ = _tmp6_;
#line 123 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp8_ = self->width1;
#line 123 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp9_ = util_format (_tmp8_, 4);
#line 123 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp10_ = _tmp9_;
#line 123 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp11_ = self->role;
#line 123 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp12_ = self->level_of_detail;
#line 123 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp13_ = self->flip_even;
#line 123 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp14_ = self->flip_odd;
#line 123 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp15_ = seed_serialize_tweak (self);
#line 123 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp16_ = _tmp15_;
#line 123 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp17_ = g_strdup_printf ("%s\n" \
"    segmentation %.1g, %d\n" \
"    width %s, %s\n" \
"    replication %d, %d, %d, %d%s\n", _tmp2_, _tmp3_, _tmp4_, _tmp7_, _tmp10_, (gint) _tmp11_, _tmp12_, (gint) _tmp13_, (gint) _tmp14_, _tmp16_);
#line 123 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp18_ = _tmp17_;
#line 123 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_g_free0 (_tmp16_);
#line 123 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_g_free0 (_tmp10_);
#line 123 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_g_free0 (_tmp7_);
#line 123 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_g_free0 (_tmp2_);
#line 123 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		result = _tmp18_;
#line 123 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		return result;
#line 499 "seed.c"
	} else {
		const gchar* _tmp19_ = NULL;
		gboolean _tmp20_;
		gchar* _tmp21_ = NULL;
		gchar* _tmp22_;
		const gchar* _tmp23_;
		gdouble _tmp24_;
		gint _tmp25_;
		gdouble _tmp26_;
		gchar* _tmp27_ = NULL;
		gchar* _tmp28_;
		gdouble _tmp29_;
		gchar* _tmp30_ = NULL;
		gchar* _tmp31_;
		Role _tmp32_;
		gint _tmp33_;
		Flip _tmp34_;
		Flip _tmp35_;
		gchar* _tmp36_ = NULL;
		gchar* _tmp37_;
		RGBA _tmp38_;
		gdouble _tmp39_;
		RGBA _tmp40_;
		gdouble _tmp41_;
		RGBA _tmp42_;
		gdouble _tmp43_;
		RGBA _tmp44_;
		gdouble _tmp45_;
		gdouble _tmp46_;
		RenderStyle _tmp47_;
		gchar* _tmp48_ = NULL;
		gchar* _tmp49_;
#line 142 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp20_ = self->debug;
#line 142 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		if (_tmp20_) {
#line 142 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp19_ = "\ndebug";
#line 538 "seed.c"
		} else {
#line 142 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp19_ = "";
#line 542 "seed.c"
		}
#line 134 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp21_ = seed_serialize_sub (self);
#line 134 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp22_ = _tmp21_;
#line 134 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp23_ = _tmp19_;
#line 134 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp24_ = self->base_offset;
#line 134 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp25_ = self->num_segment;
#line 134 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp26_ = self->width0;
#line 134 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp27_ = util_format (_tmp26_, 4);
#line 134 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp28_ = _tmp27_;
#line 134 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp29_ = self->width1;
#line 134 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp30_ = util_format (_tmp29_, 4);
#line 134 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp31_ = _tmp30_;
#line 134 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp32_ = self->role;
#line 134 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp33_ = self->level_of_detail;
#line 134 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp34_ = self->flip_even;
#line 134 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp35_ = self->flip_odd;
#line 134 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp36_ = seed_serialize_tweak (self);
#line 134 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp37_ = _tmp36_;
#line 134 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp38_ = self->color;
#line 134 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp39_ = _tmp38_.r;
#line 134 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp40_ = self->color;
#line 134 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp41_ = _tmp40_.g;
#line 134 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp42_ = self->color;
#line 134 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp43_ = _tmp42_.b;
#line 134 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp44_ = self->color;
#line 134 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp45_ = _tmp44_.a;
#line 134 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp46_ = self->color_mix;
#line 134 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp47_ = self->render_style;
#line 134 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp48_ = g_strdup_printf ("%s%s\n" \
"    segmentation %.1g, %d\n" \
"    width %s, %s\n" \
"    replication %d, %d, %d, %d%s\n" \
"    color (%.2g, %.2g, %.2g, %.2g) %.2g\n" \
"    style %d\n", _tmp22_, _tmp23_, _tmp24_, _tmp25_, _tmp28_, _tmp31_, (gint) _tmp32_, _tmp33_, (gint) _tmp34_, (gint) _tmp35_, _tmp37_, _tmp39_, _tmp41_, _tmp43_, _tmp45_, _tmp46_, (gint) _tmp47_);
#line 134 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp49_ = _tmp48_;
#line 134 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_g_free0 (_tmp37_);
#line 134 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_g_free0 (_tmp31_);
#line 134 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_g_free0 (_tmp28_);
#line 134 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_g_free0 (_tmp22_);
#line 134 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		result = _tmp49_;
#line 134 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		return result;
#line 614 "seed.c"
	}
}


static gchar* seed_serialize_tweak (Seed* self) {
	gchar* result = NULL;
	Tweak _tmp0_ = {0};
	gboolean _tmp1_ = FALSE;
#line 150 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 151 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	tweak_init (&_tmp0_);
#line 151 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp1_ = tweak_equals (&self->tweak, &_tmp0_);
#line 151 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	if (_tmp1_) {
#line 631 "seed.c"
		gchar* _tmp2_;
#line 151 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp2_ = g_strdup ("");
#line 151 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		result = _tmp2_;
#line 151 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		return result;
#line 639 "seed.c"
	} else {
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_;
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_;
#line 152 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp3_ = tweak_serialize (&self->tweak);
#line 152 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp4_ = _tmp3_;
#line 152 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp5_ = g_strdup_printf ("\n    tweak %s", _tmp4_);
#line 152 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp6_ = _tmp5_;
#line 152 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_g_free0 (_tmp4_);
#line 152 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		result = _tmp6_;
#line 152 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		return result;
#line 659 "seed.c"
	}
}


static gchar* seed_real_serialize_sub (Seed* self) {
#line 155 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_critical ("Type `%s' does not implement abstract method `seed_serialize_sub'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 155 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	return NULL;
#line 669 "seed.c"
}


gchar* seed_serialize_sub (Seed* self) {
#line 155 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 155 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	return SEED_GET_CLASS (self)->serialize_sub (self);
#line 678 "seed.c"
}


void seed_copy_parameters (Seed* self, Seed* source) {
	Seed* _tmp0_;
	gdouble _tmp1_;
	Seed* _tmp2_;
	gint _tmp3_;
	Seed* _tmp4_;
	gdouble _tmp5_;
	Seed* _tmp6_;
	gdouble _tmp7_;
	Seed* _tmp8_;
	Role _tmp9_;
	Seed* _tmp10_;
	gint _tmp11_;
	Seed* _tmp12_;
	Flip _tmp13_;
	Seed* _tmp14_;
	Flip _tmp15_;
	Seed* _tmp16_;
	Tweak _tmp17_;
	Seed* _tmp18_;
	RGBA _tmp19_;
	Seed* _tmp20_;
	gdouble _tmp21_;
	Seed* _tmp22_;
	RenderStyle _tmp23_;
#line 157 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 157 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_if_fail (source != NULL);
#line 158 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp0_ = source;
#line 158 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp1_ = _tmp0_->base_offset;
#line 158 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->base_offset = _tmp1_;
#line 159 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp2_ = source;
#line 159 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp3_ = _tmp2_->num_segment;
#line 159 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->num_segment = _tmp3_;
#line 160 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp4_ = source;
#line 160 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp5_ = _tmp4_->width0;
#line 160 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->width0 = _tmp5_;
#line 161 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp6_ = source;
#line 161 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp7_ = _tmp6_->width1;
#line 161 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->width1 = _tmp7_;
#line 162 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp8_ = source;
#line 162 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp9_ = _tmp8_->role;
#line 162 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->role = _tmp9_;
#line 163 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp10_ = source;
#line 163 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp11_ = _tmp10_->level_of_detail;
#line 163 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->level_of_detail = _tmp11_;
#line 164 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp12_ = source;
#line 164 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp13_ = _tmp12_->flip_even;
#line 164 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->flip_even = _tmp13_;
#line 165 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp14_ = source;
#line 165 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp15_ = _tmp14_->flip_odd;
#line 165 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->flip_odd = _tmp15_;
#line 166 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp16_ = source;
#line 166 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp17_ = _tmp16_->tweak;
#line 166 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->tweak = _tmp17_;
#line 167 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp18_ = source;
#line 167 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp19_ = _tmp18_->color;
#line 167 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->color = _tmp19_;
#line 168 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp20_ = source;
#line 168 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp21_ = _tmp20_->color_mix;
#line 168 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->color_mix = _tmp21_;
#line 169 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp22_ = source;
#line 169 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp23_ = _tmp22_->render_style;
#line 169 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->render_style = _tmp23_;
#line 783 "seed.c"
}


/**
 * Compute (x(t), y(t)), where t is the distance (or time)
 * of a "constant speed" curve.
 */
void seed_point (Seed* self, gdouble distance, Point* result) {
	gdouble _tmp0_;
	gdouble _tmp1_ = 0.0;
	Point _tmp2_ = {0};
#line 176 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 177 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp0_ = distance;
#line 177 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp1_ = seed_parameter (self, _tmp0_);
#line 177 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	seed_point_raw (self, _tmp1_, &_tmp2_);
#line 177 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	*result = _tmp2_;
#line 177 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	return;
#line 807 "seed.c"
}


static void seed_real_point_raw (Seed* self, gdouble t, Point* result) {
#line 180 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_critical ("Type `%s' does not implement abstract method `seed_point_raw'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 180 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	return;
#line 816 "seed.c"
}


void seed_point_raw (Seed* self, gdouble t, Point* result) {
#line 180 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 180 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	SEED_GET_CLASS (self)->point_raw (self, t, result);
#line 825 "seed.c"
}


/**
 * Given a distance on a "constant speed" curve, convert it
 * to a more convenient parameter for the computation of points on
 * the curve.
 */
gdouble seed_parameter (Seed* self, gdouble distance) {
	gdouble result = 0.0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gdouble* _tmp2_;
	gint _tmp2__length1;
	gboolean _tmp4_;
	gboolean _tmp6_;
	gdouble _tmp8_;
	gint _tmp9_;
	gdouble n_exact;
	gdouble _tmp10_;
	gint n;
	gdouble* _tmp11_;
	gint _tmp11__length1;
	gint _tmp12_;
	gdouble _tmp13_;
	gdouble t0;
	gdouble* _tmp14_;
	gint _tmp14__length1;
	gint _tmp15_;
	gdouble _tmp16_;
	gdouble t1;
	gdouble _tmp17_;
	gdouble _tmp18_;
	gdouble gap;
	gdouble _tmp19_;
	gdouble _tmp20_;
	gint _tmp21_;
	gdouble _tmp22_;
	gdouble t;
	gdouble _tmp23_;
#line 187 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 188 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp2_ = self->distance_to_param;
#line 188 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp2__length1 = self->distance_to_param_length1;
#line 188 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	if (_tmp2_ == NULL) {
#line 188 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp1_ = TRUE;
#line 876 "seed.c"
	} else {
		gdouble _tmp3_;
#line 188 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp3_ = distance;
#line 188 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp1_ = _tmp3_ <= ((gdouble) 0);
#line 883 "seed.c"
	}
#line 188 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp4_ = _tmp1_;
#line 188 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	if (_tmp4_) {
#line 188 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp0_ = TRUE;
#line 891 "seed.c"
	} else {
		gdouble _tmp5_;
#line 188 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp5_ = distance;
#line 188 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp0_ = _tmp5_ >= ((gdouble) 1);
#line 898 "seed.c"
	}
#line 188 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp6_ = _tmp0_;
#line 188 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	if (_tmp6_) {
#line 904 "seed.c"
		gdouble _tmp7_;
#line 188 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp7_ = distance;
#line 188 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		result = _tmp7_;
#line 188 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		return result;
#line 912 "seed.c"
	}
#line 190 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp8_ = distance;
#line 190 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp9_ = self->priv->div;
#line 190 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	n_exact = _tmp8_ * _tmp9_;
#line 191 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp10_ = n_exact;
#line 191 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	n = (gint) _tmp10_;
#line 192 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp11_ = self->distance_to_param;
#line 192 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp11__length1 = self->distance_to_param_length1;
#line 192 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp12_ = n;
#line 192 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp13_ = _tmp11_[_tmp12_];
#line 192 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	t0 = _tmp13_;
#line 193 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp14_ = self->distance_to_param;
#line 193 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp14__length1 = self->distance_to_param_length1;
#line 193 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp15_ = n;
#line 193 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp16_ = _tmp14_[_tmp15_ + 1];
#line 193 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	t1 = _tmp16_;
#line 194 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp17_ = t1;
#line 194 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp18_ = t0;
#line 194 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	gap = _tmp17_ - _tmp18_;
#line 195 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp19_ = t0;
#line 195 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp20_ = n_exact;
#line 195 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp21_ = n;
#line 195 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp22_ = gap;
#line 195 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	t = _tmp19_ + ((_tmp20_ - _tmp21_) * _tmp22_);
#line 196 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp23_ = t;
#line 196 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	if (_tmp23_ < ((gdouble) 0)) {
#line 964 "seed.c"
		gdouble _tmp24_;
#line 197 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp24_ = t;
#line 197 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		g_warning ("seed.vala:197: unexpected value: t=%f", _tmp24_);
#line 970 "seed.c"
	}
#line 199 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	result = t;
#line 199 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	return result;
#line 976 "seed.c"
}


/**
 * To avoid unnecessary memory allocation, distance_to_param is populated
 * only before rendering, and released after rendering.
 */
void seed_start_render (Seed* self) {
#line 206 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 208 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	seed_init_distance_to_parametric (self);
#line 209 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	seed_init_self_intersect (self);
#line 210 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	seed_init_projection (self);
#line 993 "seed.c"
}


void seed_stop_render (Seed* self) {
#line 213 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 214 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->distance_to_param = (g_free (self->distance_to_param), NULL);
#line 214 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->distance_to_param = NULL;
#line 214 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->distance_to_param_length1 = 0;
#line 215 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->priv->self_intersect = (g_free (self->priv->self_intersect), NULL);
#line 215 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->priv->self_intersect = NULL;
#line 215 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->priv->self_intersect_length1 = 0;
#line 215 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->priv->_self_intersect_size_ = self->priv->self_intersect_length1;
#line 216 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->projection = (_vala_array_free (self->projection, self->projection_length1, (GDestroyNotify) projection_unref), NULL);
#line 216 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->projection = NULL;
#line 216 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->projection_length1 = 0;
#line 1020 "seed.c"
}


/**
 * Populate distance_to_param table.
 */
static void seed_real_init_distance_to_parametric (Seed* self) {
	gdouble length;
	Point _tmp0_ = {0};
	Point p0;
	gint div_calc;
	gboolean normalized;
	gdouble _tmp22_;
	gdouble _tmp23_ = 0.0;
	gboolean _tmp24_;
	gdouble _tmp27_;
	gint _tmp28_ = 0;
	gint _tmp29_;
	gdouble* _tmp30_ = NULL;
	gdouble* _tmp31_;
	gint _tmp31__length1;
	gdouble _tmp32_;
	gdouble* _tmp33_;
	gint _tmp33__length1;
	gint _tmp34_;
	gdouble _tmp35_;
	gint i0;
	gdouble len_1;
	gdouble dist_0;
	gdouble dist_1;
#line 224 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	length = 0.0;
#line 225 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	seed_point_raw (self, (gdouble) 0, &_tmp0_);
#line 225 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	p0 = _tmp0_;
#line 226 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	div_calc = 5000;
#line 227 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	normalized = TRUE;
#line 1061 "seed.c"
	{
		gint i;
#line 228 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		i = 1;
#line 1066 "seed.c"
		{
			gboolean _tmp1_;
#line 228 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp1_ = TRUE;
#line 228 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			while (TRUE) {
#line 1073 "seed.c"
				gboolean _tmp2_;
				gint _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
				Point _tmp8_ = {0};
				Point p1;
				gboolean _tmp9_ = FALSE;
				Point _tmp10_;
				gdouble _tmp11_;
				gdouble _tmp12_ = 0.0;
				gboolean _tmp16_;
				gdouble _tmp17_;
				Point _tmp18_;
				Point _tmp19_;
				gdouble _tmp20_ = 0.0;
				Point _tmp21_;
#line 228 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp2_ = _tmp1_;
#line 228 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				if (!_tmp2_) {
#line 1095 "seed.c"
					gint _tmp3_;
#line 228 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp3_ = i;
#line 228 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					i = _tmp3_ + 1;
#line 1101 "seed.c"
				}
#line 228 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp1_ = FALSE;
#line 228 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp4_ = i;
#line 228 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp5_ = div_calc;
#line 228 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				if (!(_tmp4_ <= _tmp5_)) {
#line 228 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					break;
#line 1113 "seed.c"
				}
#line 229 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp6_ = i;
#line 229 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp7_ = div_calc;
#line 229 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				seed_point_raw (self, ((gdouble) _tmp6_) / _tmp7_, &_tmp8_);
#line 229 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				p1 = _tmp8_;
#line 230 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp10_ = p1;
#line 230 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp11_ = _tmp10_.x;
#line 230 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp12_ = fabs (_tmp11_);
#line 230 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				if (_tmp12_ > 3.0) {
#line 1131 "seed.c"
					Point _tmp13_;
					gdouble _tmp14_;
					gdouble _tmp15_ = 0.0;
#line 230 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp13_ = p1;
#line 230 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp14_ = _tmp13_.y;
#line 230 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp15_ = fabs (_tmp14_);
#line 230 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp9_ = _tmp15_ > 3.0;
#line 1143 "seed.c"
				} else {
#line 230 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp9_ = FALSE;
#line 1147 "seed.c"
				}
#line 230 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp16_ = _tmp9_;
#line 230 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				if (_tmp16_) {
#line 230 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					normalized = FALSE;
#line 1155 "seed.c"
				}
#line 231 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp17_ = length;
#line 231 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp18_ = p0;
#line 231 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp19_ = p1;
#line 231 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp20_ = point_hypot (&_tmp18_, &_tmp19_);
#line 231 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				length = _tmp17_ + _tmp20_;
#line 232 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp21_ = p1;
#line 232 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				p0 = _tmp21_;
#line 1171 "seed.c"
			}
		}
	}
#line 234 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp22_ = length;
#line 234 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	if (_tmp22_ == ((gdouble) 0)) {
#line 235 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		self->distance_to_param = (g_free (self->distance_to_param), NULL);
#line 235 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		self->distance_to_param = NULL;
#line 235 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		self->distance_to_param_length1 = 0;
#line 236 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		return;
#line 1187 "seed.c"
	}
#line 242 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp24_ = normalized;
#line 242 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	if (_tmp24_) {
#line 1193 "seed.c"
		gdouble _tmp25_;
#line 242 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp25_ = length;
#line 242 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp23_ = _tmp25_ * 1000;
#line 1199 "seed.c"
	} else {
		gdouble _tmp26_;
#line 242 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp26_ = length;
#line 242 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp23_ = _tmp26_;
#line 1206 "seed.c"
	}
#line 242 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp27_ = _tmp23_;
#line 242 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp28_ = MAX (100, ((gint) _tmp27_) / 5);
#line 242 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->priv->div = _tmp28_;
#line 243 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp29_ = self->priv->div;
#line 243 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp30_ = g_new0 (gdouble, _tmp29_ + 1);
#line 243 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->distance_to_param = (g_free (self->distance_to_param), NULL);
#line 243 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->distance_to_param = _tmp30_;
#line 243 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->distance_to_param_length1 = _tmp29_ + 1;
#line 244 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp31_ = self->distance_to_param;
#line 244 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp31__length1 = self->distance_to_param_length1;
#line 244 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp31_[0] = 0.0;
#line 244 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp32_ = _tmp31_[0];
#line 245 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp33_ = self->distance_to_param;
#line 245 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp33__length1 = self->distance_to_param_length1;
#line 245 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp34_ = self->priv->div;
#line 245 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp33_[_tmp34_] = 1.0;
#line 245 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp35_ = _tmp33_[_tmp34_];
#line 248 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	i0 = -1;
#line 249 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	len_1 = 0.0;
#line 250 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	dist_0 = 0.0;
#line 251 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	dist_1 = 0.0;
#line 1250 "seed.c"
	{
		gint d;
#line 252 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		d = 1;
#line 1255 "seed.c"
		{
			gboolean _tmp36_;
#line 252 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp36_ = TRUE;
#line 252 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			while (TRUE) {
#line 1262 "seed.c"
				gboolean _tmp37_;
				gint _tmp39_;
				gint _tmp40_;
				gint _tmp41_;
				gint _tmp42_;
				gdouble distance;
				gboolean _tmp61_ = FALSE;
				gdouble _tmp62_;
				gdouble _tmp63_;
				gboolean _tmp66_;
				gdouble _tmp67_ = 0.0;
				gdouble _tmp68_;
				gdouble _tmp69_;
				gdouble _tmp70_ = 0.0;
				gdouble _tmp71_;
				gdouble _tmp80_;
				gdouble t;
				gdouble _tmp81_;
				gdouble _tmp82_;
				gdouble* _tmp84_;
				gint _tmp84__length1;
				gint _tmp85_;
				gdouble _tmp86_;
				gdouble _tmp87_;
#line 252 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp37_ = _tmp36_;
#line 252 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				if (!_tmp37_) {
#line 1291 "seed.c"
					gint _tmp38_;
#line 252 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp38_ = d;
#line 252 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					d = _tmp38_ + 1;
#line 1297 "seed.c"
				}
#line 252 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp36_ = FALSE;
#line 252 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp39_ = d;
#line 252 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp40_ = self->priv->div;
#line 252 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				if (!(_tmp39_ < _tmp40_)) {
#line 252 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					break;
#line 1309 "seed.c"
				}
#line 253 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp41_ = d;
#line 253 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp42_ = self->priv->div;
#line 253 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				distance = ((gdouble) _tmp41_) / _tmp42_;
#line 255 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				while (TRUE) {
#line 1319 "seed.c"
					gdouble _tmp43_;
					gdouble _tmp44_;
					gint _tmp45_;
					gint _tmp46_;
					gint _tmp47_;
					gint _tmp48_;
					gint _tmp49_;
					Point _tmp50_ = {0};
					gint _tmp51_;
					gint _tmp52_;
					Point _tmp53_ = {0};
					Point p1;
					gdouble _tmp54_;
					Point _tmp55_;
					Point _tmp56_;
					gdouble _tmp57_ = 0.0;
					gdouble _tmp58_;
					gdouble _tmp59_;
					gdouble _tmp60_;
#line 255 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp43_ = dist_1;
#line 255 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp44_ = distance;
#line 255 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					if (!(_tmp43_ < _tmp44_)) {
#line 255 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
						break;
#line 1347 "seed.c"
					}
#line 256 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp45_ = i0;
#line 256 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					i0 = _tmp45_ + 1;
#line 257 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp46_ = i0;
#line 257 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp47_ = div_calc;
#line 257 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_vala_assert ((_tmp46_ + 1) <= _tmp47_, "i0 + 1 <= div_calc");
#line 258 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp48_ = i0;
#line 258 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp49_ = div_calc;
#line 258 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					seed_point_raw (self, ((gdouble) _tmp48_) / _tmp49_, &_tmp50_);
#line 258 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					p0 = _tmp50_;
#line 259 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp51_ = i0;
#line 259 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp52_ = div_calc;
#line 259 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					seed_point_raw (self, ((gdouble) (_tmp51_ + 1)) / _tmp52_, &_tmp53_);
#line 259 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					p1 = _tmp53_;
#line 260 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp54_ = len_1;
#line 260 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp55_ = p0;
#line 260 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp56_ = p1;
#line 260 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp57_ = point_hypot (&_tmp55_, &_tmp56_);
#line 260 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					len_1 = _tmp54_ + _tmp57_;
#line 261 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp58_ = dist_1;
#line 261 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					dist_0 = _tmp58_;
#line 262 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp59_ = len_1;
#line 262 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp60_ = length;
#line 262 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					dist_1 = _tmp59_ / _tmp60_;
#line 1395 "seed.c"
				}
#line 264 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp62_ = dist_0;
#line 264 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp63_ = distance;
#line 264 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				if (_tmp62_ <= _tmp63_) {
#line 1403 "seed.c"
					gdouble _tmp64_;
					gdouble _tmp65_;
#line 264 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp64_ = distance;
#line 264 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp65_ = dist_1;
#line 264 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp61_ = _tmp64_ <= _tmp65_;
#line 1412 "seed.c"
				} else {
#line 264 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp61_ = FALSE;
#line 1416 "seed.c"
				}
#line 264 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp66_ = _tmp61_;
#line 264 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				if (!_tmp66_) {
#line 1422 "seed.c"
				}
#line 267 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp68_ = dist_1;
#line 267 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp69_ = dist_0;
#line 267 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp70_ = fabs (_tmp68_ - _tmp69_);
#line 267 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp71_ = seed_epsilon;
#line 267 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				if (_tmp70_ < _tmp71_) {
#line 1434 "seed.c"
					gint _tmp72_;
					gint _tmp73_;
#line 268 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp72_ = i0;
#line 268 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp73_ = div_calc;
#line 268 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp67_ = ((gdouble) _tmp72_) / _tmp73_;
#line 1443 "seed.c"
				} else {
					gint _tmp74_;
					gdouble _tmp75_;
					gdouble _tmp76_;
					gdouble _tmp77_;
					gdouble _tmp78_;
					gint _tmp79_;
#line 269 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp74_ = i0;
#line 269 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp75_ = distance;
#line 269 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp76_ = dist_0;
#line 269 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp77_ = dist_1;
#line 269 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp78_ = dist_0;
#line 269 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp79_ = div_calc;
#line 269 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp67_ = (_tmp74_ + ((_tmp75_ - _tmp76_) / (_tmp77_ - _tmp78_))) / _tmp79_;
#line 1465 "seed.c"
				}
#line 267 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp80_ = _tmp67_;
#line 267 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				t = _tmp80_;
#line 270 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp81_ = t;
#line 270 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				if (_tmp81_ > ((gdouble) 1)) {
#line 270 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					t = (gdouble) 1;
#line 1477 "seed.c"
				}
#line 271 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp82_ = t;
#line 271 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				if (_tmp82_ < ((gdouble) 0)) {
#line 1483 "seed.c"
					gdouble _tmp83_;
#line 272 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp83_ = t;
#line 272 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					g_warning ("seed.vala:272: unexpected value: t=%f (set to 0)", _tmp83_);
#line 273 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					t = (gdouble) 0;
#line 1491 "seed.c"
				}
#line 275 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp84_ = self->distance_to_param;
#line 275 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp84__length1 = self->distance_to_param_length1;
#line 275 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp85_ = d;
#line 275 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp86_ = t;
#line 275 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp84_[_tmp85_] = _tmp86_;
#line 275 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp87_ = _tmp84_[_tmp85_];
#line 1505 "seed.c"
			}
		}
	}
}


void seed_init_distance_to_parametric (Seed* self) {
#line 222 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 222 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	SEED_GET_CLASS (self)->init_distance_to_parametric (self);
#line 1517 "seed.c"
}


/**
 * Check if segment n is self-intersecting
 */
gboolean seed_check_twisted (Seed* self, gint n) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean* _tmp1_;
	gint _tmp1__length1;
	gboolean _tmp5_;
	gboolean test;
#line 282 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 283 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp1_ = self->priv->self_intersect;
#line 283 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp1__length1 = self->priv->self_intersect_length1;
#line 283 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	if (_tmp1_ != NULL) {
#line 1539 "seed.c"
		gboolean* _tmp2_;
		gint _tmp2__length1;
		gint _tmp3_;
		gboolean _tmp4_;
#line 283 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp2_ = self->priv->self_intersect;
#line 283 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp2__length1 = self->priv->self_intersect_length1;
#line 283 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp3_ = n;
#line 283 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp4_ = _tmp2_[_tmp3_];
#line 283 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp0_ = _tmp4_;
#line 1554 "seed.c"
	} else {
#line 283 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp0_ = FALSE;
#line 1558 "seed.c"
	}
#line 283 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp5_ = _tmp0_;
#line 283 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	test = _tmp5_;
#line 284 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	result = test;
#line 284 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	return result;
#line 1568 "seed.c"
}


/**
 * Initialize self_intersect table.
 */
static void seed_init_self_intersect (Seed* self) {
	gint _tmp0_;
	gboolean* _tmp1_ = NULL;
#line 290 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 291 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp0_ = self->num_segment;
#line 291 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp1_ = g_new0 (gboolean, _tmp0_);
#line 291 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->priv->self_intersect = (g_free (self->priv->self_intersect), NULL);
#line 291 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->priv->self_intersect = _tmp1_;
#line 291 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->priv->self_intersect_length1 = _tmp0_;
#line 291 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->priv->_self_intersect_size_ = self->priv->self_intersect_length1;
#line 1592 "seed.c"
	{
		gint i;
#line 292 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		i = 0;
#line 1597 "seed.c"
		{
			gboolean _tmp2_;
#line 292 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp2_ = TRUE;
#line 292 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			while (TRUE) {
#line 1604 "seed.c"
				gboolean _tmp3_;
				gint _tmp5_;
				gint _tmp6_;
				gboolean* _tmp7_;
				gint _tmp7__length1;
				gint _tmp8_;
				gint _tmp9_;
				gboolean _tmp10_ = FALSE;
				gboolean _tmp11_;
				gboolean _tmp12_ = FALSE;
				gboolean _tmp13_;
				gboolean _tmp17_;
#line 292 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp3_ = _tmp2_;
#line 292 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				if (!_tmp3_) {
#line 1621 "seed.c"
					gint _tmp4_;
#line 292 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp4_ = i;
#line 292 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					i = _tmp4_ + 1;
#line 1627 "seed.c"
				}
#line 292 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp2_ = FALSE;
#line 292 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp5_ = i;
#line 292 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp6_ = self->num_segment;
#line 292 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				if (!(_tmp5_ < _tmp6_)) {
#line 292 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					break;
#line 1639 "seed.c"
				}
#line 293 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp7_ = self->priv->self_intersect;
#line 293 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp7__length1 = self->priv->self_intersect_length1;
#line 293 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp8_ = i;
#line 293 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp9_ = i;
#line 293 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp10_ = seed_check_self_intersect (self, _tmp9_);
#line 293 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp7_[_tmp8_] = _tmp10_;
#line 293 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp11_ = _tmp7_[_tmp8_];
#line 294 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp13_ = self->priv->twisted;
#line 294 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				if (_tmp13_) {
#line 294 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp12_ = TRUE;
#line 1661 "seed.c"
				} else {
					gboolean* _tmp14_;
					gint _tmp14__length1;
					gint _tmp15_;
					gboolean _tmp16_;
#line 294 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp14_ = self->priv->self_intersect;
#line 294 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp14__length1 = self->priv->self_intersect_length1;
#line 294 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp15_ = i;
#line 294 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp16_ = _tmp14_[_tmp15_];
#line 294 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp12_ = _tmp16_;
#line 1677 "seed.c"
				}
#line 294 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp17_ = _tmp12_;
#line 294 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				self->priv->twisted = _tmp17_;
#line 1683 "seed.c"
			}
		}
	}
}


/**
 * Check if the normals striding segment n intersect each other
 * or the curve joining their corresponding ends.
 */
static gboolean seed_check_self_intersect (Seed* self, gint n) {
	gboolean result = FALSE;
	gint _tmp0_;
	gint _tmp1_;
	gdouble t0;
	gint _tmp2_;
	gint _tmp3_;
	gdouble t1;
	gdouble _tmp4_;
	gdouble _tmp5_;
	Point _tmp6_ = {0};
	Point p0;
	gdouble _tmp7_;
	gdouble _tmp8_;
	Point _tmp9_ = {0};
	Point p1;
	gdouble _tmp10_;
	gdouble _tmp11_;
	Point _tmp12_ = {0};
	Point q0;
	gdouble _tmp13_;
	gdouble _tmp14_;
	Point _tmp15_ = {0};
	Point q1;
	Point _tmp16_;
	Point _tmp17_;
	Point _tmp18_;
	Point _tmp19_;
	gboolean _tmp20_ = FALSE;
	gint _tmp21_;
	gint _tmp22_;
	gint _tmp23_ = 0;
	gint num_points;
#line 302 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 303 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp0_ = n;
#line 303 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp1_ = self->num_segment;
#line 303 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	t0 = ((gdouble) _tmp0_) / _tmp1_;
#line 304 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp2_ = n;
#line 304 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp3_ = self->num_segment;
#line 304 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	t1 = ((gdouble) (_tmp2_ + 1)) / _tmp3_;
#line 306 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp4_ = t0;
#line 306 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp5_ = self->base_offset;
#line 306 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	seed_distant_point (self, _tmp4_, _tmp5_, &_tmp6_);
#line 306 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	p0 = _tmp6_;
#line 307 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp7_ = t0;
#line 307 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp8_ = self->base_offset;
#line 307 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	seed_distant_point (self, _tmp7_, _tmp8_ - 1, &_tmp9_);
#line 307 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	p1 = _tmp9_;
#line 309 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp10_ = t1;
#line 309 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp11_ = self->base_offset;
#line 309 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	seed_distant_point (self, _tmp10_, _tmp11_, &_tmp12_);
#line 309 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	q0 = _tmp12_;
#line 310 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp13_ = t1;
#line 310 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp14_ = self->base_offset;
#line 310 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	seed_distant_point (self, _tmp13_, _tmp14_ - 1, &_tmp15_);
#line 310 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	q1 = _tmp15_;
#line 312 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp16_ = p0;
#line 312 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp17_ = p1;
#line 312 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp18_ = q0;
#line 312 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp19_ = q1;
#line 312 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp20_ = seed_check_intersect (&_tmp16_, &_tmp17_, &_tmp18_, &_tmp19_);
#line 312 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	if (_tmp20_) {
#line 312 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		result = TRUE;
#line 312 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		return result;
#line 1789 "seed.c"
	}
#line 320 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp21_ = self->priv->div;
#line 320 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp22_ = self->num_segment;
#line 320 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp23_ = MAX (50, _tmp21_ / _tmp22_);
#line 320 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	num_points = _tmp23_;
#line 1799 "seed.c"
	{
		gint k;
#line 321 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		k = 0;
#line 1804 "seed.c"
		{
			gboolean _tmp24_;
#line 321 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp24_ = TRUE;
#line 321 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			while (TRUE) {
#line 1811 "seed.c"
				gboolean _tmp25_;
				gint _tmp27_;
				gint _tmp28_;
#line 321 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp25_ = _tmp24_;
#line 321 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				if (!_tmp25_) {
#line 1819 "seed.c"
					gint _tmp26_;
#line 321 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp26_ = k;
#line 321 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					k = _tmp26_ + 1;
#line 1825 "seed.c"
				}
#line 321 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp24_ = FALSE;
#line 321 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp27_ = k;
#line 321 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				if (!(_tmp27_ < 2)) {
#line 321 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					break;
#line 1835 "seed.c"
				}
#line 322 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp28_ = num_points;
#line 322 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				num_points = _tmp28_ + 1;
#line 1841 "seed.c"
				{
					gint i;
#line 323 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					i = 0;
#line 1846 "seed.c"
					{
						gboolean _tmp29_;
#line 323 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
						_tmp29_ = TRUE;
#line 323 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
						while (TRUE) {
#line 1853 "seed.c"
							gboolean _tmp30_;
							gint _tmp32_;
							gint _tmp33_;
							gdouble _tmp34_;
							gint _tmp35_;
							gint _tmp36_;
							gint _tmp37_;
							gdouble tA;
							gdouble _tmp38_;
							gint _tmp39_;
							gint _tmp40_;
							gint _tmp41_;
							gdouble tB;
							gdouble _tmp42_;
							gdouble _tmp43_;
							Point _tmp44_ = {0};
							Point pA;
							gdouble _tmp45_;
							gdouble _tmp46_;
							Point _tmp47_ = {0};
							Point pB;
							gdouble _tmp48_;
							gdouble _tmp49_;
							Point _tmp50_ = {0};
							Point qA;
							gdouble _tmp51_;
							gdouble _tmp52_;
							Point _tmp53_ = {0};
							Point qB;
							gboolean _tmp54_ = FALSE;
							gboolean _tmp55_ = FALSE;
							gboolean _tmp56_ = FALSE;
							Point _tmp57_;
							Point _tmp58_;
							Point _tmp59_;
							Point _tmp60_;
							gboolean _tmp61_ = FALSE;
							gboolean _tmp67_;
							gboolean _tmp73_;
							gboolean _tmp79_;
#line 323 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							_tmp30_ = _tmp29_;
#line 323 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							if (!_tmp30_) {
#line 1898 "seed.c"
								gint _tmp31_;
#line 323 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
								_tmp31_ = i;
#line 323 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
								i = _tmp31_ + 1;
#line 1904 "seed.c"
							}
#line 323 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							_tmp29_ = FALSE;
#line 323 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							_tmp32_ = i;
#line 323 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							_tmp33_ = num_points;
#line 323 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							if (!(_tmp32_ < _tmp33_)) {
#line 323 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
								break;
#line 1916 "seed.c"
							}
#line 324 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							_tmp34_ = t0;
#line 324 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							_tmp35_ = i;
#line 324 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							_tmp36_ = num_points;
#line 324 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							_tmp37_ = self->num_segment;
#line 324 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							tA = _tmp34_ + ((((gdouble) _tmp35_) / _tmp36_) / _tmp37_);
#line 325 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							_tmp38_ = t0;
#line 325 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							_tmp39_ = i;
#line 325 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							_tmp40_ = num_points;
#line 325 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							_tmp41_ = self->num_segment;
#line 325 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							tB = _tmp38_ + ((((gdouble) (_tmp39_ + 1)) / _tmp40_) / _tmp41_);
#line 327 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							_tmp42_ = tA;
#line 327 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							_tmp43_ = self->base_offset;
#line 327 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							seed_distant_point (self, _tmp42_, _tmp43_, &_tmp44_);
#line 327 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							pA = _tmp44_;
#line 328 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							_tmp45_ = tB;
#line 328 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							_tmp46_ = self->base_offset;
#line 328 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							seed_distant_point (self, _tmp45_, _tmp46_, &_tmp47_);
#line 328 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							pB = _tmp47_;
#line 329 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							_tmp48_ = tA;
#line 329 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							_tmp49_ = self->base_offset;
#line 329 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							seed_distant_point (self, _tmp48_, _tmp49_ - 1, &_tmp50_);
#line 329 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							qA = _tmp50_;
#line 330 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							_tmp51_ = tB;
#line 330 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							_tmp52_ = self->base_offset;
#line 330 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							seed_distant_point (self, _tmp51_, _tmp52_ - 1, &_tmp53_);
#line 330 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							qB = _tmp53_;
#line 331 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							_tmp57_ = p0;
#line 331 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							_tmp58_ = p1;
#line 331 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							_tmp59_ = pA;
#line 331 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							_tmp60_ = pB;
#line 331 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							_tmp61_ = seed_check_intersect (&_tmp57_, &_tmp58_, &_tmp59_, &_tmp60_);
#line 331 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							if (_tmp61_) {
#line 331 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
								_tmp56_ = TRUE;
#line 1984 "seed.c"
							} else {
								Point _tmp62_;
								Point _tmp63_;
								Point _tmp64_;
								Point _tmp65_;
								gboolean _tmp66_ = FALSE;
#line 332 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
								_tmp62_ = p0;
#line 332 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
								_tmp63_ = p1;
#line 332 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
								_tmp64_ = qA;
#line 332 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
								_tmp65_ = qB;
#line 332 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
								_tmp66_ = seed_check_intersect (&_tmp62_, &_tmp63_, &_tmp64_, &_tmp65_);
#line 332 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
								_tmp56_ = _tmp66_;
#line 2003 "seed.c"
							}
#line 331 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							_tmp67_ = _tmp56_;
#line 331 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							if (_tmp67_) {
#line 331 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
								_tmp55_ = TRUE;
#line 2011 "seed.c"
							} else {
								Point _tmp68_;
								Point _tmp69_;
								Point _tmp70_;
								Point _tmp71_;
								gboolean _tmp72_ = FALSE;
#line 333 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
								_tmp68_ = q0;
#line 333 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
								_tmp69_ = q1;
#line 333 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
								_tmp70_ = pA;
#line 333 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
								_tmp71_ = pB;
#line 333 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
								_tmp72_ = seed_check_intersect (&_tmp68_, &_tmp69_, &_tmp70_, &_tmp71_);
#line 333 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
								_tmp55_ = _tmp72_;
#line 2030 "seed.c"
							}
#line 331 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							_tmp73_ = _tmp55_;
#line 331 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							if (_tmp73_) {
#line 331 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
								_tmp54_ = TRUE;
#line 2038 "seed.c"
							} else {
								Point _tmp74_;
								Point _tmp75_;
								Point _tmp76_;
								Point _tmp77_;
								gboolean _tmp78_ = FALSE;
#line 334 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
								_tmp74_ = q0;
#line 334 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
								_tmp75_ = q1;
#line 334 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
								_tmp76_ = qA;
#line 334 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
								_tmp77_ = qB;
#line 334 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
								_tmp78_ = seed_check_intersect (&_tmp74_, &_tmp75_, &_tmp76_, &_tmp77_);
#line 334 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
								_tmp54_ = _tmp78_;
#line 2057 "seed.c"
							}
#line 331 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							_tmp79_ = _tmp54_;
#line 331 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							if (_tmp79_) {
#line 336 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
								result = TRUE;
#line 336 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
								return result;
#line 2067 "seed.c"
							}
						}
					}
				}
			}
		}
	}
#line 340 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	result = FALSE;
#line 340 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	return result;
#line 2079 "seed.c"
}


/**
 * Is p1, p2, p3 clockwise (-ve area), anti-clockwise (+ve area), or colinear (zero) ?
 * We want the sign rather than the actual area.
 */
static gdouble seed_area_sign (Point* p1, Point* p2, Point* p3) {
	gdouble result = 0.0;
	Point _tmp0_;
	gdouble _tmp1_;
	Point _tmp2_;
	gdouble _tmp3_;
	Point _tmp4_;
	gdouble _tmp5_;
	Point _tmp6_;
	gdouble _tmp7_;
	Point _tmp8_;
	gdouble _tmp9_;
	Point _tmp10_;
	gdouble _tmp11_;
	Point _tmp12_;
	gdouble _tmp13_;
	Point _tmp14_;
	gdouble _tmp15_;
	gdouble area;
	gdouble _tmp16_;
	gdouble _tmp17_ = 0.0;
	gdouble _tmp18_;
#line 347 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_val_if_fail (p1 != NULL, 0.0);
#line 347 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_val_if_fail (p2 != NULL, 0.0);
#line 347 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_val_if_fail (p3 != NULL, 0.0);
#line 348 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp0_ = *p2;
#line 348 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp1_ = _tmp0_.x;
#line 348 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp2_ = *p1;
#line 348 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp3_ = _tmp2_.x;
#line 348 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp4_ = *p3;
#line 348 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp5_ = _tmp4_.y;
#line 348 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp6_ = *p1;
#line 348 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp7_ = _tmp6_.y;
#line 348 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp8_ = *p3;
#line 348 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp9_ = _tmp8_.x;
#line 348 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp10_ = *p1;
#line 348 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp11_ = _tmp10_.x;
#line 348 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp12_ = *p2;
#line 348 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp13_ = _tmp12_.y;
#line 348 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp14_ = *p1;
#line 348 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp15_ = _tmp14_.y;
#line 348 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	area = ((_tmp1_ - _tmp3_) * (_tmp5_ - _tmp7_)) - ((_tmp9_ - _tmp11_) * (_tmp13_ - _tmp15_));
#line 349 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp16_ = area;
#line 349 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp17_ = fabs (_tmp16_);
#line 349 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp18_ = seed_epsilon;
#line 349 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	if (_tmp17_ <= _tmp18_) {
#line 349 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		result = (gdouble) 0;
#line 349 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		return result;
#line 2161 "seed.c"
	}
#line 350 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	result = area;
#line 350 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	return result;
#line 2167 "seed.c"
}


/**
 * Are the two lines p1-p2 and q1-q2 intersecting?
 */
static gboolean seed_check_intersect (Point* p1, Point* p2, Point* q1, Point* q2) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	Point _tmp1_;
	Point _tmp2_;
	Point _tmp3_;
	gdouble _tmp4_ = 0.0;
	Point _tmp5_;
	Point _tmp6_;
	Point _tmp7_;
	gdouble _tmp8_ = 0.0;
	gboolean _tmp17_;
#line 356 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_val_if_fail (p1 != NULL, FALSE);
#line 356 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_val_if_fail (p2 != NULL, FALSE);
#line 356 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_val_if_fail (q1 != NULL, FALSE);
#line 356 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_val_if_fail (q2 != NULL, FALSE);
#line 359 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp1_ = *p1;
#line 359 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp2_ = *p2;
#line 359 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp3_ = *q1;
#line 359 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp4_ = seed_area_sign (&_tmp1_, &_tmp2_, &_tmp3_);
#line 359 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp5_ = *p1;
#line 359 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp6_ = *p2;
#line 359 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp7_ = *q2;
#line 359 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp8_ = seed_area_sign (&_tmp5_, &_tmp6_, &_tmp7_);
#line 359 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	if ((_tmp4_ * _tmp8_) < ((gdouble) 0)) {
#line 2212 "seed.c"
		Point _tmp9_;
		Point _tmp10_;
		Point _tmp11_;
		gdouble _tmp12_ = 0.0;
		Point _tmp13_;
		Point _tmp14_;
		Point _tmp15_;
		gdouble _tmp16_ = 0.0;
#line 361 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp9_ = *q1;
#line 361 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp10_ = *q2;
#line 361 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp11_ = *p1;
#line 361 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp12_ = seed_area_sign (&_tmp9_, &_tmp10_, &_tmp11_);
#line 361 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp13_ = *q1;
#line 361 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp14_ = *q2;
#line 361 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp15_ = *p2;
#line 361 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp16_ = seed_area_sign (&_tmp13_, &_tmp14_, &_tmp15_);
#line 361 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp0_ = (_tmp12_ * _tmp16_) < ((gdouble) 0);
#line 2239 "seed.c"
	} else {
#line 359 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp0_ = FALSE;
#line 2243 "seed.c"
	}
#line 357 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp17_ = _tmp0_;
#line 357 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	result = _tmp17_;
#line 357 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	return result;
#line 2251 "seed.c"
}


/**
 * Precompute projections represented by each segment
 */
static void seed_init_projection (Seed* self) {
	gint _tmp0_;
	Projection** _tmp1_ = NULL;
#line 367 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 368 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp0_ = self->num_segment;
#line 368 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp1_ = g_new0 (Projection*, _tmp0_ + 1);
#line 368 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->projection = (_vala_array_free (self->projection, self->projection_length1, (GDestroyNotify) projection_unref), NULL);
#line 368 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->projection = _tmp1_;
#line 368 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->projection_length1 = _tmp0_;
#line 2273 "seed.c"
	{
		gint _tmp2_;
		gint i;
#line 369 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp2_ = self->num_segment;
#line 369 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		i = _tmp2_ - 1;
#line 2281 "seed.c"
		{
			gboolean _tmp3_;
#line 369 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp3_ = TRUE;
#line 369 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			while (TRUE) {
#line 2288 "seed.c"
				gboolean _tmp4_;
				gint _tmp6_;
				gint _tmp7_;
				gboolean odd;
				gint _tmp8_;
				gint _tmp9_;
				gdouble t0;
				gint _tmp10_;
				gint _tmp11_;
				gdouble t1;
				Flip _tmp12_ = 0;
				gboolean _tmp13_;
				Projection** _tmp16_;
				gint _tmp16__length1;
				gint _tmp17_;
				gdouble _tmp18_;
				gdouble _tmp19_;
				Flip _tmp20_;
				Projection* _tmp21_;
				Projection* _tmp22_;
#line 369 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp4_ = _tmp3_;
#line 369 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				if (!_tmp4_) {
#line 2313 "seed.c"
					gint _tmp5_;
#line 369 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp5_ = i;
#line 369 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					i = _tmp5_ - 1;
#line 2319 "seed.c"
				}
#line 369 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp3_ = FALSE;
#line 369 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp6_ = i;
#line 369 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				if (!(_tmp6_ >= 0)) {
#line 369 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					break;
#line 2329 "seed.c"
				}
#line 370 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp7_ = i;
#line 370 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				odd = (_tmp7_ % 2) == 1;
#line 371 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp8_ = i;
#line 371 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp9_ = self->num_segment;
#line 371 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				t0 = ((gdouble) _tmp8_) / _tmp9_;
#line 372 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp10_ = i;
#line 372 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp11_ = self->num_segment;
#line 372 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				t1 = ((gdouble) (_tmp10_ + 1)) / _tmp11_;
#line 373 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp13_ = odd;
#line 373 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				if (_tmp13_) {
#line 2351 "seed.c"
					Flip _tmp14_;
#line 373 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp14_ = self->flip_odd;
#line 373 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp12_ = _tmp14_;
#line 2357 "seed.c"
				} else {
					Flip _tmp15_;
#line 373 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp15_ = self->flip_even;
#line 373 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp12_ = _tmp15_;
#line 2364 "seed.c"
				}
#line 373 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp16_ = self->projection;
#line 373 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp16__length1 = self->projection_length1;
#line 373 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp17_ = i;
#line 373 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp18_ = t0;
#line 373 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp19_ = t1;
#line 373 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp20_ = _tmp12_;
#line 373 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp21_ = projection_new (NULL, self, _tmp18_, _tmp19_, _tmp20_);
#line 373 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_projection_unref0 (_tmp16_[_tmp17_]);
#line 373 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp16_[_tmp17_] = _tmp21_;
#line 373 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp22_ = _tmp16_[_tmp17_];
#line 2386 "seed.c"
			}
		}
	}
}


/**
 * Compute the point at the given distance from (x(t), y(t))
 * Distance is scaled according to width0 and width1.
 */
void seed_distant_point (Seed* self, gdouble t, gdouble distance, Point* result) {
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble length;
	gdouble _tmp5_;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_;
	Point _tmp8_ = {0};
	Point p;
	gdouble _tmp9_;
	gdouble _tmp10_ = 0.0;
	gdouble angle;
	gdouble _tmp11_;
	gdouble _tmp12_ = 0.0;
	gdouble _tmp13_;
	gdouble _tmp14_ = 0.0;
#line 381 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 382 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp0_ = distance;
#line 382 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp1_ = t;
#line 382 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp2_ = self->width0;
#line 382 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp3_ = t;
#line 382 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp4_ = self->width1;
#line 382 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	length = _tmp0_ * (((1 - _tmp1_) * _tmp2_) + (_tmp3_ * _tmp4_));
#line 383 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp5_ = t;
#line 383 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp6_ = seed_parameter (self, _tmp5_);
#line 383 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	t = _tmp6_;
#line 384 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp7_ = t;
#line 384 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	seed_point_raw (self, _tmp7_, &_tmp8_);
#line 384 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	p = _tmp8_;
#line 385 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp9_ = t;
#line 385 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp10_ = seed_perpendicular_angle (self, _tmp9_);
#line 385 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	angle = _tmp10_;
#line 386 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp11_ = p.x;
#line 386 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp12_ = cos (angle);
#line 386 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	p.x = _tmp11_ + (length * _tmp12_);
#line 387 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp13_ = p.y;
#line 387 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp14_ = sin (angle);
#line 387 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	p.y = _tmp13_ + (length * _tmp14_);
#line 388 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	*result = p;
#line 388 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	return;
#line 2464 "seed.c"
}


/**
 * The slope of the perpendicular, in radian, at t.
 */
static gdouble seed_real_perpendicular_angle (Seed* self, gdouble t) {
#line 394 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_critical ("Type `%s' does not implement abstract method `seed_perpendicular_angle'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 394 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	return 0.0;
#line 2476 "seed.c"
}


gdouble seed_perpendicular_angle (Seed* self, gdouble t) {
#line 394 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 394 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	return SEED_GET_CLASS (self)->perpendicular_angle (self, t);
#line 2485 "seed.c"
}


/**
 * Is the projected shape thinner than the given thickness?
 * The thickness of the projected shape is calculated as area / perimeter.
 * As a side effect, calculate "width" for rendering.
 */
gboolean seed_too_thin (Seed* self, Projection* pr, Probe* probe, gdouble thickness, gboolean segment_twisted, gdouble* width) {
	gboolean result = FALSE;
	gdouble _tmp0_;
	gdouble limit;
	gdouble area_ax;
	gdouble area_bx;
	gdouble area_cx;
	gdouble area_dx;
	gdouble area_ab;
	gdouble area_bc;
	gdouble area_cd;
	gdouble area_da;
	gdouble perimeter;
	gdouble dummy;
	Projection* _tmp1_;
	Probe* _tmp2_;
	gdouble _tmp3_;
	Projection* _tmp4_;
	Probe* _tmp5_;
	gdouble _tmp6_;
	Projection* _tmp7_;
	Probe* _tmp8_;
	gdouble _tmp9_;
	Projection* _tmp10_;
	Probe* _tmp11_;
	gdouble _tmp12_;
	gdouble _tmp13_;
	gdouble _tmp14_;
	gdouble _tmp15_;
	gdouble _tmp16_;
	gdouble _tmp17_ = 0.0;
	gdouble area;
	gdouble _tmp18_;
	gdouble _tmp19_;
	gdouble _tmp20_;
	gdouble _tmp21_;
	gdouble _tmp22_;
	gboolean _tmp23_ = FALSE;
	gboolean _tmp24_;
	gboolean _tmp26_;
	Projection* _tmp27_;
	Probe* _tmp28_;
	gdouble _tmp29_;
	Projection* _tmp30_;
	Probe* _tmp31_;
	gdouble _tmp32_;
	Projection* _tmp33_;
	Probe* _tmp34_;
	gdouble _tmp35_;
	Projection* _tmp36_;
	Probe* _tmp37_;
	gdouble _tmp38_;
	gdouble _tmp39_;
	gdouble _tmp40_;
	gdouble _tmp41_;
	gdouble _tmp42_ = 0.0;
	gdouble _tmp43_;
	gdouble _tmp44_;
	gdouble _tmp45_;
	gdouble _tmp46_ = 0.0;
	gdouble _tmp47_;
	gdouble _tmp48_;
	gdouble _tmp49_;
	gdouble _tmp50_ = 0.0;
	gdouble _tmp51_;
	gdouble _tmp52_;
	gdouble _tmp53_;
	gdouble _tmp54_ = 0.0;
	gdouble _tmp55_;
	gdouble _tmp56_;
	gdouble _tmp57_;
	gdouble _tmp58_;
#line 401 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 402 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp0_ = thickness;
#line 402 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	limit = 0.5 * _tmp0_;
#line 412 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	area_ax = 0.0;
#line 413 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	area_bx = 0.0;
#line 414 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	area_cx = 0.0;
#line 415 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	area_dx = 0.0;
#line 416 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	area_ab = 0.0;
#line 417 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	area_bc = 0.0;
#line 418 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	area_cd = 0.0;
#line 419 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	area_da = 0.0;
#line 420 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	perimeter = 0.0;
#line 421 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	dummy = 0.0;
#line 423 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp1_ = pr;
#line 423 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp2_ = probe;
#line 423 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp3_ = limit;
#line 423 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	seed_compute_area_perimeter (self, _tmp1_, _tmp2_, _tmp3_, (gdouble) 0, (gdouble) 0, (gdouble) 1, (gdouble) 0, &area_ab, &perimeter);
#line 424 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp4_ = pr;
#line 424 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp5_ = probe;
#line 424 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp6_ = limit;
#line 424 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	seed_compute_area_perimeter (self, _tmp4_, _tmp5_, _tmp6_, (gdouble) 1, (gdouble) 0, (gdouble) 1, (gdouble) 1, &area_bc, &perimeter);
#line 425 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp7_ = pr;
#line 425 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp8_ = probe;
#line 425 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp9_ = limit;
#line 425 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	seed_compute_area_perimeter (self, _tmp7_, _tmp8_, _tmp9_, (gdouble) 1, (gdouble) 1, (gdouble) 0, (gdouble) 1, &area_cd, &perimeter);
#line 426 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp10_ = pr;
#line 426 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp11_ = probe;
#line 426 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp12_ = limit;
#line 426 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	seed_compute_area_perimeter (self, _tmp10_, _tmp11_, _tmp12_, (gdouble) 0, (gdouble) 1, (gdouble) 0, (gdouble) 0, &area_da, &perimeter);
#line 427 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp13_ = area_ab;
#line 427 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp14_ = area_bc;
#line 427 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp15_ = area_cd;
#line 427 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp16_ = area_da;
#line 427 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp17_ = fabs (((_tmp13_ + _tmp14_) + _tmp15_) + _tmp16_);
#line 427 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	area = _tmp17_;
#line 428 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp18_ = area;
#line 428 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp19_ = perimeter;
#line 428 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	*width = (3.5 * _tmp18_) / _tmp19_;
#line 431 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp20_ = perimeter;
#line 431 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	if (_tmp20_ <= ((gdouble) 6)) {
#line 431 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		result = TRUE;
#line 431 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		return result;
#line 2650 "seed.c"
	}
#line 434 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp21_ = *width;
#line 434 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp22_ = thickness;
#line 434 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	if (_tmp21_ > _tmp22_) {
#line 434 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		result = FALSE;
#line 434 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		return result;
#line 2662 "seed.c"
	}
#line 435 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp24_ = self->priv->twisted;
#line 435 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	if (!_tmp24_) {
#line 2668 "seed.c"
		gboolean _tmp25_;
#line 435 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp25_ = segment_twisted;
#line 435 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp23_ = !_tmp25_;
#line 2674 "seed.c"
	} else {
#line 435 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp23_ = FALSE;
#line 2678 "seed.c"
	}
#line 435 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp26_ = _tmp23_;
#line 435 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	if (_tmp26_) {
#line 435 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		result = TRUE;
#line 435 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		return result;
#line 2688 "seed.c"
	}
#line 438 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp27_ = pr;
#line 438 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp28_ = probe;
#line 438 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp29_ = limit;
#line 438 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	seed_compute_area_perimeter (self, _tmp27_, _tmp28_, _tmp29_, (gdouble) 0, (gdouble) 0, 0.5, 0.5, &area_ax, &dummy);
#line 439 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp30_ = pr;
#line 439 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp31_ = probe;
#line 439 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp32_ = limit;
#line 439 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	seed_compute_area_perimeter (self, _tmp30_, _tmp31_, _tmp32_, (gdouble) 1, (gdouble) 0, 0.5, 0.5, &area_bx, &dummy);
#line 440 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp33_ = pr;
#line 440 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp34_ = probe;
#line 440 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp35_ = limit;
#line 440 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	seed_compute_area_perimeter (self, _tmp33_, _tmp34_, _tmp35_, (gdouble) 1, (gdouble) 1, 0.5, 0.5, &area_cx, &dummy);
#line 441 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp36_ = pr;
#line 441 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp37_ = probe;
#line 441 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp38_ = limit;
#line 441 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	seed_compute_area_perimeter (self, _tmp36_, _tmp37_, _tmp38_, (gdouble) 0, (gdouble) 1, 0.5, 0.5, &area_dx, &dummy);
#line 443 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp39_ = area_ab;
#line 443 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp40_ = area_bx;
#line 443 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp41_ = area_ax;
#line 443 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp42_ = fabs ((_tmp39_ + _tmp40_) - _tmp41_);
#line 443 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp43_ = area_bc;
#line 443 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp44_ = area_cx;
#line 443 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp45_ = area_bx;
#line 443 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp46_ = fabs ((_tmp43_ + _tmp44_) - _tmp45_);
#line 443 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp47_ = area_cd;
#line 443 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp48_ = area_dx;
#line 443 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp49_ = area_cx;
#line 443 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp50_ = fabs ((_tmp47_ + _tmp48_) - _tmp49_);
#line 443 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp51_ = area_da;
#line 443 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp52_ = area_ax;
#line 443 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp53_ = area_dx;
#line 443 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp54_ = fabs ((_tmp51_ + _tmp52_) - _tmp53_);
#line 443 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	area = ((_tmp42_ + _tmp46_) + _tmp50_) + _tmp54_;
#line 447 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp55_ = area;
#line 447 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp56_ = perimeter;
#line 447 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	*width = (3.5 * _tmp55_) / _tmp56_;
#line 448 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp57_ = *width;
#line 448 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp58_ = thickness;
#line 448 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	result = _tmp57_ <= _tmp58_;
#line 448 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	return result;
#line 2770 "seed.c"
}


static void seed_compute_area_perimeter (Seed* self, Projection* pr, Probe* probe, gdouble limit, gdouble x0, gdouble y0, gdouble x1, gdouble y1, gdouble* area, gdouble* perimeter) {
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	Projection* _tmp4_;
	Probe* _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	Projection* _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	Point _tmp12_ = {0};
	Point _tmp13_ = {0};
	gdouble _tmp14_;
	gdouble _tmp15_;
	Projection* _tmp16_;
	gdouble _tmp17_;
	gdouble _tmp18_;
	Point _tmp19_ = {0};
	Point _tmp20_ = {0};
#line 451 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 455 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp0_ = self->base_offset;
#line 455 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp1_ = y0;
#line 455 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	y0 = _tmp0_ - _tmp1_;
#line 456 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp2_ = self->base_offset;
#line 456 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp3_ = y1;
#line 456 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	y1 = _tmp2_ - _tmp3_;
#line 457 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp4_ = pr;
#line 457 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp5_ = probe;
#line 457 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp6_ = limit;
#line 457 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp7_ = x0;
#line 457 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp8_ = y0;
#line 457 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp9_ = pr;
#line 457 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp10_ = x0;
#line 457 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp11_ = y0;
#line 457 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	seed_distant_point (self, _tmp10_, _tmp11_, &_tmp12_);
#line 457 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	projection_map (_tmp9_, &_tmp12_, &_tmp13_);
#line 457 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp14_ = x1;
#line 457 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp15_ = y1;
#line 457 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp16_ = pr;
#line 457 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp17_ = x1;
#line 457 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp18_ = y1;
#line 457 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	seed_distant_point (self, _tmp17_, _tmp18_, &_tmp19_);
#line 457 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	projection_map (_tmp16_, &_tmp19_, &_tmp20_);
#line 457 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	seed_compute_sub_area_perimeter (self, _tmp4_, _tmp5_, _tmp6_, _tmp7_, _tmp8_, &_tmp13_, _tmp14_, _tmp15_, &_tmp20_, area, perimeter, 1000);
#line 2846 "seed.c"
}


static void seed_compute_sub_area_perimeter (Seed* self, Projection* pr, Probe* probe, gdouble limit, gdouble x0, gdouble y0, Point* p0, gdouble x1, gdouble y1, Point* p1, gdouble* area, gdouble* perimeter, gint depth) {
#line 463 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 463 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_if_fail (p0 != NULL);
#line 463 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_if_fail (p1 != NULL);
#line 468 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	while (TRUE) {
#line 2859 "seed.c"
		gboolean _tmp0_ = FALSE;
		Probe* _tmp1_;
		gboolean _tmp4_;
		gdouble _tmp5_;
		gdouble _tmp6_;
		gdouble xm;
		gdouble _tmp7_;
		gdouble _tmp8_;
		gdouble ym;
		Projection* _tmp9_;
		gdouble _tmp10_;
		gdouble _tmp11_;
		Point _tmp12_ = {0};
		Point _tmp13_ = {0};
		Point pm;
		Point _tmp14_;
		Point _tmp15_;
		gdouble _tmp16_ = 0.0;
		gdouble distance;
		gboolean _tmp17_ = FALSE;
		gboolean _tmp18_ = FALSE;
		gboolean _tmp19_ = FALSE;
		gdouble _tmp20_;
		gdouble _tmp21_;
		gboolean _tmp26_;
		gboolean _tmp37_;
		gboolean _tmp39_;
		Projection* _tmp51_;
		Probe* _tmp52_;
		gdouble _tmp53_;
		gdouble _tmp54_;
		gdouble _tmp55_;
		Point _tmp56_;
		gdouble _tmp57_;
		gdouble _tmp58_;
		Point _tmp59_;
		gint _tmp60_;
		gdouble _tmp61_;
		gdouble _tmp62_;
		Point _tmp63_;
		gint _tmp64_;
#line 469 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp1_ = probe;
#line 469 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		if (_tmp1_ != NULL) {
#line 2905 "seed.c"
			Probe* _tmp2_;
			gboolean _tmp3_;
#line 469 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp2_ = probe;
#line 469 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp3_ = _tmp2_->cancelled;
#line 469 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp0_ = _tmp3_;
#line 2914 "seed.c"
		} else {
#line 469 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp0_ = FALSE;
#line 2918 "seed.c"
		}
#line 469 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp4_ = _tmp0_;
#line 469 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		if (_tmp4_) {
#line 469 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			return;
#line 2926 "seed.c"
		}
#line 470 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp5_ = x0;
#line 470 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp6_ = x1;
#line 470 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		xm = (_tmp5_ + _tmp6_) / 2;
#line 471 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp7_ = y0;
#line 471 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp8_ = y1;
#line 471 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		ym = (_tmp7_ + _tmp8_) / 2;
#line 472 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp9_ = pr;
#line 472 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp10_ = xm;
#line 472 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp11_ = ym;
#line 472 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		seed_distant_point (self, _tmp10_, _tmp11_, &_tmp12_);
#line 472 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		projection_map (_tmp9_, &_tmp12_, &_tmp13_);
#line 472 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		pm = _tmp13_;
#line 473 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp14_ = *p0;
#line 473 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp15_ = *p1;
#line 473 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp16_ = point_hypot (&_tmp14_, &_tmp15_);
#line 473 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		distance = _tmp16_;
#line 474 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp20_ = distance;
#line 474 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp21_ = limit;
#line 474 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		if (_tmp20_ <= _tmp21_) {
#line 2966 "seed.c"
			Point _tmp22_;
			Point _tmp23_;
			gdouble _tmp24_ = 0.0;
			gdouble _tmp25_;
#line 474 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp22_ = *p0;
#line 474 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp23_ = pm;
#line 474 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp24_ = point_hypot (&_tmp22_, &_tmp23_);
#line 474 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp25_ = distance;
#line 474 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp19_ = _tmp24_ <= _tmp25_;
#line 2981 "seed.c"
		} else {
#line 474 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp19_ = FALSE;
#line 2985 "seed.c"
		}
#line 474 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp26_ = _tmp19_;
#line 474 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		if (_tmp26_) {
#line 2991 "seed.c"
			Point _tmp27_;
			Projection* _tmp28_;
			gdouble _tmp29_;
			gdouble _tmp30_;
			gdouble _tmp31_;
			gdouble _tmp32_;
			Point _tmp33_ = {0};
			Point _tmp34_ = {0};
			gdouble _tmp35_ = 0.0;
			gdouble _tmp36_;
#line 475 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp27_ = *p0;
#line 475 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp28_ = pr;
#line 475 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp29_ = x0;
#line 475 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp30_ = x1;
#line 475 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp31_ = y0;
#line 475 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp32_ = y1;
#line 475 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			seed_distant_point (self, (0.85 * _tmp29_) + (0.15 * _tmp30_), (0.85 * _tmp31_) + (0.15 * _tmp32_), &_tmp33_);
#line 475 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			projection_map (_tmp28_, &_tmp33_, &_tmp34_);
#line 475 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp35_ = point_hypot (&_tmp27_, &_tmp34_);
#line 475 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp36_ = distance;
#line 475 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp18_ = _tmp35_ <= _tmp36_;
#line 3024 "seed.c"
		} else {
#line 474 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp18_ = FALSE;
#line 3028 "seed.c"
		}
#line 474 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp37_ = _tmp18_;
#line 474 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		if (_tmp37_) {
#line 474 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp17_ = TRUE;
#line 3036 "seed.c"
		} else {
			gint _tmp38_;
#line 477 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp38_ = depth;
#line 477 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp17_ = _tmp38_ == 0;
#line 3043 "seed.c"
		}
#line 474 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp39_ = _tmp17_;
#line 474 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		if (_tmp39_) {
#line 3049 "seed.c"
			gdouble _tmp40_;
			Point _tmp41_;
			gdouble _tmp42_;
			Point _tmp43_;
			gdouble _tmp44_;
			Point _tmp45_;
			gdouble _tmp46_;
			Point _tmp47_;
			gdouble _tmp48_;
			gdouble _tmp49_;
			gdouble _tmp50_;
#line 479 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp40_ = *area;
#line 479 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp41_ = *p0;
#line 479 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp42_ = _tmp41_.x;
#line 479 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp43_ = *p1;
#line 479 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp44_ = _tmp43_.y;
#line 479 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp45_ = *p0;
#line 479 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp46_ = _tmp45_.y;
#line 479 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp47_ = *p1;
#line 479 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp48_ = _tmp47_.x;
#line 479 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			*area = _tmp40_ + ((_tmp42_ * _tmp44_) - (_tmp46_ * _tmp48_));
#line 480 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp49_ = *perimeter;
#line 480 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp50_ = distance;
#line 480 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			*perimeter = _tmp49_ + _tmp50_;
#line 481 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			return;
#line 3089 "seed.c"
		}
#line 483 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp51_ = pr;
#line 483 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp52_ = probe;
#line 483 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp53_ = limit;
#line 483 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp54_ = x0;
#line 483 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp55_ = y0;
#line 483 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp56_ = *p0;
#line 483 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp57_ = xm;
#line 483 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp58_ = ym;
#line 483 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp59_ = pm;
#line 483 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp60_ = depth;
#line 483 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		seed_compute_sub_area_perimeter (self, _tmp51_, _tmp52_, _tmp53_, _tmp54_, _tmp55_, &_tmp56_, _tmp57_, _tmp58_, &_tmp59_, area, perimeter, _tmp60_ - 1);
#line 485 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp61_ = xm;
#line 485 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		x0 = _tmp61_;
#line 485 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp62_ = ym;
#line 485 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		y0 = _tmp62_;
#line 485 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp63_ = pm;
#line 485 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		*p0 = _tmp63_;
#line 485 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp64_ = depth;
#line 485 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		depth = _tmp64_ - 1;
#line 3129 "seed.c"
	}
}


/**
 * Draw by mapping every point onto the projection.
 */
void seed_draw (Seed* self, DeferredCairo* dc, Projection* pr, Probe* probe, gdouble limit) {
	gdouble _tmp0_;
	gboolean filled;
	RenderStyle _tmp1_;
	RenderStyle _tmp2_;
#line 492 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 492 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_if_fail (dc != NULL);
#line 493 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp0_ = limit;
#line 493 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	filled = _tmp0_ <= 2.0;
#line 494 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp1_ = self->render_style;
#line 494 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	if (_tmp1_ == RENDER_STYLE_NONE) {
#line 494 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		return;
#line 3156 "seed.c"
	}
#line 495 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp2_ = self->render_style;
#line 495 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	if (_tmp2_ == RENDER_STYLE_THIN) {
#line 3162 "seed.c"
		Projection* _tmp3_;
		Point _tmp4_ = {0};
		Point _tmp5_ = {0};
		Point p;
		DeferredCairo* _tmp6_;
		Point _tmp7_;
		DeferredCairo* _tmp8_;
		Projection* _tmp9_;
		Probe* _tmp10_;
		gdouble _tmp11_;
#line 496 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp3_ = pr;
#line 496 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		seed_point_raw (self, 0.0, &_tmp4_);
#line 496 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		projection_map (_tmp3_, &_tmp4_, &_tmp5_);
#line 496 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		p = _tmp5_;
#line 497 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp6_ = dc;
#line 497 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp7_ = p;
#line 497 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		deferred_cairo_move_to (_tmp6_, &_tmp7_);
#line 498 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp8_ = dc;
#line 498 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp9_ = pr;
#line 498 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp10_ = probe;
#line 498 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp11_ = limit;
#line 498 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		seed_draw_segment (self, _tmp8_, _tmp9_, _tmp10_, (gdouble) 0, (gdouble) 0, (gdouble) 1, (gdouble) 0, _tmp11_);
#line 3197 "seed.c"
	} else {
		gboolean _tmp12_ = FALSE;
		RenderStyle _tmp13_;
		gboolean _tmp15_;
#line 500 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp13_ = self->render_style;
#line 500 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		if (_tmp13_ == RENDER_STYLE_FILLED) {
#line 500 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp12_ = TRUE;
#line 3208 "seed.c"
		} else {
			RenderStyle _tmp14_;
#line 500 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp14_ = self->render_style;
#line 500 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp12_ = _tmp14_ == RENDER_STYLE_CLOSED;
#line 3215 "seed.c"
		}
#line 500 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp15_ = _tmp12_;
#line 500 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		if (_tmp15_) {
#line 3221 "seed.c"
			Projection* _tmp16_;
			Point _tmp17_ = {0};
			Point _tmp18_ = {0};
			Point p;
			DeferredCairo* _tmp19_;
			Point _tmp20_;
			DeferredCairo* _tmp21_;
			Projection* _tmp22_;
			Probe* _tmp23_;
			gdouble _tmp24_;
			Projection* _tmp25_;
			gboolean _tmp45_ = FALSE;
			gboolean _tmp46_;
			gboolean _tmp48_;
#line 501 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp16_ = pr;
#line 501 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			seed_point_raw (self, 0.0, &_tmp17_);
#line 501 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			projection_map (_tmp16_, &_tmp17_, &_tmp18_);
#line 501 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			p = _tmp18_;
#line 502 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp19_ = dc;
#line 502 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp20_ = p;
#line 502 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			deferred_cairo_move_to (_tmp19_, &_tmp20_);
#line 503 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp21_ = dc;
#line 503 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp22_ = pr;
#line 503 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp23_ = probe;
#line 503 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp24_ = limit;
#line 503 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			seed_draw_segment (self, _tmp21_, _tmp22_, _tmp23_, (gdouble) 0, (gdouble) 0, (gdouble) 1, (gdouble) 0, _tmp24_);
#line 504 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp25_ = pr;
#line 504 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			if (_tmp25_ != NULL) {
#line 3264 "seed.c"
				Line* _tmp26_;
				Line* line;
				Point _tmp27_ = {0};
				Point p0;
				Point _tmp28_ = {0};
				Point p1;
				Line* _tmp29_;
				Point _tmp30_;
				gdouble _tmp31_;
				Point _tmp32_;
				gdouble _tmp33_;
				Point _tmp34_;
				gdouble _tmp35_;
				Point _tmp36_;
				gdouble _tmp37_;
				gdouble* _tmp38_ = NULL;
				gdouble* _tmp39_;
				gint _tmp39__length1;
				Line* _tmp40_;
				DeferredCairo* _tmp41_;
				Projection* _tmp42_;
				Probe* _tmp43_;
				gdouble _tmp44_;
#line 506 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp26_ = line_new ();
#line 506 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				line = _tmp26_;
#line 507 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				seed_point_raw (self, (gdouble) 0, &_tmp27_);
#line 507 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				p0 = _tmp27_;
#line 508 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				seed_point_raw (self, (gdouble) 1, &_tmp28_);
#line 508 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				p1 = _tmp28_;
#line 509 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp29_ = line;
#line 509 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp30_ = p0;
#line 509 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp31_ = _tmp30_.x;
#line 509 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp32_ = p0;
#line 509 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp33_ = _tmp32_.y;
#line 509 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp34_ = p1;
#line 509 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp35_ = _tmp34_.x;
#line 509 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp36_ = p1;
#line 509 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp37_ = _tmp36_.y;
#line 509 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp38_ = g_new0 (gdouble, 4);
#line 509 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp38_[0] = _tmp31_;
#line 509 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp38_[1] = _tmp33_;
#line 509 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp38_[2] = _tmp35_;
#line 509 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp38_[3] = _tmp37_;
#line 509 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp39_ = _tmp38_;
#line 509 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp39__length1 = 4;
#line 509 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				seed_init_full ((Seed*) _tmp29_, _tmp39_, 4);
#line 509 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp39_ = (g_free (_tmp39_), NULL);
#line 510 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp40_ = line;
#line 510 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp41_ = dc;
#line 510 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp42_ = pr;
#line 510 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp43_ = probe;
#line 510 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp44_ = limit;
#line 510 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				seed_draw_segment ((Seed*) _tmp40_, _tmp41_, _tmp42_, _tmp43_, (gdouble) 1, (gdouble) 0, (gdouble) 0, (gdouble) 0, _tmp44_);
#line 504 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_g_object_unref0 (line);
#line 3350 "seed.c"
			}
#line 512 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp46_ = filled;
#line 512 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			if (_tmp46_) {
#line 3356 "seed.c"
				RenderStyle _tmp47_;
#line 512 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp47_ = self->render_style;
#line 512 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp45_ = _tmp47_ == RENDER_STYLE_FILLED;
#line 3362 "seed.c"
			} else {
#line 512 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp45_ = FALSE;
#line 3366 "seed.c"
			}
#line 512 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp48_ = _tmp45_;
#line 512 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			if (_tmp48_) {
#line 3372 "seed.c"
				DeferredCairo* _tmp49_;
#line 512 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp49_ = dc;
#line 512 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				deferred_cairo_fill (_tmp49_);
#line 3378 "seed.c"
			}
		} else {
			Projection* _tmp50_;
			gdouble _tmp51_;
			Point _tmp52_ = {0};
			Point _tmp53_ = {0};
			Point p;
			DeferredCairo* _tmp54_;
			Point _tmp55_;
			DeferredCairo* _tmp56_;
			Projection* _tmp57_;
			Probe* _tmp58_;
			gdouble _tmp59_;
			gdouble _tmp60_;
			gdouble _tmp61_;
			DeferredCairo* _tmp62_;
			Projection* _tmp63_;
			Probe* _tmp64_;
			gdouble _tmp65_;
			gdouble _tmp66_;
			gdouble _tmp67_;
			DeferredCairo* _tmp68_;
			Projection* _tmp69_;
			Probe* _tmp70_;
			gdouble _tmp71_;
			gdouble _tmp72_;
			gdouble _tmp73_;
			DeferredCairo* _tmp74_;
			Projection* _tmp75_;
			Probe* _tmp76_;
			gdouble _tmp77_;
			gdouble _tmp78_;
			gdouble _tmp79_;
			gboolean _tmp80_ = FALSE;
			gboolean _tmp81_;
			gboolean _tmp83_;
#line 515 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp50_ = pr;
#line 515 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp51_ = self->base_offset;
#line 515 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			seed_distant_point (self, 0.0, _tmp51_, &_tmp52_);
#line 515 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			projection_map (_tmp50_, &_tmp52_, &_tmp53_);
#line 515 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			p = _tmp53_;
#line 516 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp54_ = dc;
#line 516 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp55_ = p;
#line 516 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			deferred_cairo_move_to (_tmp54_, &_tmp55_);
#line 517 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp56_ = dc;
#line 517 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp57_ = pr;
#line 517 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp58_ = probe;
#line 517 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp59_ = self->base_offset;
#line 517 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp60_ = self->base_offset;
#line 517 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp61_ = limit;
#line 517 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			seed_draw_segment (self, _tmp56_, _tmp57_, _tmp58_, (gdouble) 0, _tmp59_, (gdouble) 1, _tmp60_, _tmp61_);
#line 518 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp62_ = dc;
#line 518 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp63_ = pr;
#line 518 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp64_ = probe;
#line 518 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp65_ = self->base_offset;
#line 518 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp66_ = self->base_offset;
#line 518 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp67_ = limit;
#line 518 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			seed_draw_segment (self, _tmp62_, _tmp63_, _tmp64_, (gdouble) 1, _tmp65_, (gdouble) 1, _tmp66_ - 1, _tmp67_);
#line 519 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp68_ = dc;
#line 519 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp69_ = pr;
#line 519 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp70_ = probe;
#line 519 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp71_ = self->base_offset;
#line 519 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp72_ = self->base_offset;
#line 519 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp73_ = limit;
#line 519 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			seed_draw_segment (self, _tmp68_, _tmp69_, _tmp70_, (gdouble) 1, _tmp71_ - 1, (gdouble) 0, _tmp72_ - 1, _tmp73_);
#line 520 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp74_ = dc;
#line 520 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp75_ = pr;
#line 520 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp76_ = probe;
#line 520 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp77_ = self->base_offset;
#line 520 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp78_ = self->base_offset;
#line 520 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp79_ = limit;
#line 520 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			seed_draw_segment (self, _tmp74_, _tmp75_, _tmp76_, (gdouble) 0, _tmp77_ - 1, (gdouble) 0, _tmp78_, _tmp79_);
#line 521 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp81_ = filled;
#line 521 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			if (_tmp81_) {
#line 3491 "seed.c"
				RenderStyle _tmp82_;
#line 521 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp82_ = self->render_style;
#line 521 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp80_ = _tmp82_ == RENDER_STYLE_THICK;
#line 3497 "seed.c"
			} else {
#line 521 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp80_ = FALSE;
#line 3501 "seed.c"
			}
#line 521 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp83_ = _tmp80_;
#line 521 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			if (_tmp83_) {
#line 3507 "seed.c"
				DeferredCairo* _tmp84_;
#line 521 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp84_ = dc;
#line 521 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				deferred_cairo_fill (_tmp84_);
#line 3513 "seed.c"
			}
		}
	}
}


/**
 * Draw the segmentation of the seed, showing the projection boxes.
 */
void seed_draw_segmentation (Seed* self, cairo_t* cr, Projection* pr) {
	DeferredCairo* _tmp0_;
	DeferredCairo* dc;
	Projection* _tmp1_;
	gdouble _tmp2_;
	Point _tmp3_ = {0};
	Point _tmp4_ = {0};
	Point p;
	DeferredCairo* _tmp5_;
	Point _tmp6_;
	DeferredCairo* _tmp7_;
	Projection* _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_;
	DeferredCairo* _tmp11_;
	cairo_t* _tmp12_;
	Projection* _tmp13_;
	gdouble _tmp14_;
	Point _tmp15_ = {0};
	Point _tmp16_ = {0};
	DeferredCairo* _tmp17_;
	Point _tmp18_;
	DeferredCairo* _tmp19_;
	Projection* _tmp20_;
	gdouble _tmp21_;
	gdouble _tmp22_;
	DeferredCairo* _tmp23_;
	cairo_t* _tmp24_;
#line 528 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 528 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_if_fail (cr != NULL);
#line 529 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	seed_start_render (self);
#line 530 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp0_ = deferred_cairo_new ();
#line 530 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	dc = _tmp0_;
#line 532 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp1_ = pr;
#line 532 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp2_ = self->base_offset;
#line 532 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	seed_distant_point (self, (gdouble) 0, _tmp2_, &_tmp3_);
#line 532 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	projection_map (_tmp1_, &_tmp3_, &_tmp4_);
#line 532 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	p = _tmp4_;
#line 533 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp5_ = dc;
#line 533 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp6_ = p;
#line 533 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	deferred_cairo_move_to (_tmp5_, &_tmp6_);
#line 534 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp7_ = dc;
#line 534 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp8_ = pr;
#line 534 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp9_ = self->base_offset;
#line 534 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp10_ = self->base_offset;
#line 534 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	seed_draw_segment (self, _tmp7_, _tmp8_, NULL, (gdouble) 0, _tmp9_, (gdouble) 1, _tmp10_, 0.5);
#line 535 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp11_ = dc;
#line 535 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp12_ = cr;
#line 535 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	deferred_cairo_render (_tmp11_, _tmp12_);
#line 537 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp13_ = pr;
#line 537 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp14_ = self->base_offset;
#line 537 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	seed_distant_point (self, (gdouble) 0, _tmp14_ - 1, &_tmp15_);
#line 537 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	projection_map (_tmp13_, &_tmp15_, &_tmp16_);
#line 537 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	p = _tmp16_;
#line 538 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp17_ = dc;
#line 538 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp18_ = p;
#line 538 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	deferred_cairo_move_to (_tmp17_, &_tmp18_);
#line 539 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp19_ = dc;
#line 539 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp20_ = pr;
#line 539 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp21_ = self->base_offset;
#line 539 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp22_ = self->base_offset;
#line 539 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	seed_draw_segment (self, _tmp19_, _tmp20_, NULL, (gdouble) 0, _tmp21_ - 1, (gdouble) 1, _tmp22_ - 1, 0.5);
#line 540 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp23_ = dc;
#line 540 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp24_ = cr;
#line 540 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	deferred_cairo_render (_tmp23_, _tmp24_);
#line 3625 "seed.c"
	{
		gint i;
#line 542 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		i = 0;
#line 3630 "seed.c"
		{
			gboolean _tmp25_;
#line 542 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp25_ = TRUE;
#line 542 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			while (TRUE) {
#line 3637 "seed.c"
				gboolean _tmp26_;
				gint _tmp28_;
				gint _tmp29_;
				gint _tmp30_;
				gint _tmp31_;
				gdouble x;
				Projection* _tmp32_;
				gdouble _tmp33_;
				gdouble _tmp34_;
				Point _tmp35_ = {0};
				Point _tmp36_ = {0};
				DeferredCairo* _tmp37_;
				Point _tmp38_;
				DeferredCairo* _tmp39_;
				Projection* _tmp40_;
				gdouble _tmp41_;
				gdouble _tmp42_;
				gdouble _tmp43_;
				gdouble _tmp44_;
				DeferredCairo* _tmp45_;
				cairo_t* _tmp46_;
#line 542 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp26_ = _tmp25_;
#line 542 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				if (!_tmp26_) {
#line 3663 "seed.c"
					gint _tmp27_;
#line 542 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp27_ = i;
#line 542 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					i = _tmp27_ + 1;
#line 3669 "seed.c"
				}
#line 542 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp25_ = FALSE;
#line 542 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp28_ = i;
#line 542 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp29_ = self->num_segment;
#line 542 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				if (!(_tmp28_ <= _tmp29_)) {
#line 542 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					break;
#line 3681 "seed.c"
				}
#line 543 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp30_ = i;
#line 543 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp31_ = self->num_segment;
#line 543 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				x = ((gdouble) _tmp30_) / _tmp31_;
#line 544 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp32_ = pr;
#line 544 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp33_ = x;
#line 544 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp34_ = self->base_offset;
#line 544 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				seed_distant_point (self, _tmp33_, _tmp34_, &_tmp35_);
#line 544 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				projection_map (_tmp32_, &_tmp35_, &_tmp36_);
#line 544 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				p = _tmp36_;
#line 545 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp37_ = dc;
#line 545 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp38_ = p;
#line 545 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				deferred_cairo_move_to (_tmp37_, &_tmp38_);
#line 546 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp39_ = dc;
#line 546 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp40_ = pr;
#line 546 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp41_ = x;
#line 546 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp42_ = self->base_offset;
#line 546 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp43_ = x;
#line 546 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp44_ = self->base_offset;
#line 546 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				seed_draw_segment (self, _tmp39_, _tmp40_, NULL, _tmp41_, _tmp42_, _tmp43_, _tmp44_ - 1, 0.5);
#line 547 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp45_ = dc;
#line 547 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp46_ = cr;
#line 547 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				deferred_cairo_render (_tmp45_, _tmp46_);
#line 3727 "seed.c"
			}
		}
	}
#line 549 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	seed_stop_render (self);
#line 528 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_deferred_cairo_unref0 (dc);
#line 3735 "seed.c"
}


/**
 * Draw a projected line segment.
 */
static void seed_draw_segment (Seed* self, DeferredCairo* dc, Projection* pr, Probe* probe, gdouble x0, gdouble y0, gdouble x1, gdouble y1, gdouble limit) {
	gboolean _tmp0_ = FALSE;
	Probe* _tmp1_;
	gboolean _tmp4_;
	DeferredCairo* _tmp5_;
	Projection* _tmp6_;
	Probe* _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_;
	Projection* _tmp10_;
	gdouble _tmp11_;
	gdouble _tmp12_;
	Point _tmp13_ = {0};
	Point _tmp14_ = {0};
	gdouble _tmp15_;
	gdouble _tmp16_;
	Projection* _tmp17_;
	gdouble _tmp18_;
	gdouble _tmp19_;
	Point _tmp20_ = {0};
	Point _tmp21_ = {0};
	gdouble _tmp22_;
#line 555 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 555 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_if_fail (dc != NULL);
#line 557 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp1_ = probe;
#line 557 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	if (_tmp1_ != NULL) {
#line 3772 "seed.c"
		Probe* _tmp2_;
		gboolean _tmp3_;
#line 557 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp2_ = probe;
#line 557 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp3_ = _tmp2_->cancelled;
#line 557 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp0_ = _tmp3_;
#line 3781 "seed.c"
	} else {
#line 557 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp0_ = FALSE;
#line 3785 "seed.c"
	}
#line 557 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp4_ = _tmp0_;
#line 557 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	if (_tmp4_) {
#line 557 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		return;
#line 3793 "seed.c"
	}
#line 558 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp5_ = dc;
#line 558 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp6_ = pr;
#line 558 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp7_ = probe;
#line 558 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp8_ = x0;
#line 558 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp9_ = y0;
#line 558 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp10_ = pr;
#line 558 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp11_ = x0;
#line 558 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp12_ = y0;
#line 558 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	seed_distant_point (self, _tmp11_, _tmp12_, &_tmp13_);
#line 558 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	projection_map (_tmp10_, &_tmp13_, &_tmp14_);
#line 558 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp15_ = x1;
#line 558 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp16_ = y1;
#line 558 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp17_ = pr;
#line 558 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp18_ = x1;
#line 558 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp19_ = y1;
#line 558 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	seed_distant_point (self, _tmp18_, _tmp19_, &_tmp20_);
#line 558 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	projection_map (_tmp17_, &_tmp20_, &_tmp21_);
#line 558 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp22_ = limit;
#line 558 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	seed_draw_sub_segment (self, _tmp5_, _tmp6_, _tmp7_, _tmp8_, _tmp9_, &_tmp14_, _tmp15_, _tmp16_, &_tmp21_, _tmp22_, 1000);
#line 3833 "seed.c"
}


/**
 * Draw by recursively splitting into two smaller subsegments.
 * p0 and p1 are pre-computed projections of (x0, y0) and (x1, y1) respectively.
 */
static void seed_draw_sub_segment (Seed* self, DeferredCairo* dc, Projection* pr, Probe* probe, gdouble x0, gdouble y0, Point* p0, gdouble x1, gdouble y1, Point* p1, gdouble limit, gint depth) {
#line 568 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 568 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_if_fail (dc != NULL);
#line 568 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_if_fail (p0 != NULL);
#line 568 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_if_fail (p1 != NULL);
#line 571 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	while (TRUE) {
#line 3852 "seed.c"
		gboolean _tmp0_ = FALSE;
		gboolean _tmp1_ = FALSE;
		Probe* _tmp2_;
		gboolean _tmp5_;
		gboolean _tmp7_;
		gdouble _tmp8_;
		gdouble _tmp9_;
		gdouble xm;
		gdouble _tmp10_;
		gdouble _tmp11_;
		gdouble ym;
		Projection* _tmp12_;
		gdouble _tmp13_;
		gdouble _tmp14_;
		Point _tmp15_ = {0};
		Point _tmp16_ = {0};
		Point pm;
		Point _tmp17_;
		Point _tmp18_;
		gdouble _tmp19_ = 0.0;
		gdouble distance;
		gboolean _tmp20_ = FALSE;
		gboolean _tmp21_ = FALSE;
		gdouble _tmp22_;
		gdouble _tmp23_;
		gboolean _tmp28_;
		gboolean _tmp39_;
		DeferredCairo* _tmp42_;
		Projection* _tmp43_;
		Probe* _tmp44_;
		gdouble _tmp45_;
		gdouble _tmp46_;
		Point _tmp47_;
		gdouble _tmp48_;
		gdouble _tmp49_;
		Point _tmp50_;
		gdouble _tmp51_;
		gint _tmp52_;
		gdouble _tmp53_;
		gdouble _tmp54_;
		Point _tmp55_;
		gint _tmp56_;
#line 572 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp2_ = probe;
#line 572 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		if (_tmp2_ != NULL) {
#line 3899 "seed.c"
			Probe* _tmp3_;
			gboolean _tmp4_;
#line 572 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp3_ = probe;
#line 572 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp4_ = _tmp3_->cancelled;
#line 572 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp1_ = _tmp4_;
#line 3908 "seed.c"
		} else {
#line 572 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp1_ = FALSE;
#line 3912 "seed.c"
		}
#line 572 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp5_ = _tmp1_;
#line 572 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		if (_tmp5_) {
#line 572 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp0_ = TRUE;
#line 3920 "seed.c"
		} else {
			gint _tmp6_;
#line 572 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp6_ = depth;
#line 572 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp0_ = _tmp6_ == 0;
#line 3927 "seed.c"
		}
#line 572 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp7_ = _tmp0_;
#line 572 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		if (_tmp7_) {
#line 572 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			return;
#line 3935 "seed.c"
		}
#line 573 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp8_ = x0;
#line 573 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp9_ = x1;
#line 573 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		xm = (_tmp8_ + _tmp9_) / 2;
#line 574 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp10_ = y0;
#line 574 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp11_ = y1;
#line 574 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		ym = (_tmp10_ + _tmp11_) / 2;
#line 575 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp12_ = pr;
#line 575 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp13_ = xm;
#line 575 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp14_ = ym;
#line 575 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		seed_distant_point (self, _tmp13_, _tmp14_, &_tmp15_);
#line 575 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		projection_map (_tmp12_, &_tmp15_, &_tmp16_);
#line 575 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		pm = _tmp16_;
#line 577 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp17_ = *p0;
#line 577 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp18_ = *p1;
#line 577 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp19_ = point_hypot (&_tmp17_, &_tmp18_);
#line 577 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		distance = _tmp19_;
#line 578 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp22_ = distance;
#line 578 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp23_ = limit;
#line 578 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		if (_tmp22_ <= _tmp23_) {
#line 3975 "seed.c"
			Point _tmp24_;
			Point _tmp25_;
			gdouble _tmp26_ = 0.0;
			gdouble _tmp27_;
#line 578 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp24_ = *p0;
#line 578 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp25_ = pm;
#line 578 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp26_ = point_hypot (&_tmp24_, &_tmp25_);
#line 578 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp27_ = distance;
#line 578 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp21_ = _tmp26_ <= _tmp27_;
#line 3990 "seed.c"
		} else {
#line 578 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp21_ = FALSE;
#line 3994 "seed.c"
		}
#line 578 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp28_ = _tmp21_;
#line 578 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		if (_tmp28_) {
#line 4000 "seed.c"
			Point _tmp29_;
			Projection* _tmp30_;
			gdouble _tmp31_;
			gdouble _tmp32_;
			gdouble _tmp33_;
			gdouble _tmp34_;
			Point _tmp35_ = {0};
			Point _tmp36_ = {0};
			gdouble _tmp37_ = 0.0;
			gdouble _tmp38_;
#line 579 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp29_ = *p0;
#line 579 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp30_ = pr;
#line 579 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp31_ = x0;
#line 579 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp32_ = x1;
#line 579 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp33_ = y0;
#line 579 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp34_ = y1;
#line 579 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			seed_distant_point (self, (0.85 * _tmp31_) + (0.15 * _tmp32_), (0.85 * _tmp33_) + (0.15 * _tmp34_), &_tmp35_);
#line 579 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			projection_map (_tmp30_, &_tmp35_, &_tmp36_);
#line 579 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp37_ = point_hypot (&_tmp29_, &_tmp36_);
#line 579 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp38_ = distance;
#line 579 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp20_ = _tmp37_ <= _tmp38_;
#line 4033 "seed.c"
		} else {
#line 578 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp20_ = FALSE;
#line 4037 "seed.c"
		}
#line 578 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp39_ = _tmp20_;
#line 578 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		if (_tmp39_) {
#line 4043 "seed.c"
			DeferredCairo* _tmp40_;
			Point _tmp41_;
#line 582 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp40_ = dc;
#line 582 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp41_ = *p1;
#line 582 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			deferred_cairo_line_to (_tmp40_, &_tmp41_);
#line 583 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			return;
#line 4054 "seed.c"
		}
#line 585 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp42_ = dc;
#line 585 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp43_ = pr;
#line 585 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp44_ = probe;
#line 585 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp45_ = x0;
#line 585 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp46_ = y0;
#line 585 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp47_ = *p0;
#line 585 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp48_ = xm;
#line 585 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp49_ = ym;
#line 585 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp50_ = pm;
#line 585 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp51_ = limit;
#line 585 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp52_ = depth;
#line 585 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		seed_draw_sub_segment (self, _tmp42_, _tmp43_, _tmp44_, _tmp45_, _tmp46_, &_tmp47_, _tmp48_, _tmp49_, &_tmp50_, _tmp51_, _tmp52_ - 1);
#line 587 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp53_ = xm;
#line 587 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		x0 = _tmp53_;
#line 587 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp54_ = ym;
#line 587 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		y0 = _tmp54_;
#line 587 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp55_ = pm;
#line 587 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		*p0 = _tmp55_;
#line 587 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp56_ = depth;
#line 587 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		depth = _tmp56_ - 1;
#line 4096 "seed.c"
	}
}


/**
 * Draw directly using cairo methods.
 */
static void seed_real_draw_direct (Seed* self, cairo_t* cr, gdouble scale) {
#line 603 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_critical ("Type `%s' does not implement abstract method `seed_draw_direct'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 603 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	return;
#line 4109 "seed.c"
}


void seed_draw_direct (Seed* self, cairo_t* cr, gdouble scale) {
#line 603 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 603 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	SEED_GET_CLASS (self)->draw_direct (self, cr, scale);
#line 4118 "seed.c"
}


/**
 * Controls used for moving, scaling, rotation, etc.
 */
static void seed_real_draw_controls (Seed* self, cairo_t* cr, gdouble scale) {
#line 608 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_critical ("Type `%s' does not implement abstract method `seed_draw_controls'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 608 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	return;
#line 4130 "seed.c"
}


void seed_draw_controls (Seed* self, cairo_t* cr, gdouble scale) {
#line 608 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 608 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	SEED_GET_CLASS (self)->draw_controls (self, cr, scale);
#line 4139 "seed.c"
}


void seed_draw_square_control (Seed* self, cairo_t* cr, Point* p) {
	cairo_t* _tmp0_;
	Point _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	Point _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	cairo_t* _tmp9_;
#line 610 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 610 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_if_fail (cr != NULL);
#line 610 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_if_fail (p != NULL);
#line 611 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp0_ = cr;
#line 611 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp1_ = *p;
#line 611 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp2_ = _tmp1_.x;
#line 611 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp3_ = self->priv->control_radius;
#line 611 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp4_ = *p;
#line 611 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp5_ = _tmp4_.y;
#line 611 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp6_ = self->priv->control_radius;
#line 611 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp7_ = self->priv->control_radius;
#line 611 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp8_ = self->priv->control_radius;
#line 611 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	cairo_rectangle (_tmp0_, _tmp2_ - _tmp3_, _tmp5_ - _tmp6_, _tmp7_ * 2, _tmp8_ * 2);
#line 612 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp9_ = cr;
#line 612 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	cairo_fill (_tmp9_);
#line 4184 "seed.c"
}


void seed_draw_line_control (Seed* self, cairo_t* cr, Point* p0, Point* p1) {
	cairo_t* _tmp0_;
	Point _tmp1_;
	gdouble _tmp2_;
	Point _tmp3_;
	gdouble _tmp4_;
	cairo_t* _tmp5_;
	Point _tmp6_;
	gdouble _tmp7_;
	Point _tmp8_;
	gdouble _tmp9_;
	cairo_t* _tmp10_;
#line 615 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 615 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_if_fail (cr != NULL);
#line 615 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_if_fail (p0 != NULL);
#line 615 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_if_fail (p1 != NULL);
#line 616 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp0_ = cr;
#line 616 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp1_ = *p0;
#line 616 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp2_ = _tmp1_.x;
#line 616 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp3_ = *p0;
#line 616 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp4_ = _tmp3_.y;
#line 616 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	cairo_move_to (_tmp0_, _tmp2_, _tmp4_);
#line 617 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp5_ = cr;
#line 617 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp6_ = *p1;
#line 617 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp7_ = _tmp6_.x;
#line 617 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp8_ = *p1;
#line 617 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp9_ = _tmp8_.y;
#line 617 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	cairo_line_to (_tmp5_, _tmp7_, _tmp9_);
#line 618 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp10_ = cr;
#line 618 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	cairo_stroke (_tmp10_);
#line 4236 "seed.c"
}


void seed_draw_circle_control (Seed* self, cairo_t* cr, Point* p) {
	cairo_t* _tmp0_;
	Point _tmp1_;
	gdouble _tmp2_;
	Point _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	cairo_t* _tmp6_;
#line 621 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 621 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_if_fail (cr != NULL);
#line 621 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_if_fail (p != NULL);
#line 622 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp0_ = cr;
#line 622 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp1_ = *p;
#line 622 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp2_ = _tmp1_.x;
#line 622 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp3_ = *p;
#line 622 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp4_ = _tmp3_.y;
#line 622 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp5_ = self->priv->control_radius;
#line 622 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	cairo_arc (_tmp0_, _tmp2_, _tmp4_, _tmp5_, (gdouble) 0, 2 * G_PI);
#line 623 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp6_ = cr;
#line 623 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	cairo_fill (_tmp6_);
#line 4272 "seed.c"
}


/**
 * Is point 0 and point 1 within range?
 * One of the point is a control, the other is the cursor.
 */
gboolean seed_within_snap_range (Seed* self, Point* p0, Point* p1, gdouble scale) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	Point _tmp1_;
	gdouble _tmp2_;
	Point _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gboolean _tmp15_;
#line 630 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 630 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_val_if_fail (p0 != NULL, FALSE);
#line 630 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_val_if_fail (p1 != NULL, FALSE);
#line 631 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp1_ = *p0;
#line 631 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp2_ = _tmp1_.x;
#line 631 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp3_ = *p1;
#line 631 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp4_ = _tmp3_.x;
#line 631 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp5_ = fabs (_tmp2_ - _tmp4_);
#line 631 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp6_ = scale;
#line 631 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp7_ = self->priv->control_magnetic_range;
#line 631 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	if ((_tmp5_ * _tmp6_) <= _tmp7_) {
#line 4313 "seed.c"
		Point _tmp8_;
		gdouble _tmp9_;
		Point _tmp10_;
		gdouble _tmp11_;
		gdouble _tmp12_ = 0.0;
		gdouble _tmp13_;
		gdouble _tmp14_;
#line 632 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp8_ = *p0;
#line 632 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp9_ = _tmp8_.y;
#line 632 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp10_ = *p1;
#line 632 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp11_ = _tmp10_.y;
#line 632 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp12_ = fabs (_tmp9_ - _tmp11_);
#line 632 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp13_ = scale;
#line 632 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp14_ = self->priv->control_magnetic_range;
#line 632 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp0_ = (_tmp12_ * _tmp13_) <= _tmp14_;
#line 4337 "seed.c"
	} else {
#line 631 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp0_ = FALSE;
#line 4341 "seed.c"
	}
#line 631 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp15_ = _tmp0_;
#line 631 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	result = _tmp15_;
#line 631 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	return result;
#line 4349 "seed.c"
}


gboolean seed_within_touch_range (Seed* self, Point* p0, Point* p1, gdouble scale) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	Point _tmp1_;
	gdouble _tmp2_;
	Point _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gboolean _tmp15_;
#line 635 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 635 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_val_if_fail (p0 != NULL, FALSE);
#line 635 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_val_if_fail (p1 != NULL, FALSE);
#line 636 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp1_ = *p0;
#line 636 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp2_ = _tmp1_.x;
#line 636 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp3_ = *p1;
#line 636 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp4_ = _tmp3_.x;
#line 636 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp5_ = fabs (_tmp2_ - _tmp4_);
#line 636 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp6_ = scale;
#line 636 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp7_ = self->priv->control_radius;
#line 636 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	if ((_tmp5_ * _tmp6_) <= _tmp7_) {
#line 4386 "seed.c"
		Point _tmp8_;
		gdouble _tmp9_;
		Point _tmp10_;
		gdouble _tmp11_;
		gdouble _tmp12_ = 0.0;
		gdouble _tmp13_;
		gdouble _tmp14_;
#line 637 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp8_ = *p0;
#line 637 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp9_ = _tmp8_.y;
#line 637 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp10_ = *p1;
#line 637 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp11_ = _tmp10_.y;
#line 637 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp12_ = fabs (_tmp9_ - _tmp11_);
#line 637 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp13_ = scale;
#line 637 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp14_ = self->priv->control_radius;
#line 637 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp0_ = (_tmp12_ * _tmp13_) <= _tmp14_;
#line 4410 "seed.c"
	} else {
#line 636 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp0_ = FALSE;
#line 4414 "seed.c"
	}
#line 636 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp15_ = _tmp0_;
#line 636 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	result = _tmp15_;
#line 636 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	return result;
#line 4422 "seed.c"
}


/**
 * Is point p touching the seed
 */
gboolean seed_touching (Seed* self, Point* p, gdouble scale) {
	gboolean result = FALSE;
#line 643 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 643 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_val_if_fail (p != NULL, FALSE);
#line 4435 "seed.c"
	{
		gint i;
#line 645 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		i = 0;
#line 4440 "seed.c"
		{
			gboolean _tmp0_;
#line 645 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp0_ = TRUE;
#line 645 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			while (TRUE) {
#line 4447 "seed.c"
				gboolean _tmp1_;
				gint _tmp3_;
				gint _tmp4_;
				gdouble t0;
				gint _tmp5_;
				gdouble t1;
#line 645 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp1_ = _tmp0_;
#line 645 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				if (!_tmp1_) {
#line 4458 "seed.c"
					gint _tmp2_;
#line 645 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp2_ = i;
#line 645 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					i = _tmp2_ + 1;
#line 4464 "seed.c"
				}
#line 645 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp0_ = FALSE;
#line 645 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp3_ = i;
#line 645 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				if (!(_tmp3_ < 4)) {
#line 645 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					break;
#line 4474 "seed.c"
				}
#line 647 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp4_ = i;
#line 647 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				t0 = 0.25 * _tmp4_;
#line 648 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp5_ = i;
#line 648 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				t1 = 0.25 * (_tmp5_ + 1);
#line 649 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				while (TRUE) {
#line 4486 "seed.c"
					gdouble _tmp6_;
					gdouble _tmp7_;
					gdouble _tmp8_;
					Point _tmp9_;
					gdouble _tmp10_;
					Point _tmp11_ = {0};
					gdouble _tmp12_ = 0.0;
					gdouble _tmp13_;
					gdouble d0;
					Point _tmp14_;
					gdouble _tmp15_;
					Point _tmp16_ = {0};
					gdouble _tmp17_ = 0.0;
					gdouble _tmp18_;
					gdouble d1;
					gboolean _tmp19_ = FALSE;
					gdouble _tmp20_;
					gdouble _tmp21_;
					gboolean _tmp24_;
#line 649 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp6_ = t1;
#line 649 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp7_ = t0;
#line 649 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp8_ = seed_epsilon;
#line 649 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					if (!((_tmp6_ - _tmp7_) > _tmp8_)) {
#line 649 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
						break;
#line 4516 "seed.c"
					}
#line 650 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp9_ = *p;
#line 650 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp10_ = t0;
#line 650 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					seed_point (self, _tmp10_, &_tmp11_);
#line 650 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp12_ = point_hypot (&_tmp9_, &_tmp11_);
#line 650 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp13_ = scale;
#line 650 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					d0 = _tmp12_ * _tmp13_;
#line 651 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp14_ = *p;
#line 651 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp15_ = t1;
#line 651 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					seed_point (self, _tmp15_, &_tmp16_);
#line 651 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp17_ = point_hypot (&_tmp14_, &_tmp16_);
#line 651 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp18_ = scale;
#line 651 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					d1 = _tmp17_ * _tmp18_;
#line 652 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp20_ = d0;
#line 652 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp21_ = self->priv->control_radius;
#line 652 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					if (_tmp20_ <= _tmp21_) {
#line 652 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
						_tmp19_ = TRUE;
#line 4550 "seed.c"
					} else {
						gdouble _tmp22_;
						gdouble _tmp23_;
#line 652 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
						_tmp22_ = d1;
#line 652 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
						_tmp23_ = self->priv->control_radius;
#line 652 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
						_tmp19_ = _tmp22_ <= _tmp23_;
#line 4560 "seed.c"
					}
#line 652 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp24_ = _tmp19_;
#line 652 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					if (_tmp24_) {
#line 653 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
						result = TRUE;
#line 653 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
						return result;
#line 4570 "seed.c"
					} else {
						gdouble _tmp25_;
						gdouble _tmp26_;
#line 655 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
						_tmp25_ = d0;
#line 655 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
						_tmp26_ = d1;
#line 655 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
						if (_tmp25_ < _tmp26_) {
#line 4580 "seed.c"
							gdouble _tmp27_;
							gdouble _tmp28_;
#line 656 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							_tmp27_ = t0;
#line 656 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							_tmp28_ = t1;
#line 656 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							t1 = (_tmp27_ + _tmp28_) / 2;
#line 4589 "seed.c"
						} else {
							gdouble _tmp29_;
							gdouble _tmp30_;
#line 659 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							_tmp29_ = t0;
#line 659 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							_tmp30_ = t1;
#line 659 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
							t0 = (_tmp29_ + _tmp30_) / 2;
#line 4599 "seed.c"
						}
					}
				}
			}
		}
	}
#line 663 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	result = FALSE;
#line 663 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	return result;
#line 4610 "seed.c"
}


/**
 * See if any control is within the range of the cursor.
 * Output: 
 *  + selected_control
 *            -1 : not selected
 *           100 : drag the entire shape
 *        others : determined by pressed_control
 * + pressed_point : the point where the drag began
 */
gboolean seed_start_drag (Seed* self, Point* p, gdouble scale, gboolean selected, gboolean snap_on, gdouble grid_size) {
	gboolean result = FALSE;
	Point _tmp0_;
	Point snapped_p;
	gboolean _tmp1_;
	gboolean _tmp6_;
	gboolean _tmp10_ = FALSE;
	gint _tmp11_;
	gboolean _tmp15_;
	gint _tmp17_;
#line 675 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 675 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_val_if_fail (p != NULL, FALSE);
#line 676 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->selected_control = -1;
#line 677 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	seed_save_drag_context (self);
#line 678 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp0_ = *p;
#line 678 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	snapped_p = _tmp0_;
#line 679 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp1_ = snap_on;
#line 679 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	if (_tmp1_) {
#line 4649 "seed.c"
		gdouble _tmp2_;
		gdouble _tmp3_;
		gboolean _tmp4_ = FALSE;
#line 680 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp2_ = scale;
#line 680 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp3_ = grid_size;
#line 680 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp4_ = seed_snap (self, &snapped_p, _tmp2_, _tmp3_);
#line 680 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		if (_tmp4_) {
#line 4661 "seed.c"
			Point _tmp5_;
#line 680 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp5_ = snapped_p;
#line 680 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			seed_init_default (self, &_tmp5_);
#line 4667 "seed.c"
		}
	}
#line 682 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp6_ = selected;
#line 682 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	if (_tmp6_) {
#line 4674 "seed.c"
		Point _tmp7_;
		gdouble _tmp8_;
		gint _tmp9_ = 0;
#line 683 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp7_ = snapped_p;
#line 683 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp8_ = scale;
#line 683 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp9_ = seed_pressed_control (self, &_tmp7_, _tmp8_);
#line 683 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		self->selected_control = _tmp9_;
#line 4686 "seed.c"
	}
#line 685 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp11_ = self->selected_control;
#line 685 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	if (_tmp11_ == (-1)) {
#line 4692 "seed.c"
		Point _tmp12_;
		gdouble _tmp13_;
		gboolean _tmp14_ = FALSE;
#line 685 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp12_ = *p;
#line 685 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp13_ = scale;
#line 685 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp14_ = seed_touching (self, &_tmp12_, _tmp13_);
#line 685 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp10_ = _tmp14_;
#line 4704 "seed.c"
	} else {
#line 685 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp10_ = FALSE;
#line 4708 "seed.c"
	}
#line 685 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp15_ = _tmp10_;
#line 685 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	if (_tmp15_) {
#line 4714 "seed.c"
		Point _tmp16_;
#line 686 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		self->selected_control = 100;
#line 687 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp16_ = *p;
#line 687 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		self->pressed_point = _tmp16_;
#line 4722 "seed.c"
	}
#line 689 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp17_ = self->selected_control;
#line 689 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	result = _tmp17_ != (-1);
#line 689 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	return result;
#line 4730 "seed.c"
}


/**
 * Which control is pressed and about to be dragged?
 */
static gint seed_real_pressed_control (Seed* self, Point* p, gdouble scale) {
#line 695 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_critical ("Type `%s' does not implement abstract method `seed_pressed_control'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 695 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	return 0;
#line 4742 "seed.c"
}


gint seed_pressed_control (Seed* self, Point* p, gdouble scale) {
#line 695 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 695 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	return SEED_GET_CLASS (self)->pressed_control (self, p, scale);
#line 4751 "seed.c"
}


static void seed_real_save_drag_context (Seed* self) {
#line 696 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_critical ("Type `%s' does not implement abstract method `seed_save_drag_context'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 696 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	return;
#line 4760 "seed.c"
}


void seed_save_drag_context (Seed* self) {
#line 696 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 696 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	SEED_GET_CLASS (self)->save_drag_context (self);
#line 4769 "seed.c"
}


void seed_drag (Seed* self, Point* p, gdouble scale, gboolean snap_on, gdouble grid_size, gdouble snap_angle) {
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp30_;
#line 698 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 698 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_if_fail (p != NULL);
#line 698 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp0_ = self->selected_control;
#line 698 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_if_fail (_tmp0_ != (-1));
#line 700 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp1_ = self->selected_control;
#line 700 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	if (_tmp1_ == 100) {
#line 4789 "seed.c"
		Point _tmp2_;
		gdouble _tmp3_;
		Point _tmp4_;
		gdouble _tmp5_;
		gdouble delta_x;
		Point _tmp6_;
		gdouble _tmp7_;
		Point _tmp8_;
		gdouble _tmp9_;
		gdouble delta_y;
		gdouble _tmp10_;
		gdouble _tmp11_;
		gboolean _tmp12_;
#line 701 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp2_ = *p;
#line 701 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp3_ = _tmp2_.x;
#line 701 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp4_ = self->pressed_point;
#line 701 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp5_ = _tmp4_.x;
#line 701 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		delta_x = _tmp3_ - _tmp5_;
#line 702 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp6_ = *p;
#line 702 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp7_ = _tmp6_.y;
#line 702 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp8_ = self->pressed_point;
#line 702 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp9_ = _tmp8_.y;
#line 702 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		delta_y = _tmp7_ - _tmp9_;
#line 703 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp10_ = delta_x;
#line 703 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp11_ = delta_y;
#line 703 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		seed_move_shape (self, _tmp10_, _tmp11_);
#line 704 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp12_ = snap_on;
#line 704 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		if (_tmp12_) {
#line 4833 "seed.c"
			gdouble dx;
			gdouble dy;
			gdouble _tmp13_;
			gdouble _tmp14_;
			gdouble _tmp15_ = 0.0;
			gdouble _tmp16_ = 0.0;
			gdouble _tmp17_;
			gdouble _tmp20_;
			gdouble _tmp23_;
			gdouble _tmp24_;
#line 705 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			dx = (gdouble) 999999;
#line 706 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			dy = (gdouble) 999999;
#line 707 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp13_ = scale;
#line 707 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp14_ = grid_size;
#line 707 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			seed_distance_to_grid (self, _tmp13_, _tmp14_, &_tmp15_, &_tmp16_);
#line 707 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			dx = _tmp15_;
#line 707 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			dy = _tmp16_;
#line 708 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp17_ = dx;
#line 708 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			if (_tmp17_ != ((gdouble) 999999)) {
#line 4862 "seed.c"
				gdouble _tmp18_;
				gdouble _tmp19_;
#line 708 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp18_ = delta_x;
#line 708 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp19_ = dx;
#line 708 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				delta_x = _tmp18_ - _tmp19_;
#line 4871 "seed.c"
			}
#line 709 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp20_ = dy;
#line 709 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			if (_tmp20_ != ((gdouble) 999999)) {
#line 4877 "seed.c"
				gdouble _tmp21_;
				gdouble _tmp22_;
#line 709 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp21_ = delta_y;
#line 709 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp22_ = dy;
#line 709 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				delta_y = _tmp21_ - _tmp22_;
#line 4886 "seed.c"
			}
#line 710 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp23_ = delta_x;
#line 710 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			_tmp24_ = delta_y;
#line 710 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			seed_move_shape (self, _tmp23_, _tmp24_);
#line 4894 "seed.c"
		}
	} else {
		Point _tmp25_;
		gdouble _tmp26_;
		gboolean _tmp27_;
		gdouble _tmp28_;
		gdouble _tmp29_;
#line 714 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp25_ = *p;
#line 714 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp26_ = scale;
#line 714 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp27_ = snap_on;
#line 714 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp28_ = grid_size;
#line 714 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp29_ = snap_angle;
#line 714 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		seed_drag_control (self, &_tmp25_, _tmp26_, _tmp27_, _tmp28_, _tmp29_);
#line 4914 "seed.c"
	}
#line 717 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp30_ = self->selected_control;
#line 717 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	if (_tmp30_ != 100) {
#line 717 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		seed_init_distance_to_parametric (self);
#line 4922 "seed.c"
	}
}


static void seed_real_move_shape (Seed* self, gdouble delta_x, gdouble delta_y) {
#line 720 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_critical ("Type `%s' does not implement abstract method `seed_move_shape'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 720 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	return;
#line 4932 "seed.c"
}


void seed_move_shape (Seed* self, gdouble delta_x, gdouble delta_y) {
#line 720 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 720 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	SEED_GET_CLASS (self)->move_shape (self, delta_x, delta_y);
#line 4941 "seed.c"
}


static void seed_real_drag_control (Seed* self, Point* p, gdouble scale, gboolean snap_on, gdouble grid_size, gdouble snap_angle) {
#line 721 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_critical ("Type `%s' does not implement abstract method `seed_drag_control'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 721 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	return;
#line 4950 "seed.c"
}


void seed_drag_control (Seed* self, Point* p, gdouble scale, gboolean snap_on, gdouble grid_size, gdouble snap_angle) {
#line 721 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 721 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	SEED_GET_CLASS (self)->drag_control (self, p, scale, snap_on, grid_size, snap_angle);
#line 4959 "seed.c"
}


/**
 * Snap to the nearest grid
 */
gboolean seed_snap (Seed* self, Point* p, gdouble scale, gdouble grid_size) {
	gboolean result = FALSE;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean bx;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gboolean _tmp5_ = FALSE;
	gboolean by;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_;
	gboolean _tmp9_;
#line 726 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 726 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_val_if_fail (p != NULL, FALSE);
#line 727 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp0_ = scale;
#line 727 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp1_ = grid_size;
#line 727 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp2_ = seed_snap_x (self, p, _tmp0_, _tmp1_);
#line 727 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	bx = _tmp2_;
#line 728 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp3_ = scale;
#line 728 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp4_ = grid_size;
#line 728 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp5_ = seed_snap_y (self, p, _tmp3_, _tmp4_);
#line 728 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	by = _tmp5_;
#line 729 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp7_ = bx;
#line 729 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	if (_tmp7_) {
#line 729 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp6_ = TRUE;
#line 5005 "seed.c"
	} else {
		gboolean _tmp8_;
#line 729 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp8_ = by;
#line 729 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp6_ = _tmp8_;
#line 5012 "seed.c"
	}
#line 729 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp9_ = _tmp6_;
#line 729 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	result = _tmp9_;
#line 729 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	return result;
#line 5020 "seed.c"
}


gboolean seed_snap_x (Seed* self, Point* p, gdouble scale, gdouble grid_size) {
	gboolean result = FALSE;
	Point _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_;
	gdouble grid_x;
	Point _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_;
	gdouble _tmp10_;
#line 732 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 732 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_val_if_fail (p != NULL, FALSE);
#line 733 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp0_ = *p;
#line 733 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp1_ = _tmp0_.x;
#line 733 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp2_ = grid_size;
#line 733 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp3_ = round (_tmp1_ / _tmp2_);
#line 733 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp4_ = grid_size;
#line 733 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	grid_x = _tmp3_ * _tmp4_;
#line 734 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp5_ = *p;
#line 734 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp6_ = _tmp5_.x;
#line 734 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp7_ = grid_x;
#line 734 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp8_ = fabs (_tmp6_ - _tmp7_);
#line 734 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp9_ = scale;
#line 734 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp10_ = self->priv->grid_magnetic_range;
#line 734 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	if ((_tmp8_ * _tmp9_) <= _tmp10_) {
#line 5068 "seed.c"
		gdouble _tmp11_;
#line 735 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp11_ = grid_x;
#line 735 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		(*p).x = _tmp11_;
#line 736 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		result = TRUE;
#line 736 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		return result;
#line 5078 "seed.c"
	} else {
#line 739 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		result = FALSE;
#line 739 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		return result;
#line 5084 "seed.c"
	}
}


gboolean seed_snap_y (Seed* self, Point* p, gdouble scale, gdouble grid_size) {
	gboolean result = FALSE;
	Point _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_;
	gdouble grid_y;
	Point _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_;
	gdouble _tmp10_;
#line 743 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 743 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_val_if_fail (p != NULL, FALSE);
#line 744 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp0_ = *p;
#line 744 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp1_ = _tmp0_.y;
#line 744 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp2_ = grid_size;
#line 744 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp3_ = round (_tmp1_ / _tmp2_);
#line 744 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp4_ = grid_size;
#line 744 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	grid_y = _tmp3_ * _tmp4_;
#line 745 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp5_ = *p;
#line 745 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp6_ = _tmp5_.y;
#line 745 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp7_ = grid_y;
#line 745 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp8_ = fabs (_tmp6_ - _tmp7_);
#line 745 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp9_ = scale;
#line 745 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp10_ = self->priv->grid_magnetic_range;
#line 745 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	if ((_tmp8_ * _tmp9_) <= _tmp10_) {
#line 5133 "seed.c"
		gdouble _tmp11_;
#line 746 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		_tmp11_ = grid_y;
#line 746 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		(*p).y = _tmp11_;
#line 747 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		result = TRUE;
#line 747 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		return result;
#line 5143 "seed.c"
	} else {
#line 750 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		result = FALSE;
#line 750 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		return result;
#line 5149 "seed.c"
	}
}


/**
 * Among the points returned by points_to_snap, find one that is closest to an x grid,
 * and one that is closest to a y grid. Return the distances to the respective
 * grid via the out parameters.
 */
void seed_distance_to_grid (Seed* self, gdouble scale, gdouble grid_size, gdouble* distance_x, gdouble* distance_y) {
	gdouble _vala_distance_x = 0.0;
	gdouble _vala_distance_y = 0.0;
	gint _tmp0_ = 0;
	Point* _tmp1_ = NULL;
	Point* ps;
	gint ps_length1;
	gint _ps_size_;
	Point* _tmp2_;
	gint _tmp2__length1;
#line 759 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 761 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_vala_distance_x = (gdouble) 999999;
#line 762 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_vala_distance_y = (gdouble) 999999;
#line 763 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp1_ = seed_points_to_snap (self, &_tmp0_);
#line 763 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	ps = _tmp1_;
#line 763 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	ps_length1 = _tmp0_;
#line 763 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_ps_size_ = ps_length1;
#line 764 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp2_ = ps;
#line 764 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp2__length1 = ps_length1;
#line 5187 "seed.c"
	{
		Point* p_collection = NULL;
		gint p_collection_length1 = 0;
		gint _p_collection_size_ = 0;
		gint p_it = 0;
#line 764 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		p_collection = _tmp2_;
#line 764 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		p_collection_length1 = _tmp2__length1;
#line 764 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		for (p_it = 0; p_it < _tmp2__length1; p_it = p_it + 1) {
#line 5199 "seed.c"
			Point p = {0};
#line 764 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
			p = p_collection[p_it];
#line 5203 "seed.c"
			{
				Point _tmp3_;
				gdouble _tmp4_;
				Point _tmp5_;
				gdouble _tmp6_;
				gdouble _tmp7_;
				gdouble _tmp8_ = 0.0;
				gdouble _tmp9_;
				gdouble delta_x;
				gdouble _tmp10_;
				gdouble _tmp11_ = 0.0;
				gdouble _tmp12_;
				gdouble _tmp13_;
				Point _tmp22_;
				gdouble _tmp23_;
				Point _tmp24_;
				gdouble _tmp25_;
				gdouble _tmp26_;
				gdouble _tmp27_ = 0.0;
				gdouble _tmp28_;
				gdouble delta_y;
				gdouble _tmp29_;
				gdouble _tmp30_ = 0.0;
				gdouble _tmp31_;
				gdouble _tmp32_;
#line 765 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp3_ = p;
#line 765 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp4_ = _tmp3_.x;
#line 765 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp5_ = p;
#line 765 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp6_ = _tmp5_.x;
#line 765 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp7_ = grid_size;
#line 765 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp8_ = round (_tmp6_ / _tmp7_);
#line 765 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp9_ = grid_size;
#line 765 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				delta_x = _tmp4_ - (_tmp8_ * _tmp9_);
#line 766 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp10_ = delta_x;
#line 766 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp11_ = fabs (_tmp10_);
#line 766 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp12_ = scale;
#line 766 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp13_ = self->priv->grid_magnetic_range;
#line 766 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				if ((_tmp11_ * _tmp12_) <= _tmp13_) {
#line 5255 "seed.c"
					gboolean _tmp14_ = FALSE;
					gdouble _tmp15_;
					gboolean _tmp20_;
#line 767 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp15_ = _vala_distance_x;
#line 767 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					if (_tmp15_ == ((gdouble) 999999)) {
#line 767 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
						_tmp14_ = TRUE;
#line 5265 "seed.c"
					} else {
						gdouble _tmp16_;
						gdouble _tmp17_ = 0.0;
						gdouble _tmp18_;
						gdouble _tmp19_ = 0.0;
#line 767 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
						_tmp16_ = delta_x;
#line 767 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
						_tmp17_ = fabs (_tmp16_);
#line 767 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
						_tmp18_ = _vala_distance_x;
#line 767 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
						_tmp19_ = fabs (_tmp18_);
#line 767 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
						_tmp14_ = _tmp17_ < _tmp19_;
#line 5281 "seed.c"
					}
#line 767 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp20_ = _tmp14_;
#line 767 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					if (_tmp20_) {
#line 5287 "seed.c"
						gdouble _tmp21_;
#line 768 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
						_tmp21_ = delta_x;
#line 768 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
						_vala_distance_x = _tmp21_;
#line 5293 "seed.c"
					}
				}
#line 771 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp22_ = p;
#line 771 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp23_ = _tmp22_.y;
#line 771 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp24_ = p;
#line 771 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp25_ = _tmp24_.y;
#line 771 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp26_ = grid_size;
#line 771 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp27_ = round (_tmp25_ / _tmp26_);
#line 771 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp28_ = grid_size;
#line 771 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				delta_y = _tmp23_ - (_tmp27_ * _tmp28_);
#line 772 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp29_ = delta_y;
#line 772 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp30_ = fabs (_tmp29_);
#line 772 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp31_ = scale;
#line 772 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				_tmp32_ = self->priv->grid_magnetic_range;
#line 772 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
				if ((_tmp30_ * _tmp31_) <= _tmp32_) {
#line 5322 "seed.c"
					gboolean _tmp33_ = FALSE;
					gdouble _tmp34_;
					gboolean _tmp39_;
#line 773 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp34_ = _vala_distance_y;
#line 773 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					if (_tmp34_ == ((gdouble) 999999)) {
#line 773 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
						_tmp33_ = TRUE;
#line 5332 "seed.c"
					} else {
						gdouble _tmp35_;
						gdouble _tmp36_ = 0.0;
						gdouble _tmp37_;
						gdouble _tmp38_ = 0.0;
#line 773 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
						_tmp35_ = delta_y;
#line 773 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
						_tmp36_ = fabs (_tmp35_);
#line 773 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
						_tmp37_ = _vala_distance_y;
#line 773 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
						_tmp38_ = fabs (_tmp37_);
#line 773 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
						_tmp33_ = _tmp36_ < _tmp38_;
#line 5348 "seed.c"
					}
#line 773 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					_tmp39_ = _tmp33_;
#line 773 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
					if (_tmp39_) {
#line 5354 "seed.c"
						gdouble _tmp40_;
#line 774 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
						_tmp40_ = delta_y;
#line 774 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
						_vala_distance_y = _tmp40_;
#line 5360 "seed.c"
					}
				}
			}
		}
	}
#line 759 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	ps = (g_free (ps), NULL);
#line 759 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	if (distance_x) {
#line 759 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		*distance_x = _vala_distance_x;
#line 5372 "seed.c"
	}
#line 759 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	if (distance_y) {
#line 759 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
		*distance_y = _vala_distance_y;
#line 5378 "seed.c"
	}
}


/**
 * When dragging the entire shape, which points should be snapped to the grids?
 */
static Point* seed_real_points_to_snap (Seed* self, int* result_length1) {
#line 783 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_critical ("Type `%s' does not implement abstract method `seed_points_to_snap'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 783 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	return NULL;
#line 5391 "seed.c"
}


Point* seed_points_to_snap (Seed* self, int* result_length1) {
#line 783 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 783 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	return SEED_GET_CLASS (self)->points_to_snap (self, result_length1);
#line 5400 "seed.c"
}


static void seed_real_draw_icon (Seed* self, cairo_t* cr, gdouble width, gdouble height) {
#line 785 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_critical ("Type `%s' does not implement abstract method `seed_draw_icon'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 785 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	return;
#line 5409 "seed.c"
}


void seed_draw_icon (Seed* self, cairo_t* cr, gdouble width, gdouble height) {
#line 785 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 785 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	SEED_GET_CLASS (self)->draw_icon (self, cr, width, height);
#line 5418 "seed.c"
}


Seed* seed_construct (GType object_type) {
	Seed * self = NULL;
#line 19 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self = (Seed*) g_object_new (object_type, NULL);
#line 19 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	return self;
#line 5428 "seed.c"
}


static void seed_class_init (SeedClass * klass) {
	gdouble _tmp0_;
#line 19 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	seed_parent_class = g_type_class_peek_parent (klass);
#line 19 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	g_type_class_add_private (klass, sizeof (SeedPrivate));
#line 19 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	SEED_CLASS (klass)->init_default_sub = seed_real_init_default_sub;
#line 19 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	SEED_CLASS (klass)->init_full_sub = seed_real_init_full_sub;
#line 19 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	SEED_CLASS (klass)->serialize_sub = seed_real_serialize_sub;
#line 19 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	SEED_CLASS (klass)->point_raw = seed_real_point_raw;
#line 19 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	SEED_CLASS (klass)->init_distance_to_parametric = seed_real_init_distance_to_parametric;
#line 19 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	SEED_CLASS (klass)->perpendicular_angle = seed_real_perpendicular_angle;
#line 19 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	SEED_CLASS (klass)->draw_direct = seed_real_draw_direct;
#line 19 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	SEED_CLASS (klass)->draw_controls = seed_real_draw_controls;
#line 19 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	SEED_CLASS (klass)->pressed_control = seed_real_pressed_control;
#line 19 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	SEED_CLASS (klass)->save_drag_context = seed_real_save_drag_context;
#line 19 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	SEED_CLASS (klass)->move_shape = seed_real_move_shape;
#line 19 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	SEED_CLASS (klass)->drag_control = seed_real_drag_control;
#line 19 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	SEED_CLASS (klass)->points_to_snap = seed_real_points_to_snap;
#line 19 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	SEED_CLASS (klass)->draw_icon = seed_real_draw_icon;
#line 19 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	G_OBJECT_CLASS (klass)->finalize = seed_finalize;
#line 21 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	_tmp0_ = DBL_EPSILON;
#line 21 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	seed_epsilon = _tmp0_;
#line 5472 "seed.c"
}


static void seed_instance_init (Seed * self) {
	Tweak _tmp0_ = {0};
	RGBA _tmp1_ = {0};
#line 19 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->priv = SEED_GET_PRIVATE (self);
#line 20 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->debug = FALSE;
#line 31 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->role = ROLE_DUAL;
#line 38 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->base_offset = 0.5;
#line 42 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->flip_even = FLIP_NONE;
#line 43 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->flip_odd = FLIP_Y;
#line 44 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	tweak_init (&_tmp0_);
#line 44 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->tweak = _tmp0_;
#line 48 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->width0 = 0.2;
#line 52 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->width1 = 0.2;
#line 56 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->num_segment = 4;
#line 60 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->level_of_detail = 10;
#line 64 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	rgba_init (&_tmp1_, 0.0, 0.0, 0.0, 1.0);
#line 64 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->color = _tmp1_;
#line 68 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->color_mix = 0.5;
#line 69 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->render_style = RENDER_STYLE_THIN;
#line 594 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->priv->control_radius = (gdouble) 5;
#line 595 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->priv->control_magnetic_range = (gdouble) 10;
#line 596 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->priv->grid_magnetic_range = (gdouble) 10;
#line 597 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->selected_control = -1;
#line 5519 "seed.c"
}


static void seed_finalize (GObject* obj) {
	Seed * self;
#line 19 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SEED, Seed);
#line 82 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->distance_to_param = (g_free (self->distance_to_param), NULL);
#line 92 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->priv->self_intersect = (g_free (self->priv->self_intersect), NULL);
#line 102 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	self->projection = (_vala_array_free (self->projection, self->projection_length1, (GDestroyNotify) projection_unref), NULL);
#line 19 "/home/jaidi/project/mutiara/tiara/src/seed.vala"
	G_OBJECT_CLASS (seed_parent_class)->finalize (obj);
#line 5535 "seed.c"
}


GType seed_get_type (void) {
	static volatile gsize seed_type_id__volatile = 0;
	if (g_once_init_enter (&seed_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SeedClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) seed_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Seed), 0, (GInstanceInitFunc) seed_instance_init, NULL };
		GType seed_type_id;
		seed_type_id = g_type_register_static (G_TYPE_OBJECT, "Seed", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&seed_type_id__volatile, seed_type_id);
	}
	return seed_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
#line 101 "/home/jaidi/project/mutiara/tiara/src/pod.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 5554 "seed.c"
		int i;
#line 101 "/home/jaidi/project/mutiara/tiara/src/pod.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 101 "/home/jaidi/project/mutiara/tiara/src/pod.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 101 "/home/jaidi/project/mutiara/tiara/src/pod.vala"
				destroy_func (((gpointer*) array)[i]);
#line 5562 "seed.c"
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
#line 101 "/home/jaidi/project/mutiara/tiara/src/pod.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 101 "/home/jaidi/project/mutiara/tiara/src/pod.vala"
	g_free (array);
#line 5574 "seed.c"
}



